/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],Z=function(q){for(var e=[],w=0,t=q.length;w<t;w++)e[w]=J[q[w]];return e};define(J[121],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function w(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=w;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(J[122],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(D){return D?D.replace(/\$\((.*?)\)/g,(v,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=w;class t{constructor(v,h,m){this.id=v,this.definition=h,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,v){const h=["codicon","codicon-"+D];return v&&h.push("codicon-modifier-"+v),h}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(I){if(I instanceof t)return["codicon","codicon-"+I.id];const y=v.exec(I.id);if(!y)return h(t.error);const[,g,d]=y,E=["codicon","codicon-"+g];return d&&E.push("codicon-modifier-"+d.substr(1)),E}D.asClassNameArray=h;function m(I){return h(I).join(" ")}D.asClassName=m;function C(I){return"."+h(I).join(".")}D.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(J[123],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function w(v,h){const m=Math.pow(10,h);return Math.round(v*m)/m}class t{constructor(h,m,C,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,m){return h.r===m.r&&h.g===m.g&&h.b===m.b&&h.a===m.a}}e.RGBA=t;class k{constructor(h,m,C,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.l=w(Math.max(Math.min(1,C),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.l===m.l&&h.a===m.a}static fromRGBA(h){const m=h.r/255,C=h.g/255,I=h.b/255,y=h.a,g=Math.max(m,C,I),d=Math.min(m,C,I);let E=0,b=0;const p=(d+g)/2,S=g-d;if(S>0){switch(b=Math.min(p<=.5?S/(2*p):S/(2-2*p),1),g){case m:E=(C-I)/S+(C<I?6:0);break;case C:E=(I-m)/S+2;break;case I:E=(m-C)/S+4;break}E*=60,E=Math.round(E)}return new k(E,b,p,y)}static _hue2rgb(h,m,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?h+(m-h)*6*C:C<1/2?m:C<2/3?h+(m-h)*(2/3-C)*6:h}static toRGBA(h){const m=h.h/360,{s:C,l:I,a:y}=h;let g,d,E;if(C===0)g=d=E=I;else{const b=I<.5?I*(1+C):I+C-I*C,p=2*I-b;g=k._hue2rgb(p,b,m+1/3),d=k._hue2rgb(p,b,m),E=k._hue2rgb(p,b,m-1/3)}return new t(Math.round(g*255),Math.round(d*255),Math.round(E*255),y)}}e.HSLA=k;class R{constructor(h,m,C,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.v=w(Math.max(Math.min(1,C),0),3),this.a=w(Math.max(Math.min(1,I),0),3)}static equals(h,m){return h.h===m.h&&h.s===m.s&&h.v===m.v&&h.a===m.a}static fromRGBA(h){const m=h.r/255,C=h.g/255,I=h.b/255,y=Math.max(m,C,I),g=Math.min(m,C,I),d=y-g,E=y===0?0:d/y;let b;return d===0?b=0:y===m?b=((C-I)/d%6+6)%6:y===C?b=(I-m)/d+2:b=(m-C)/d+4,new R(Math.round(b*60),E,y,h.a)}static toRGBA(h){const{h:m,s:C,v:I,a:y}=h,g=I*C,d=g*(1-Math.abs(m/60%2-1)),E=I-g;let[b,p,S]=[0,0,0];return m<60?(b=g,p=d):m<120?(b=d,p=g):m<180?(p=g,S=d):m<240?(p=d,S=g):m<300?(b=d,S=g):m<=360&&(b=g,S=d),b=Math.round((b+E)*255),p=Math.round((p+E)*255),S=Math.round((S+E)*255),new t(b,p,S,y)}}e.HSVA=R;class D{constructor(h){if(h)if(h instanceof t)this.rgba=h;else if(h instanceof k)this._hsla=h,this.rgba=k.toRGBA(h);else if(h instanceof R)this._hsva=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(h){return!!h&&t.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),m=D._relativeLuminanceForComponent(this.rgba.g),C=D._relativeLuminanceForComponent(this.rgba.b),I=.2126*h+.7152*m+.0722*C;return w(I,4)}static _relativeLuminanceForComponent(h){const m=h/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(h){const m=this.getRelativeLuminance(),C=h.getRelativeLuminance();return m>C?(m+.05)/(C+.05):(C+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const m=this.getRelativeLuminance(),C=h.getRelativeLuminance();return m>C}isDarkerThan(h){const m=this.getRelativeLuminance(),C=h.getRelativeLuminance();return m<C}lighten(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:m,g:C,b:I,a:y}=this.rgba;return new D(new t(m,C,I,y*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const m=h.rgba,C=this.rgba.a,I=m.a,y=C+I*(1-C);if(y<1e-6)return D.transparent;const g=this.rgba.r*C/y+m.r*I*(1-C)/y,d=this.rgba.g*C/y+m.g*I*(1-C)/y,E=this.rgba.b*C/y+m.b*I*(1-C)/y;return new D(new t(g,d,E,y))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:m,g:C,b:I,a:y}=this.rgba;return new D(new t(h.rgba.r-y*(h.rgba.r-m),h.rgba.g-y*(h.rgba.g-C),h.rgba.b-y*(h.rgba.b-I),1))}flatten(...h){const m=h.reduceRight((C,I)=>D._flatten(I,C));return D._flatten(this,m)}static _flatten(h,m){const C=1-h.rgba.a;return new D(new t(C*m.rgba.r+h.rgba.a*h.rgba.r,C*m.rgba.g+h.rgba.a*h.rgba.g,C*m.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,m,C){if(h.isLighterThan(m))return h;C=C||.5;const I=h.getRelativeLuminance(),y=m.getRelativeLuminance();return C=C*(y-I)/y,h.lighten(C)}static getDarkerColor(h,m,C){if(h.isDarkerThan(m))return h;C=C||.5;const I=h.getRelativeLuminance(),y=m.getRelativeLuminance();return C=C*(I-y)/I,h.darken(C)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(v){let h;(function(m){let C;(function(I){function y(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:v.Format.CSS.formatRGBA(r)}I.formatRGB=y;function g(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}I.formatRGBA=g;function d(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(r)}I.formatHSL=d;function E(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}I.formatHSLA=E;function b(r){const s=r.toString(16);return s.length!==2?"0"+s:s}function p(r){return`#${b(r.rgba.r)}${b(r.rgba.g)}${b(r.rgba.b)}`}I.formatHex=p;function S(r,s=!1){return s&&r.rgba.a===1?v.Format.CSS.formatHex(r):`#${b(r.rgba.r)}${b(r.rgba.g)}${b(r.rgba.b)}${b(Math.round(r.rgba.a*255))}`}I.formatHexA=S;function f(r){return r.isOpaque()?v.Format.CSS.formatHex(r):v.Format.CSS.formatRGBA(r)}I.format=f;function u(r){const s=r.length;if(s===0||r.charCodeAt(0)!==35)return null;if(s===7){const i=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),n=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),o=16*c(r.charCodeAt(5))+c(r.charCodeAt(6));return new v(new t(i,n,o,1))}if(s===9){const i=16*c(r.charCodeAt(1))+c(r.charCodeAt(2)),n=16*c(r.charCodeAt(3))+c(r.charCodeAt(4)),o=16*c(r.charCodeAt(5))+c(r.charCodeAt(6)),a=16*c(r.charCodeAt(7))+c(r.charCodeAt(8));return new v(new t(i,n,o,a/255))}if(s===4){const i=c(r.charCodeAt(1)),n=c(r.charCodeAt(2)),o=c(r.charCodeAt(3));return new v(new t(16*i+i,16*n+n,16*o+o))}if(s===5){const i=c(r.charCodeAt(1)),n=c(r.charCodeAt(2)),o=c(r.charCodeAt(3)),a=c(r.charCodeAt(4));return new v(new t(16*i+i,16*n+n,16*o+o,(16*a+a)/255))}return null}I.parseHex=u;function c(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=m.CSS||(m.CSS={}))})(h=v.Format||(v.Format={}))}(D=e.Color||(e.Color={}))}),define(J[52],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(D){return(v,h,m)=>{let C=null,I=null;if(typeof m.value=="function"?(C="value",I=m.value):typeof m.get=="function"&&(C="get",I=m.get),!I)throw new Error("not supported");m[C]=D(I,h)}}e.createDecorator=w;function t(D,v,h){let m=null,C=null;if(typeof h.value=="function"?(m="value",C=h.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(m="get",C=h.get),!C)throw new Error("not supported");const I=`$memoize$${v}`;h[m]=function(...y){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,y)}),this[I]}}e.memoize=t;function k(D,v,h){return w((m,C)=>{const I=`$debounce$${C}`,y=`$debounce$result$${C}`;return function(...g){this[y]||(this[y]=h?h():void 0),clearTimeout(this[I]),v&&(this[y]=v(this[y],...g),g=[this[y]]),this[I]=setTimeout(()=>{m.apply(this,g),this[y]=h?h():void 0},D)}})}e.debounce=k;function R(D,v,h){return w((m,C)=>{const I=`$throttle$timer$${C}`,y=`$throttle$result$${C}`,g=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...E){if(this[y]||(this[y]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),v&&(this[y]=v(this[y],...E)),this[d])return;const b=this[g]+D;b<=Date.now()?(this[g]=Date.now(),m.apply(this,[this[y]]),this[y]=h?h():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),m.apply(this,[this[y]]),this[y]=h?h():void 0},b-Date.now()))}})}e.throttle=R}),define(J[18],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?f.isErrorNoTelemetry(r)?new f(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(s=>{s(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=w,e.errorHandler=new w;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:r,message:s}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:r,message:s,stack:i,noTelemetry:f.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const v="Canceled";function h(c){return c instanceof m?!0:c instanceof Error&&c.name===v&&c.message===v}e.isCancellationError=h;class m extends Error{constructor(){super(v);this.name=this.message}}e.CancellationError=m;function C(){const c=new Error(v);return c.name=c.message,c}e.canceled=C;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function y(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=y;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(c){const r=new Error(`${c} has been disposed`);return r.name="DISPOSED",r}e.disposed=d;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=E;class b extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=b;class p extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;class f extends Error{constructor(r){super(r);this.name="CodeExpectedError"}static fromError(r){if(r instanceof f)return r;const s=new f;return s.message=r.message,s.stack=r.stack,s}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class u extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(J[24],Z([0,1,18]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,te=0){return j[j.length-(1+te)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,te,ie=(ce,fe)=>ce===fe){if(j===te)return!0;if(!j||!te||j.length!==te.length)return!1;for(let ce=0,fe=j.length;ce<fe;ce++)if(!ie(j[ce],te[ce]))return!1;return!0}e.equals=R;function D(j,te){const ie=j.length-1;te<ie&&(j[te]=j[ie]),j.pop()}e.removeFastWithoutKeepingOrder=D;function v(j,te,ie){return h(j.length,ce=>ie(j[ce],te))}e.binarySearch=v;function h(j,te){let ie=0,ce=j-1;for(;ie<=ce;){const fe=(ie+ce)/2|0,ke=te(fe);if(ke<0)ie=fe+1;else if(ke>0)ce=fe-1;else return fe}return-(ie+1)}e.binarySearch2=h;function m(j,te){let ie=0,ce=j.length;if(ce===0)return 0;for(;ie<ce;){const fe=Math.floor((ie+ce)/2);te(j[fe])?ce=fe:ie=fe+1}return ie}e.findFirstInSorted=m;function C(j,te,ie){if(j=j|0,j>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],fe=[],ke=[],Le=[];for(const Me of te){const Ae=ie(Me,ce);Ae<0?fe.push(Me):Ae>0?ke.push(Me):Le.push(Me)}return j<fe.length?C(j,fe,ie):j<fe.length+Le.length?Le[0]:C(j-(fe.length+Le.length),ke,ie)}e.quickSelect=C;function I(j,te){const ie=[];let ce;for(const fe of j.slice(0).sort(te))!ce||te(ce[0],fe)!==0?(ce=[fe],ie.push(ce)):ce.push(fe);return ie}e.groupBy=I;function y(j,te,ie){const ce=[];function fe(Me,Ae,Ve){if(Ae===0&&Ve.length===0)return;const ge=ce[ce.length-1];ge&&ge.start+ge.deleteCount===Me?(ge.deleteCount+=Ae,ge.toInsert.push(...Ve)):ce.push({start:Me,deleteCount:Ae,toInsert:Ve})}let ke=0,Le=0;for(;;){if(ke===j.length){fe(ke,0,te.slice(Le));break}if(Le===te.length){fe(ke,j.length-ke,[]);break}const Me=j[ke],Ae=te[Le],Ve=ie(Me,Ae);Ve===0?(ke+=1,Le+=1):Ve<0?(fe(ke,1,[]),ke+=1):Ve>0&&(fe(ke,0,[Ae]),Le+=1)}return ce}e.sortedDiff=y;function g(j,te,ie){const ce=y(j,te,ie),fe=[],ke=[];for(const Le of ce)fe.push(...j.slice(Le.start,Le.start+Le.deleteCount)),ke.push(...Le.toInsert);return{removed:fe,added:ke}}e.delta=g;function d(j,te,ie){if(ie===0)return[];const ce=j.slice(0,ie).sort(te);return b(j,te,ce,ie,j.length),ce}e.top=d;function E(j,te,ie,ce,fe){return ie===0?Promise.resolve([]):new Promise((ke,Le)=>{(async()=>{const Me=j.length,Ae=j.slice(0,ie).sort(te);for(let Ve=ie,ge=Math.min(ie+ce,Me);Ve<Me;Ve=ge,ge=Math.min(ge+ce,Me)){if(Ve>ie&&await new Promise(pe=>setTimeout(pe)),fe&&fe.isCancellationRequested)throw new w.CancellationError;b(j,te,Ae,Ve,ge)}return Ae})().then(ke,Le)})}e.topAsync=E;function b(j,te,ie,ce,fe){for(const ke=ie.length;ce<fe;ce++){const Le=j[ce];if(te(Le,ie[ke-1])<0){ie.pop();const Me=m(ie,Ae=>te(Le,Ae)<0);ie.splice(Me,0,Le)}}}function p(j){return j.filter(te=>!!te)}e.coalesce=p;function S(j){let te=0;for(let ie=0;ie<j.length;ie++)j[ie]&&(j[te]=j[ie],te+=1);j.length=te}e.coalesceInPlace=S;function f(j,te,ie){j.splice(ie,0,j.splice(te,1)[0])}e.move=f;function u(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=u;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function r(j,te=ie=>ie){const ie=new Set;return j.filter(ce=>{const fe=te(ce);return ie.has(fe)?!1:(ie.add(fe),!0)})}e.distinct=r;function s(j){const te=new Set;return ie=>{const ce=j(ie);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=s;function i(j,te){const ie=n(j,te);if(ie!==-1)return j[ie]}e.findLast=i;function n(j,te){for(let ie=j.length-1;ie>=0;ie--){const ce=j[ie];if(te(ce))return ie}return-1}e.lastIndex=n;function o(j,te){return j.length>0?j[0]:te}e.firstOrDefault=o;function a(j,te){return j.length>0?j[j.length-1]:te}e.lastOrDefault=a;function l(j,te,ie=(ce,fe)=>ce===fe){let ce=0;for(let fe=0,ke=Math.min(j.length,te.length);fe<ke&&ie(j[fe],te[fe]);fe++)ce++;return ce}e.commonPrefixLength=l;function P(j){return[].concat(...j)}e.flatten=P;function M(j,te){let ie=typeof te=="number"?j:0;typeof te=="number"?ie=j:(ie=0,te=j);const ce=[];if(ie<=te)for(let fe=ie;fe<te;fe++)ce.push(fe);else for(let fe=ie;fe>te;fe--)ce.push(fe);return ce}e.range=M;function T(j,te,ie){return j.reduce((ce,fe)=>(ce[te(fe)]=ie?ie(fe):fe,ce),Object.create(null))}e.index=T;function W(j,te){return j.push(te),()=>U(j,te)}e.insert=W;function U(j,te){const ie=j.indexOf(te);if(ie>-1)return j.splice(ie,1),te}e.remove=U;function x(j,te,ie){const ce=j.slice(0,te),fe=j.slice(te);return ce.concat(ie,fe)}e.arrayInsert=x;function re(j,te){let ie;if(typeof te=="number"){let ce=te;ie=()=>{const fe=Math.sin(ce++)*179426549;return fe-Math.floor(fe)}}else ie=Math.random;for(let ce=j.length-1;ce>0;ce-=1){const fe=Math.floor(ie()*(ce+1)),ke=j[ce];j[ce]=j[fe],j[fe]=ke}}e.shuffle=re;function le(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.unshift(te))}e.pushToStart=le;function ue(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.push(te))}e.pushToEnd=ue;function se(j,te){for(const ie of te)j.push(ie)}e.pushMany=se;function de(j,te){return Array.isArray(j)?j.map(te):te(j)}e.mapArrayOrNot=de;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function _(j,te){for(const ie of j){const ce=te(ie);if(ce!==void 0)return ce}}e.mapFind=_;function A(j,te,ie){const ce=z(j,te),fe=j.length,ke=ie.length;j.length=fe+ke;for(let Le=fe-1;Le>=ce;Le--)j[Le+ke]=j[Le];for(let Le=0;Le<ke;Le++)j[Le+ce]=ie[Le]}e.insertInto=A;function F(j,te,ie,ce){const fe=z(j,te),ke=j.splice(fe,ie);return A(j,fe,ce),ke}e.splice=F;function z(j,te){return te<0?Math.max(te+j.length,0):Math.min(te,j.length)}var ee;(function(j){function te(fe){return fe<0}j.isLessThan=te;function ie(fe){return fe>0}j.isGreaterThan=ie;function ce(fe){return fe===0}j.isNeitherLessOrGreaterThan=ce,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function B(j,te){return(ie,ce)=>te(j(ie),j(ce))}e.compareBy=B;function H(...j){return(te,ie)=>{for(const ce of j){const fe=ce(te,ie);if(!ee.isNeitherLessOrGreaterThan(fe))return fe}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const L=(j,te)=>j-te;e.numberComparator=L;function O(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const fe=j[ce];te(fe,ie)>0&&(ie=fe)}return ie}e.findMaxBy=O;function N(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const fe=j[ce];te(fe,ie)>=0&&(ie=fe)}return ie}e.findLastMaxBy=N;function V(j,te){return O(j,(ie,ce)=>-te(ie,ce))}e.findMinBy=V;class Q{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const ce=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,ce}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const ce=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=Q;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(ce=>te(ce)?ie(ce):!0))}map(te){return new ne(ie=>this.iterate(ce=>ie(te(ce))))}some(te){let ie=!1;return this.iterate(ce=>(ie=te(ce),!ie)),ie}findFirst(te){let ie;return this.iterate(ce=>te(ce)?(ie=ce,!1):!0),ie}findLast(te){let ie;return this.iterate(ce=>(te(ce)&&(ie=ce),!0)),ie}findLastMaxBy(te){let ie,ce=!0;return this.iterate(fe=>((ce||ee.isGreaterThan(te(fe,ie)))&&(ce=!1,ie=fe),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(J[49],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=w}),define(J[57],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(t){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*v(s){yield s}t.single=v;function h(s){return s||R}t.from=h;function m(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=m;function C(s){return s[Symbol.iterator]().next().value}t.first=C;function I(s,i){for(const n of s)if(i(n))return!0;return!1}t.some=I;function y(s,i){for(const n of s)if(i(n))return n}t.find=y;function*g(s,i){for(const n of s)i(n)&&(yield n)}t.filter=g;function*d(s,i){let n=0;for(const o of s)yield i(o,n++)}t.map=d;function*E(...s){for(const i of s)for(const n of i)yield n}t.concat=E;function*b(s){for(const i of s)for(const n of i)yield n}t.concatNested=b;function p(s,i,n){let o=n;for(const a of s)o=i(o,a);return o}t.reduce=p;function S(s,i){let n=0;for(const o of s)i(o,n++)}t.forEach=S;function*f(s,i,n=s.length){for(i<0&&(i+=s.length),n<0?n+=s.length:n>s.length&&(n=s.length);i<n;i++)yield s[i]}t.slice=f;function u(s,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,s];const o=s[Symbol.iterator]();for(let a=0;a<i;a++){const l=o.next();if(l.done)return[n,t.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=u;function c(s){return u(s)[0]}t.collect=c;function r(s,i,n=(o,a)=>o===a){const o=s[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const l=o.next(),P=a.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!n(l.value,P.value))return!1}}t.equals=r})(w=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(r){r.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(r,s=!1){let i=0;const n=r.length;let o="",a=0,l=16,P=0;function M(ue){let se=0,de=0;for(;se<ue;){const K=r.charCodeAt(i);if(K>=48&&K<=57)de=de*16+K-48;else if(K>=65&&K<=70)de=de*16+K-65+10;else if(K>=97&&K<=102)de=de*16+K-97+10;else break;i++,se++}return se<ue&&(de=-1),de}function T(ue){i=ue,o="",a=0,l=16,P=0}function W(){const ue=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&m(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&m(r.charCodeAt(i)))for(i++;i<r.length&&m(r.charCodeAt(i));)i++;else return P=3,r.substring(ue,i);let se=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&m(r.charCodeAt(i))){for(i++;i<r.length&&m(r.charCodeAt(i));)i++;se=i}else P=3;return r.substring(ue,se)}function U(){let ue="",se=i;for(;;){if(i>=n){ue+=r.substring(se,i),P=2;break}const de=r.charCodeAt(i);if(de===34){ue+=r.substring(se,i),i++;break}if(de===92){if(ue+=r.substring(se,i),i++,i>=n){P=2;break}switch(r.charCodeAt(i++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const $=M(4);$>=0?ue+=String.fromCharCode($):P=4;break}default:P=5}se=i;continue}if(de>=0&&de<=31)if(h(de)){ue+=r.substring(se,i),P=2;break}else P=6;i++}return ue}function x(){if(o="",P=0,a=i,i>=n)return a=n,l=17;let ue=r.charCodeAt(i);if(v(ue)){do i++,o+=String.fromCharCode(ue),ue=r.charCodeAt(i);while(v(ue));return l=15}if(h(ue))return i++,o+=String.fromCharCode(ue),ue===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),l=14;switch(ue){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,o=U(),l=10;case 47:{const se=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(r.charCodeAt(i));)i++;return o=r.substring(se,i),l=12}if(r.charCodeAt(i+1)===42){i+=2;const de=n-1;let K=!1;for(;i<de;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),o=r.substring(se,i),l=13}return o+=String.fromCharCode(ue),i++,l=16}case 45:if(o+=String.fromCharCode(ue),i++,i===n||!m(r.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),l=11;default:for(;i<n&&re(ue);)i++,ue=r.charCodeAt(i);if(a!==i){switch(o=r.substring(a,i),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(ue),i++,l=16}}function re(ue){if(v(ue)||h(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ue;do ue=x();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>i,scan:s?le:x,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=D;function v(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function h(r){return r===10||r===13||r===8232||r===8233}function m(r){return r>=48&&r<=57}var C;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(C||(C={}));function I(r,s){const i=[],n=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,T,W,U){a.value=M,a.offset=T,a.length=W,a.type=U,a.colonOffset=void 0,o=a}try{f(r,{onObjectBegin:(M,T)=>{if(s<=M)throw n;o=void 0,l=s>M,i.push("")},onObjectProperty:(M,T,W)=>{if(s<T||(P(M,T,W,"property"),i[i.length-1]=M,s<=T+W))throw n},onObjectEnd:(M,T)=>{if(s<=M)throw n;o=void 0,i.pop()},onArrayBegin:(M,T)=>{if(s<=M)throw n;o=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(s<=M)throw n;o=void 0,i.pop()},onLiteralValue:(M,T,W)=>{if(s<T||(P(M,T,W,c(M)),s<=T+W))throw n},onSeparator:(M,T,W)=>{if(s<=T)throw n;if(M===":"&&o&&o.type==="property")o.colonOffset=T,l=!1,o=void 0;else if(M===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(l=!0,i[i.length-1]=""),o=void 0}}})}catch(M){if(M!==n)throw M}return{path:i,previousNode:o,isAtPropertyKey:l,matches:M=>{let T=0;for(let W=0;T<M.length&&W<i.length;W++)if(M[T]===i[W]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=I;function y(r,s=[],i=R.DEFAULT){let n=null,o=[];const a=[];function l(M){Array.isArray(o)?o.push(M):n!==null&&(o[n]=M)}return f(r,{onObjectBegin:()=>{const M={};l(M),a.push(o),o=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const M=[];l(M),a.push(o),o=M,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(M,T,W)=>{s.push({error:M,offset:T,length:W})}},i),o[0]}e.parse=y;function g(r,s=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){n.type==="property"&&(n.length=M-n.offset,n=n.parent)}function a(M){return n.children.push(M),M}f(r,{onObjectBegin:M=>{n=a({type:"object",offset:M,length:-1,parent:n,children:[]})},onObjectProperty:(M,T,W)=>{n=a({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:M,offset:T,length:W,parent:n})},onObjectEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onArrayBegin:(M,T)=>{n=a({type:"array",offset:M,length:-1,parent:n,children:[]})},onArrayEnd:(M,T)=>{n.length=M+T-n.offset,n=n.parent,o(M+T)},onLiteralValue:(M,T,W)=>{a({type:c(M),offset:T,length:W,parent:n,value:M}),o(T+W)},onSeparator:(M,T,W)=>{n.type==="property"&&(M===":"?n.colonOffset=T:M===","&&o(T))},onError:(M,T,W)=>{s.push({error:M,offset:T,length:W})}},i);const P=n.children[0];return P&&delete P.parent,P}e.parseTree=g;function d(r,s){if(!r)return;let i=r;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function E(r){if(!r.parent||!r.parent.children)return[];const s=E(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.getNodePath=E;function b(r){switch(r.type){case"array":return r.children.map(b);case"object":{const s=Object.create(null);for(const i of r.children){const n=i.children[1];n&&(s[i.children[0].value]=b(n))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=b;function p(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.contains=p;function S(r,s,i=!1){if(p(r,s,i)){const n=r.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=s;o++){const a=S(n[o],s,i);if(a)return a}return r}}e.findNodeAtOffset=S;function f(r,s,i=R.DEFAULT){const n=D(r,!1);function o(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(B){return B?H=>B(H,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=o(s.onObjectBegin),P=a(s.onObjectProperty),M=o(s.onObjectEnd),T=o(s.onArrayBegin),W=o(s.onArrayEnd),U=a(s.onLiteralValue),x=a(s.onSeparator),re=o(s.onComment),le=a(s.onError),ue=i&&i.disallowComments,se=i&&i.allowTrailingComma;function de(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ue||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(B){case 12:case 13:ue?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return B}}}function K(B,H=[],L=[]){if(le(B),H.length+L.length>0){let O=n.getToken();for(;O!==17;){if(H.indexOf(O)!==-1){de();break}else if(L.indexOf(O)!==-1)break;O=de()}}}function $(B){const H=n.getTokenValue();return B?U(H):P(H),de(),!0}function _(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(K(2),B=0)}catch{K(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return de(),!0}function A(){return n.getToken()!==10?(K(3,[],[2,5]),!1):($(!1),n.getToken()===6?(x(":"),de(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function F(){l(),de();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||K(4,[],[]),x(","),de(),n.getToken()===2&&se)break}else B&&K(6,[],[]);A()||K(4,[],[2,5]),B=!0}return M(),n.getToken()!==2?K(7,[2],[]):de(),!0}function z(){T(),de();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||K(4,[],[]),x(","),de(),n.getToken()===4&&se)break}else B&&K(6,[],[]);ee()||K(4,[],[4,5]),B=!0}return W(),n.getToken()!==4?K(8,[4],[]):de(),!0}function ee(){switch(n.getToken()){case 3:return z();case 1:return F();case 10:return $(!0);default:return _()}}return de(),n.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=f;function u(r,s){const i=D(r),n=[];let o,a=0,l;do switch(l=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==l&&n.push(r.substring(a,l)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[124],Z([0,1,43]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,C,I){let y,g,d,E,b;if(C){for(E=C.offset,b=E+C.length,d=E;d>0&&!h(m,d-1);)d--;let l=b;for(;l<m.length&&!h(m,l);)l++;g=m.substring(d,l),y=D(g,I)}else g=m,y=0,d=0,E=0,b=m.length;const p=v(I,m);let S=!1,f=0,u;I.insertSpaces?u=R(" ",I.tabSize||4):u="	";const c=(0,w.createScanner)(g,!1);let r=!1;function s(){return p+R(u,y+f)}function i(){let l=c.scan();for(S=!1;l===15||l===14;)S=S||l===14,l=c.scan();return r=l===16||c.getTokenError()!==0,l}const n=[];function o(l,P,M){!r&&P<b&&M>E&&m.substring(P,M)!==l&&n.push({offset:P,length:M-P,content:l})}let a=i();if(a!==17){const l=c.getTokenOffset()+d,P=R(u,y);o(P,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,P=i(),M="";for(;!S&&(P===12||P===13);){const W=c.getTokenOffset()+d;o(" ",l,W),l=c.getTokenOffset()+c.getTokenLength()+d,M=P===12?s():"",P=i()}if(P===2)a!==1&&(f--,M=s());else if(P===4)a!==3&&(f--,M=s());else{switch(a){case 3:case 1:f++,M=s();break;case 5:case 12:M=s();break;case 13:S?M=s():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(r=!0);break;case 16:r=!0;break}S&&(P===12||P===13)&&(M=s())}const T=c.getTokenOffset()+d;o(M,l,T),a=P}return n}e.format=t;function k(m,C){const I=JSON.stringify(m,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?I.replace(/\r\n|\r|\n/g,C.eol):I}e.toFormattedString=k;function R(m,C){let I="";for(let y=0;y<C;y++)I+=m;return I}function D(m,C){let I=0,y=0;const g=C.tabSize||4;for(;I<m.length;){const d=m.charAt(I);if(d===" ")y++;else if(d==="	")y+=g;else break;I++}return Math.floor(y/g)}function v(m,C){for(let I=0;I<C.length;I++){const y=C.charAt(I);if(y==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=v;function h(m,C){return`\r
`.indexOf(m.charAt(C))!==-1}e.isEOL=h}),define(J[125],Z([0,1,43,124]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,C,I){return R(m,C,void 0,I)}e.removeProperty=k;function R(m,C,I,y,g){const d=C.slice(),E=[],b=(0,w.parseTree)(m,E);let p,S;for(;d.length>0&&(S=d.pop(),p=(0,w.findNodeAtLocation)(b,d),p===void 0&&I!==void 0);)typeof S=="string"?I={[S]:I}:I=[I];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const f=(0,w.findNodeAtLocation)(p,[S]);if(f!==void 0)if(I===void 0){if(!f.parent)throw new Error("Malformed AST");const u=p.children.indexOf(f.parent);let c,r=f.parent.offset+f.parent.length;if(u>0){const s=p.children[u-1];c=s.offset+s.length}else c=p.offset+1,p.children.length>1&&(r=p.children[1].offset);return D(m,{offset:c,length:r-c,content:""},y)}else return D(m,{offset:f.offset,length:f.length,content:JSON.stringify(I)},y);else{if(I===void 0)return[];const u=`${JSON.stringify(S)}: ${JSON.stringify(I)}`,c=g?g(p.children.map(s=>s.children[0].value)):p.children.length;let r;if(c>0){const s=p.children[c-1];r={offset:s.offset+s.length,length:0,content:","+u}}else p.children.length===0?r={offset:p.offset+1,length:0,content:u}:r={offset:p.offset+1,length:0,content:u+","};return D(m,r,y)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(I!==void 0){const f=`${JSON.stringify(I)}`;let u;if(p.children.length===0||S===0)u={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const c=S===-1||S>p.children.length?p.children.length:S,r=p.children[c-1];u={offset:r.offset+r.length,length:0,content:","+f}}return D(m,u,y)}else{const f=S,u=p.children[f];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const r=p.children[f-1],s=r.offset+r.length,i=p.offset+p.length;c={offset:s,length:i-2-s,content:""}}else c={offset:u.offset,length:p.children[f+1].offset-u.offset,content:""};return D(m,c,y)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},y)}}e.setProperty=R;function D(m,C,I){let y=v(m,C),g=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;g>0&&!(0,t.isEOL)(y,g-1);)g--;for(;d<y.length&&!(0,t.isEOL)(y,d);)d++}const E=(0,t.format)(y,{offset:g,length:d-g},I);for(let p=E.length-1;p>=0;p--){const S=E[p];y=v(y,S),g=Math.min(g,S.offset),d=Math.max(d,S.offset+S.length),d+=S.content.length-S.length}const b=m.length-(y.length-d)-g;return[{offset:g,length:b,content:y.substring(g,d)}]}e.withFormatting=D;function v(m,C){return m.substring(0,C.offset)+C.content+m.substring(C.offset+C.length)}e.applyEdit=v;function h(m,C){const I=C.slice(0).sort((g,d)=>{const E=g.offset-d.offset;return E===0?g.length-d.length:E});let y=m.length;for(let g=I.length-1;g>=0;g--){const d=I[g];if(d.offset+d.length<=y)m=v(m,d);else throw new Error("Overlapping edit");y=d.offset}return m}e.applyEdits=h}),define(J[126],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new w(()=>k(this.getValue()))}}e.Lazy=w}),define(J[2],Z([0,1,49,57]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(a){R=a}if(e.setDisposableTracker=D,k){const a="__is_disposable_tracked__";D(new class{trackDisposable(l){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[a]||console.log(P)},3e3)}setParent(l,P){if(l&&l!==f.None)try{l[a]=!0}catch{}}markAsDisposed(l){if(l&&l!==f.None)try{l[a]=!0}catch{}}markAsSingleton(l){}})}function v(a){return R?.trackDisposable(a),a}function h(a){R?.markAsDisposed(a)}function m(a,l){R?.setParent(a,l)}function C(a,l){if(!!R)for(const P of a)R.setParent(P,l)}function I(a){return R?.markAsSingleton(a),a}e.markAsSingleton=I;class y extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=y;function g(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=g;function d(a){if(t.Iterable.is(a)){const l=[];for(const P of a)if(P)try{P.dispose()}catch(M){l.push(M)}if(l.length===1)throw l[0];if(l.length>1)throw new y(l);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function E(a){for(const l of a)g(l)&&l.dispose();return[]}e.disposeIfDisposable=E;function b(...a){const l=p(()=>d(a));return C(a,l),l}e.combinedDisposable=b;function p(a){const l=v({dispose:(0,w.once)(()=>{h(l),a()})});return l}e.toDisposable=p;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return m(l,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new S,v(this),m(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&m(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&m(l,null),l}}e.MutableDisposable=u;class c{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(l){let P=l;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,h(this))},this}}e.SafeDisposable=r;class s{constructor(){this.references=new Map}acquire(l,...P){let M=this.references.get(l);M||(M={counter:0,object:this.createReferencedObject(l,...P)},this.references.set(l,M));const{object:T}=M,W=(0,w.once)(()=>{--M.counter==0&&(this.destroyReferencedObject(l,M.object),this.references.delete(l))});return M.counter++,{object:T,dispose:W}}}e.ReferenceCollection=s;class i{constructor(l){this.referenceCollection=l}async acquire(l,...P){const M=this.referenceCollection.acquire(l,...P);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=i;class n{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=n;function o(a){const l=new S;try{a(l)}finally{l.dispose()}}e.disposeOnReturn=o}),define(J[127],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(R){this.element=R,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class t{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let R=this._first;for(;R!==w.Undefined;){const D=R.next;R.prev=w.Undefined,R.next=w.Undefined,R=D}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const v=new w(R);if(this._first===w.Undefined)this._first=v,this._last=v;else if(D){const m=this._last;this._last=v,v.prev=m,m.next=v}else{const m=this._first;this._first=v,v.next=m,m.prev=v}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(v))}}shift(){if(this._first!==w.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==w.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==w.Undefined&&R.next!==w.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===w.Undefined&&R.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):R.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):R.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==w.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(h){R.push(h,Date.now())}function v(){const h=[];for(let m=0;m<R.length;m+=2)h.push({name:R[m],startTime:R[m+1]});return h}return{mark:D,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=w(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var t in w)(typeof exports=="object"?exports:q)[t]=w[t]}}(typeof self!="undefined"?self:this,function(){return function(q){var e={};function w(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=q,w.c=e,w.d=function(t,k,R){w.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},w.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},w.t=function(t,k){if(1&k&&(t=w(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(w.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)w.d(R,D,function(v){return t[v]}.bind(null,D));return R},w.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return w.d(k,"a",k),k},w.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},w.p="",w(w.s=0)}([function(q,e,w){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],h=e.src=[],m=0,C=m++;h[C]="0|[1-9]\\d*";var I=m++;h[I]="[0-9]+";var y=m++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=m++;h[g]="("+h[C]+")\\.("+h[C]+")\\.("+h[C]+")";var d=m++;h[d]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var E=m++;h[E]="(?:"+h[C]+"|"+h[y]+")";var b=m++;h[b]="(?:"+h[I]+"|"+h[y]+")";var p=m++;h[p]="(?:-("+h[E]+"(?:\\."+h[E]+")*))";var S=m++;h[S]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var f=m++;h[f]="[0-9A-Za-z-]+";var u=m++;h[u]="(?:\\+("+h[f]+"(?:\\."+h[f]+")*))";var c=m++,r="v?"+h[g]+h[p]+"?"+h[u]+"?";h[c]="^"+r+"$";var s="[v=\\s]*"+h[d]+h[S]+"?"+h[u]+"?",i=m++;h[i]="^"+s+"$";var n=m++;h[n]="((?:<|>)?=?)";var o=m++;h[o]=h[I]+"|x|X|\\*";var a=m++;h[a]=h[C]+"|x|X|\\*";var l=m++;h[l]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[p]+")?"+h[u]+"?)?)?";var P=m++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[S]+")?"+h[u]+"?)?)?";var M=m++;h[M]="^"+h[n]+"\\s*"+h[l]+"$";var T=m++;h[T]="^"+h[n]+"\\s*"+h[P]+"$";var W=m++;h[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;h[U]="(?:~>?)";var x=m++;h[x]="(\\s*)"+h[U]+"\\s+",v[x]=new RegExp(h[x],"g");var re=m++;h[re]="^"+h[U]+h[l]+"$";var le=m++;h[le]="^"+h[U]+h[P]+"$";var ue=m++;h[ue]="(?:\\^)";var se=m++;h[se]="(\\s*)"+h[ue]+"\\s+",v[se]=new RegExp(h[se],"g");var de=m++;h[de]="^"+h[ue]+h[l]+"$";var K=m++;h[K]="^"+h[ue]+h[P]+"$";var $=m++;h[$]="^"+h[n]+"\\s*("+s+")$|^$";var _=m++;h[_]="^"+h[n]+"\\s*("+r+")$|^$";var A=m++;h[A]="(\\s*)"+h[n]+"\\s*("+s+"|"+h[l]+")",v[A]=new RegExp(h[A],"g");var F=m++;h[F]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var z=m++;h[z]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var ee=m++;h[ee]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,h[B]),v[B]||(v[B]=new RegExp(h[B]));function H(X,ae){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(ae?v[i]:v[c]).test(X))return null;try{return new L(X,ae)}catch{return null}}function L(X,ae){if(X instanceof L){if(X.loose===ae)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,ae);k("SemVer",X,ae),this.loose=ae;var he=X.trim().match(ae?v[i]:v[c]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(X,ae){var he=H(X,ae);return he?he.version:null},e.clean=function(X,ae){var he=H(X.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),N(this.major,X.major)||N(this.minor,X.minor)||N(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],ye=X.prerelease[ae];if(k("prerelease compare",ae,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return N(he,ye)}while(++ae)},L.prototype.inc=function(X,ae){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ae,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new L(X,he).inc(ae,ye).version}catch{return null}},e.diff=function(X,ae){if(j(X,ae))return null;var he=H(X),ye=H(ae);if(he.prerelease.length||ye.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=N;var O=/^[0-9]+$/;function N(X,ae){var he=O.test(X),ye=O.test(ae);return he&&ye&&(X=+X,ae=+ae),he&&!ye?-1:ye&&!he?1:X<ae?-1:X>ae?1:0}function V(X,ae,he){return new L(X,he).compare(new L(ae,he))}function Q(X,ae,he){return V(X,ae,he)>0}function ne(X,ae,he){return V(X,ae,he)<0}function j(X,ae,he){return V(X,ae,he)===0}function te(X,ae,he){return V(X,ae,he)!==0}function ie(X,ae,he){return V(X,ae,he)>=0}function ce(X,ae,he){return V(X,ae,he)<=0}function fe(X,ae,he,ye){var Ce;switch(ae){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ce=X!==he;break;case"":case"=":case"==":Ce=j(X,he,ye);break;case"!=":Ce=te(X,he,ye);break;case">":Ce=Q(X,he,ye);break;case">=":Ce=ie(X,he,ye);break;case"<":Ce=ne(X,he,ye);break;case"<=":Ce=ce(X,he,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function ke(X,ae){if(X instanceof ke){if(X.loose===ae)return X;X=X.value}if(!(this instanceof ke))return new ke(X,ae);k("comparator",X,ae),this.loose=ae,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,ae){return N(ae,X)},e.major=function(X,ae){return new L(X,ae).major},e.minor=function(X,ae){return new L(X,ae).minor},e.patch=function(X,ae){return new L(X,ae).patch},e.compare=V,e.compareLoose=function(X,ae){return V(X,ae,!0)},e.rcompare=function(X,ae,he){return V(ae,X,he)},e.sort=function(X,ae){return X.sort(function(he,ye){return e.compare(he,ye,ae)})},e.rsort=function(X,ae){return X.sort(function(he,ye){return e.rcompare(he,ye,ae)})},e.gt=Q,e.lt=ne,e.eq=j,e.neq=te,e.gte=ie,e.lte=ce,e.cmp=fe,e.Comparator=ke;var Le={};function Me(X,ae){if(X instanceof Me)return X.loose===ae?X:new Me(X.raw,ae);if(X instanceof ke)return new Me(X.value,ae);if(!(this instanceof Me))return new Me(X,ae);if(this.loose=ae,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ve(X,ae,he,ye,Ce,Te,Oe,Be,ze,_e,He,G,oe){return((ae=Ae(he)?"":Ae(ye)?">="+he+".0.0":Ae(Ce)?">="+he+"."+ye+".0":">="+ae)+" "+(Be=Ae(ze)?"":Ae(_e)?"<"+(+ze+1)+".0.0":Ae(He)?"<"+ze+"."+(+_e+1)+".0":G?"<="+ze+"."+_e+"."+He+"-"+G:"<="+Be)).trim()}function ge(X,ae){for(var he=0;he<X.length;he++)if(!X[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var ye=X[he].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function pe(X,ae,he){try{ae=new Me(ae,he)}catch{return!1}return ae.test(X)}function be(X,ae,he,ye){var Ce,Te,Oe,Be,ze;switch(X=new L(X,ye),ae=new Me(ae,ye),he){case">":Ce=Q,Te=ce,Oe=ne,Be=">",ze=">=";break;case"<":Ce=ne,Te=ie,Oe=Q,Be="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(X,ae,ye))return!1;for(var _e=0;_e<ae.set.length;++_e){var He=ae.set[_e],G=null,oe=null;if(He.forEach(function(me){me.semver===Le&&(me=new ke(">=0.0.0")),G=G||me,oe=oe||me,Ce(me.semver,G.semver,ye)?G=me:Oe(me.semver,oe.semver,ye)&&(oe=me)}),G.operator===Be||G.operator===ze||(!oe.operator||oe.operator===Be)&&Te(X,oe.semver)||oe.operator===ze&&Oe(X,oe.semver))return!1}return!0}ke.prototype.parse=function(X){var ae=this.loose?v[$]:v[_],he=X.match(ae);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),fe(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,ae){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Me(X.value,ae),pe(this.value,he,ae);if(X.operator==="")return he=new Me(this.value,ae),pe(X.semver,he,ae);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Te=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=fe(this.semver,"<",X.semver,ae)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),ze=fe(this.semver,">",X.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ce||Te&&Oe||Be||ze},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(X){var ae=this.loose;X=X.trim(),k("range",X,ae);var he=ae?v[z]:v[F];X=X.replace(he,Ve),k("hyphen replace",X),X=X.replace(v[A],"$1$2$3"),k("comparator trim",X,v[A]),X=(X=(X=X.replace(v[x],"$1~")).replace(v[se],"$1^")).split(/\s+/).join(" ");var ye=ae?v[$]:v[_],Ce=X.split(" ").map(function(Te){return function(Oe,Be){return k("comp",Oe),Oe=function(ze,_e){return ze.trim().split(/\s+/).map(function(He){return function(G,oe){k("caret",G,oe);var me=oe?v[K]:v[de];return G.replace(me,function(Se,we,Ie,Fe,$e){var Ke;return k("caret",G,Se,we,Ie,Fe,$e),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(Fe)?Ke=we==="0"?">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+".0 <"+(+we+1)+".0.0":$e?(k("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Fe+$e+" <"+we+"."+Ie+"."+(+Fe+1):">="+we+"."+Ie+"."+Fe+$e+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Fe+$e+" <"+(+we+1)+".0.0"):(k("no pr"),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Fe+" <"+we+"."+Ie+"."+(+Fe+1):">="+we+"."+Ie+"."+Fe+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Fe+" <"+(+we+1)+".0.0"),k("caret return",Ke),Ke})}(He,_e)}).join(" ")}(Oe,Be),k("caret",Oe),Oe=function(ze,_e){return ze.trim().split(/\s+/).map(function(He){return function(G,oe){var me=oe?v[le]:v[re];return G.replace(me,function(Se,we,Ie,Fe,$e){var Ke;return k("tilde",G,Se,we,Ie,Fe,$e),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(Fe)?Ke=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":$e?(k("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ke=">="+we+"."+Ie+"."+Fe+$e+" <"+we+"."+(+Ie+1)+".0"):Ke=">="+we+"."+Ie+"."+Fe+" <"+we+"."+(+Ie+1)+".0",k("tilde return",Ke),Ke})}(He,_e)}).join(" ")}(Oe,Be),k("tildes",Oe),Oe=function(ze,_e){return k("replaceXRanges",ze,_e),ze.split(/\s+/).map(function(He){return function(G,oe){G=G.trim();var me=oe?v[T]:v[M];return G.replace(me,function(Se,we,Ie,Fe,$e,Ke){k("xRange",G,Se,we,Ie,Fe,$e,Ke);var Qe=Ae(Ie),Ye=Qe||Ae(Fe),et=Ye||Ae($e);return we==="="&&et&&(we=""),Qe?Se=we===">"||we==="<"?"<0.0.0":"*":we&&et?(Ye&&(Fe=0),et&&($e=0),we===">"?(we=">=",Ye?(Ie=+Ie+1,Fe=0,$e=0):et&&(Fe=+Fe+1,$e=0)):we==="<="&&(we="<",Ye?Ie=+Ie+1:Fe=+Fe+1),Se=we+Ie+"."+Fe+"."+$e):Ye?Se=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":et&&(Se=">="+Ie+"."+Fe+".0 <"+Ie+"."+(+Fe+1)+".0"),k("xRange return",Se),Se})}(He,_e)}).join(" ")}(Oe,Be),k("xrange",Oe),Oe=function(ze,_e){return k("replaceStars",ze,_e),ze.trim().replace(v[ee],"")}(Oe,Be),k("stars",Oe),Oe}(Te,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(ye)})),Ce=Ce.map(function(Te){return new ke(Te,ae)})},Me.prototype.intersects=function(X,ae){if(!(X instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return X.set.some(function(Ce){return Ce.every(function(Te){return ye.intersects(Te,ae)})})})})},e.toComparators=function(X,ae){return new Me(X,ae).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var ae=0;ae<this.set.length;ae++)if(ge(this.set[ae],X))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(X,ae,he){var ye=null,Ce=null;try{var Te=new Me(ae,he)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,he)))}),ye},e.minSatisfying=function(X,ae,he){var ye=null,Ce=null;try{var Te=new Me(ae,he)}catch{return null}return X.forEach(function(Oe){Te.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,he)))}),ye},e.validRange=function(X,ae){try{return new Me(X,ae).range||"*"}catch{return null}},e.ltr=function(X,ae,he){return be(X,ae,"<",he)},e.gtr=function(X,ae,he){return be(X,ae,">",he)},e.outside=be,e.prerelease=function(X,ae){var he=H(X,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ae,he){return X=new Me(X,he),ae=new Me(ae,he),X.intersects(ae)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var ae=X.match(v[W]);return ae==null?null:H((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,w(1))},function(q,e){var w,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function v(b){if(w===setTimeout)return setTimeout(b,0);if((w===R||!w)&&setTimeout)return w=setTimeout,setTimeout(b,0);try{return w(b,0)}catch{try{return w.call(null,b,0)}catch{return w.call(this,b,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:R}catch{w=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var h,m=[],C=!1,I=-1;function y(){C&&h&&(C=!1,h.length?m=h.concat(m):I=-1,m.length&&g())}function g(){if(!C){var b=v(y);C=!0;for(var p=m.length;p;){for(h=m,m=[];++I<p;)h&&h[I].run();I=-1,p=m.length}h=null,C=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(b)}}function d(b,p){this.fun=b,this.array=p}function E(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];m.push(new d(b,p)),m.length!==1||C||v(g)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=E,k.addListener=E,k.once=E,k.off=E,k.removeListener=E,k.removeAllListeners=E,k.emit=E,k.prependListener=E,k.prependOnceListener=E,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(J[128],Z([0,1]),function(q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(v,h,m){this.level=v,this.key=h,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(v,h=2**16){this.comparator=v,this[w]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,h){return R._insert(this,v,h,this.comparator)&&(this._size+=1),this}delete(v){const h=R._delete(this,v,this.comparator);return h&&(this._size-=1),h}forEach(v,h){let m=this._header.forward[0];for(;m;)v.call(h,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",h=this._header.forward[0];for(;h;)v+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return v}static _search(v,h,m){let C=v._header;for(let I=v._level-1;I>=0;I--)for(;C.forward[I]&&m(C.forward[I].key,h)<0;)C=C.forward[I];if(C=C.forward[0],C&&m(C.key,h)===0)return C}static _insert(v,h,m,C){const I=[];let y=v._header;for(let g=v._level-1;g>=0;g--){for(;y.forward[g]&&C(y.forward[g].key,h)<0;)y=y.forward[g];I[g]=y}if(y=y.forward[0],y&&C(y.key,h)===0)return y.value=m,!1;{const g=R._randomLevel(v);if(g>v._level){for(let d=v._level;d<g;d++)I[d]=v._header;v._level=g}y=new t(g,h,m);for(let d=0;d<g;d++)y.forward[d]=I[d].forward[d],I[d].forward[d]=y;return!0}}static _randomLevel(v,h=.5){let m=1;for(;Math.random()<h&&m<v._maxLevel;)m+=1;return m}static _delete(v,h,m){const C=[];let I=v._header;for(let y=v._level-1;y>=0;y--){for(;I.forward[y]&&m(I.forward[y].key,h)<0;)I=I.forward[y];C[y]=I}if(I=I.forward[0],!I||m(I.key,h)!==0)return!1;for(let y=0;y<v._level&&C[y].forward[y]===I;y++)C[y].forward[y]=I.forward[y];for(;v._level>0&&v._header.forward[v._level-1]===k;)v._level-=1;return!0}}e.SkipList=R}),define(J[58],Z([0,1,18,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=k;function R(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=R;function D(u){const c=u;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function v(u,c){return new h(u,c)}e.newWriteableStream=v;class h{constructor(c,r){this.reducer=c,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(r=>r(c))}emitError(c){this.listeners.error.length===0?(0,w.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(r=>r(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,r){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(c,r){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(u,c){const r=[];let s;for(;(s=u.read())!==null;)r.push(s);return c(r)}e.consumeReadable=m;function C(u,c,r){const s=[];let i;for(;(i=u.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=C;function I(u,c){return new Promise((r,s)=>{const i=[];y(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?s(n):r(void 0)},onEnd:()=>{r(c?c(i):void 0)}})})}e.consumeStream=I;function y(u,c){let r=!1;return u.on("error",s=>{r||c.onError(s)}),u.on("end",()=>{r||c.onEnd()}),u.on("data",s=>{r||c.onData(s)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=y;function g(u,c){return new Promise((r,s)=>{const i=new t.DisposableStore,n=[],o=P=>{if(n.push(P),n.length>c)return i.dispose(),u.pause(),r({stream:u,buffer:n,ended:!1})},a=P=>s(P),l=()=>r({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=g;function d(u,c){const r=v(c);return r.end(u),r}e.toStream=d;function E(){const u=v(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=E;function b(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=b;function p(u,c,r){const s=v(r);return y(u,{onData:i=>s.write(c.data(i)),onError:i=>s.error(c.error?c.error(i):i),onEnd:()=>s.end()}),s}e.transform=p;function S(u,c,r){let s=!1;return{read:()=>{const i=c.read();return s?i:(s=!0,i!==null?r([u,i]):u)}}}e.prefixedReadable=S;function f(u,c,r){let s=!1;const i=v(r);return y(c,{onData:n=>s?i.write(n):(s=!0,i.write(r([u,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(u)),i.end()}}),i}e.prefixedStream=f}),define(J[17],Z([0,1,58]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,W=P.length;T<W;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M=="undefined"){M=0;for(let U=0,x=P.length;U<x;U++)M+=P[U].byteLength}const T=D.alloc(M);let W=0;for(let U=0,x=P.length;U<x;U++){const re=P[U];T.set(re,W),W+=re.byteLength}return T}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,M){C(this.buffer,P,M)}readUInt32LE(P){return I(this.buffer,P)}writeUInt32LE(P,M){y(this.buffer,P,M)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,M){d(this.buffer,P,M)}}e.VSBuffer=D;function v(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=v;function h(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=h;function m(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=m;function C(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=C;function I(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=I;function y(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=y;function g(l,P){return l[P]}e.readUInt8=g;function d(l,P,M){l[M]=P}e.writeUInt8=d;function E(l){return w.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=E;function b(l){return w.toReadable(l)}e.bufferToReadable=b;function p(l){return w.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=p;async function S(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=S;function f(l){return w.toStream(l,P=>D.concat(P))}e.bufferToStream=f;function u(l){return w.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=u;function c(l){return w.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=c;function r(l,P){return w.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=r;function s(l,P){return w.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=s;function i(l){let P=0,M=0,T=0;const W=new Uint8Array(Math.floor(l.length/4*3)),U=re=>{switch(M){case 3:W[T++]=P|re,M=0;break;case 2:W[T++]=P|re>>>2,P=re<<6,M=3;break;case 1:W[T++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<l.length;re++){const le=l.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[re]}`)}}const x=T;for(;M>0;)U(0);return D.wrap(W).slice(0,x)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},P=!0,M=!1){const T=M?o:n;let W="";const U=l.byteLength%3;let x=0;for(;x<l.byteLength-U;x+=3){const re=l[x+0],le=l[x+1],ue=l[x+2];W+=T[re>>>2],W+=T[(re<<4|le>>>4)&63],W+=T[(le<<2|ue>>>6)&63],W+=T[ue&63]}if(U===1){const re=l[x+0];W+=T[re>>>2],W+=T[re<<4&63],P&&(W+="==")}else if(U===2){const re=l[x+0],le=l[x+1];W+=T[re>>>2],W+=T[(re<<4|le>>>4)&63],W+=T[le<<2&63],P&&(W+="=")}return W}e.encodeBase64=a}),define(J[12],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(s){return typeof s=="string"}e.isString=w;function t(s){return Array.isArray(s)&&s.every(i=>w(i))}e.isStringArray=t;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function R(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}e.isTypedArray=R;function D(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=D;function v(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=v;function h(s){return s===!0||s===!1}e.isBoolean=h;function m(s){return typeof s=="undefined"}e.isUndefined=m;function C(s){return!I(s)}e.isDefined=C;function I(s){return m(s)||s===null}e.isUndefinedOrNull=I;function y(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function g(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=g;function d(...s){const i=[];for(let n=0;n<s.length;n++){const o=s[n];if(I(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=d;const E=Object.prototype.hasOwnProperty;function b(s){if(!k(s))return!1;for(const i in s)if(E.call(s,i))return!1;return!0}e.isEmptyObject=b;function p(s){return typeof s=="function"}e.isFunction=p;function S(...s){return s.length>0&&s.every(p)}e.areFunctions=S;function f(s,i){const n=Math.min(s.length,i.length);for(let o=0;o<n;o++)u(s[o],i[o])}e.validateConstraints=f;function u(s,i){if(w(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(s instanceof i)return}catch{}if(!I(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(s){return s===null?void 0:s}e.withNullAsUndefined=c;function r(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=r}),define(J[50],Z([0,1,12]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const S=Array.isArray(p)?[]:{};return Object.keys(p).forEach(f=>{p[f]&&typeof p[f]=="object"?S[f]=t(p[f]):S[f]=p[f]}),S}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const S=[p];for(;S.length>0;){const f=S.shift();Object.freeze(f);for(const u in f)if(R.call(f,u)){const c=f[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,w.isTypedArray)(c)&&S.push(c)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,S){return v(p,S,new Set)}e.cloneAndChange=D;function v(p,S,f){if((0,w.isUndefinedOrNull)(p))return p;const u=S(p);if(typeof u!="undefined")return u;if(Array.isArray(p)){const c=[];for(const r of p)c.push(v(r,S,f));return c}if((0,w.isObject)(p)){if(f.has(p))throw new Error("Cannot clone recursive data-structure");f.add(p);const c={};for(const r in p)R.call(p,r)&&(c[r]=v(p[r],S,f));return f.delete(p),c}return p}function h(p,S,f=!0){return(0,w.isObject)(p)?((0,w.isObject)(S)&&Object.keys(S).forEach(u=>{u in p?f&&((0,w.isObject)(p[u])&&(0,w.isObject)(S[u])?h(p[u],S[u],f):p[u]=S[u]):p[u]=S[u]}),p):S}e.mixin=h;function m(p,S){if(p===S)return!0;if(p==null||S===null||S===void 0||typeof p!=typeof S||typeof p!="object"||Array.isArray(p)!==Array.isArray(S))return!1;let f,u;if(Array.isArray(p)){if(p.length!==S.length)return!1;for(f=0;f<p.length;f++)if(!m(p[f],S[f]))return!1}else{const c=[];for(u in p)c.push(u);c.sort();const r=[];for(u in S)r.push(u);if(r.sort(),!m(c,r))return!1;for(f=0;f<c.length;f++)if(!m(p[c[f]],S[c[f]]))return!1}return!0}e.equals=m;function C(p){const S=new Set;return JSON.stringify(p,(f,u)=>{if((0,w.isObject)(u)||Array.isArray(u)){if(S.has(u))return"[Circular]";S.add(u)}return u})}e.safeStringify=C;function I(p,S){const f=Object.create(null);return!p||!S||Object.keys(S).forEach(c=>{const r=p[c],s=S[c];m(r,s)||(f[c]=s)}),f}e.distinct=I;function y(p,S){const f=S.toLowerCase(),u=Object.keys(p).find(c=>c.toLowerCase()===f);return u?p[u]:p[S]}e.getCaseInsensitive=y;function g(p,S){const f=Object.create(null);for(const[u,c]of Object.entries(p))S(u,c)&&(f[u]=c);return f}e.filter=g;function d(p){let S=[],f=Object.getPrototypeOf(p);for(;Object.prototype!==f;)S=S.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return S}e.getAllPropertyNames=d;function E(p){const S=[];for(const f of d(p))typeof p[f]=="function"&&S.push(f);return S}e.getAllMethodNames=E;function b(p,S){const f=c=>function(){const r=Array.prototype.slice.call(arguments,0);return S(c,r)},u={};for(const c of p)u[c]=f(c);return u}e.createProxyObject=b}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return w.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(v){for(let h=0;h<v.length;h++)v[h]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),D=[];for(let v=0;v<256;v++)D.push(v.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,m="";return m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+="-",m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m+=D[R[h++]],m}}()}),define(J[129],Z([0,1,76,29,49]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,v){if(await new Promise((C,I)=>{const y=t.createReadStream(D),g=w.createHash("sha1");y.pipe(g);const d=(0,k.once)((E,b)=>{y.removeAllListeners(),g.removeAllListeners(),E?I(E):C(b)});y.once("error",d),y.once("end",d),g.once("error",d),g.once("data",E=>d(void 0,E.toString("hex")))})!==v)throw new Error("Hash mismatch")}e.checksum=R}),define(J[130],Z([0,1,30]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const v=D.replace(/\-/g,":").toLowerCase();return!t.has(v)}function R(){const D=(0,w.networkInterfaces)();for(const v in D){const h=D[v];if(h){for(const{mac:m}of h)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(J[92],Z([0,1,77]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(v,h,m,C=1){let I=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!I)return I=!0,y(0)},m);k(v,h,C,d=>{if(!I)return I=!0,clearTimeout(g),y(d)})})}e.findFreePort=t;function k(v,h,m,C){if(h===0)return C(0);const I=new w.Socket;I.once("connect",()=>(D(I),k(v+m,h-1,m,C))),I.once("data",()=>{}),I.once("error",y=>(D(I),y.code!=="ECONNREFUSED"?k(v+m,h-1,m,C):C(v))),I.connect(v,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(v,h,m){let C=!1,I,y=1;const g=w.createServer({pauseOnConnect:!0});function d(E,b){C||(C=!0,g.removeAllListeners(),g.close(),I&&clearTimeout(I),b(E))}return new Promise(E=>{I=setTimeout(()=>{d(0,E)},m),g.on("listening",()=>{d(v,E)}),g.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&y<h?(v++,y++,g.listen(v,"127.0.0.1")):d(0,E)}),g.on("close",()=>{d(0,E)}),g.listen(v,"127.0.0.1")})}e.findFreePortFaster=R;function D(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(h){console.error(h)}}}),define(J[131],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[132],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[40],Z([0,1,15,18]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,v){const h=(m,...C)=>{this.validateEvent(D,m)&&v(m,...C)};return this.mapListenerToWrapper.set(v,h),w.ipcMain.on(D,h),this}once(D,v){return w.ipcMain.once(D,(h,...m)=>{this.validateEvent(D,h)&&v(h,...m)}),this}handle(D,v){return w.ipcMain.handle(D,(h,...m)=>this.validateEvent(D,h)?v(h,...m):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return w.ipcMain.removeHandler(D),this}removeListener(D,v){const h=this.mapListenerToWrapper.get(v);return h&&(w.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(v)),this}validateEvent(D,v){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=v.senderFrame,m=h.url;if(!m)return!0;let C="unknown";try{C=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${m}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${C}'.`),!1):h.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(J[133],Z([0,1,15,40,12,131]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(h,m,C,I,y)=>{const g=v(h,I,C);g.popup({window:(0,k.withNullAsUndefined)(w.BrowserWindow.fromWebContents(h.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{g&&h.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function v(h,m,C){const I=new w.Menu;return C.forEach(y=>{let g;y.type==="separator"?g=new w.MenuItem({type:y.type}):Array.isArray(y.submenu)?g=new w.MenuItem({submenu:v(h,m,y.submenu),label:y.label}):g=new w.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,E,b)=>h.sender.send(m,y.id,b)}),I.append(g)}),I}}),define(J[134],Z([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[135],Z([0,1,134]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,v=R*30,h=R*365;function m(I,y,g){typeof I!="number"&&(I=I.getTime());const d=Math.round((new Date().getTime()-I)/1e3);if(d<-30)return(0,w.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,w.localize)(1,null);let E;return d<t?(E=d,y?E===1?g?(0,w.localize)(2,null,E):(0,w.localize)(3,null,E):g?(0,w.localize)(4,null,E):(0,w.localize)(5,null,E):E===1?g?(0,w.localize)(6,null,E):(0,w.localize)(7,null,E):g?(0,w.localize)(8,null,E):(0,w.localize)(9,null,E)):d<k?(E=Math.floor(d/t),y?E===1?g?(0,w.localize)(10,null,E):(0,w.localize)(11,null,E):g?(0,w.localize)(12,null,E):(0,w.localize)(13,null,E):E===1?g?(0,w.localize)(14,null,E):(0,w.localize)(15,null,E):g?(0,w.localize)(16,null,E):(0,w.localize)(17,null,E)):d<R?(E=Math.floor(d/k),y?E===1?g?(0,w.localize)(18,null,E):(0,w.localize)(19,null,E):g?(0,w.localize)(20,null,E):(0,w.localize)(21,null,E):E===1?g?(0,w.localize)(22,null,E):(0,w.localize)(23,null,E):g?(0,w.localize)(24,null,E):(0,w.localize)(25,null,E)):d<D?(E=Math.floor(d/R),y?E===1?(0,w.localize)(26,null,E):(0,w.localize)(27,null,E):E===1?(0,w.localize)(28,null,E):(0,w.localize)(29,null,E)):d<v?(E=Math.floor(d/D),y?E===1?g?(0,w.localize)(30,null,E):(0,w.localize)(31,null,E):g?(0,w.localize)(32,null,E):(0,w.localize)(33,null,E):E===1?g?(0,w.localize)(34,null,E):(0,w.localize)(35,null,E):g?(0,w.localize)(36,null,E):(0,w.localize)(37,null,E)):d<h?(E=Math.floor(d/v),y?E===1?g?(0,w.localize)(38,null,E):(0,w.localize)(39,null,E):g?(0,w.localize)(40,null,E):(0,w.localize)(41,null,E):E===1?g?(0,w.localize)(42,null,E):(0,w.localize)(43,null,E):g?(0,w.localize)(44,null,E):(0,w.localize)(45,null,E)):(E=Math.floor(d/h),y?E===1?g?(0,w.localize)(46,null,E):(0,w.localize)(47,null,E):g?(0,w.localize)(48,null,E):(0,w.localize)(49,null,E):E===1?g?(0,w.localize)(50,null,E):(0,w.localize)(51,null,E):g?(0,w.localize)(52,null,E):(0,w.localize)(53,null,E))}e.fromNow=m;function C(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(J[136],Z([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[44],Z([0,1,24,12,136]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,y){return y&&(I.stack||I.stacktrace)?k.localize(0,null,v(I),D(I.stack)||D(I.stacktrace)):v(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function v(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?k.localize(1,null,I.message):I.message||k.localize(2,null)}function h(I=null,y=!1){if(!I)return k.localize(3,null);if(Array.isArray(I)){const g=w.coalesce(I),d=h(g[0],y);return g.length>1?k.localize(4,null,d,g.length):d}if(t.isString(I))return I;if(I.detail){const g=I.detail;if(g.error)return R(g.error,y);if(g.exception)return R(g.exception,y)}return I.stack?R(I,y):I.message?I.message:k.localize(5,null)}e.toErrorMessage=h;function m(I){const y=I;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=m;function C(I,y){let g;return typeof I=="string"?g=new Error(I):g=I,g.actions=y,g}e.createErrorWithActions=C}),define(J[137],Z([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(J[138],Z([0,1,137]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(J[139],Z([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(J[4],Z([0,1,139]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,v=!1,h=!1,m=!1,C=!1,I=!1,y=!1,g,d=t,E,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const S=typeof p?.versions?.electron=="string",f=S&&p?.type==="renderer";if(typeof navigator=="object"&&!f)b=navigator.userAgent,k=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,I=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=b.indexOf("Linux")>=0,m=!0,g=w.getConfiguredDefaultLocale(w.localize(0,null))||t,d=g;else if(typeof p=="object"){k=p.platform==="win32",R=p.platform==="darwin",D=p.platform==="linux",v=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,C=S,y=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t,d=t;const l=p.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];g=P.locale,d=M||t,E=P._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var u;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let r=0;R?r=1:k?r=3:D&&(r=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=v,e.isNative=h,e.isElectron=C,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=y,e.platform=r,e.userAgent=b,e.language=d;var s;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function T(){return e.language==="en"}l.isDefault=T})(s=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,W=l.length;T<W;T++){const U=l[T];if(U.id===M.data.vscodeScheduleAsyncWork){l.splice(T,1),U.callback();return}}});let P=0;return M=>{const T=++P;l.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:k?1:3;let n=!0,o=!1;function a(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[34],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const k=w.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(J[9],Z([0,1,34]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,v=46,h=47,m=92,C=58,I=63;class y extends Error{constructor(u,c,r){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${s} of type ${c}`;n+=`. Received type ${typeof r}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function g(f,u){if(typeof f!="string")throw new y(u,"string",f)}function d(f){return f===h||f===m}function E(f){return f===h}function b(f){return f>=t&&f<=R||f>=k&&f<=D}function p(f,u,c,r){let s="",i=0,n=-1,o=0,a=0;for(let l=0;l<=f.length;++l){if(l<f.length)a=f.charCodeAt(l);else{if(r(a))break;a=h}if(r(a)){if(!(n===l-1||o===1))if(o===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==v||s.charCodeAt(s.length-2)!==v){if(s.length>2){const P=s.lastIndexOf(c);P===-1?(s="",i=0):(s=s.slice(0,P),i=s.length-1-s.lastIndexOf(c)),n=l,o=0;continue}else if(s.length!==0){s="",i=0,n=l,o=0;continue}}u&&(s+=s.length>0?`${c}..`:"..",i=2)}else s.length>0?s+=`${c}${f.slice(n+1,l)}`:s=f.slice(n+1,l),i=l-n-1;n=l,o=0}else a===v&&o!==-1?++o:o=-1}return s}function S(f,u){if(u===null||typeof u!="object")throw new y("pathObject","Object",u);const c=u.dir||u.root,r=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${r}`:`${c}${f}${r}`:r}e.win32={resolve(...f){let u="",c="",r=!1;for(let s=f.length-1;s>=-1;s--){let i;if(s>=0){if(i=f[s],g(i,"path"),i.length===0)continue}else u.length===0?i=w.cwd():(i=w.env[`=${u}`]||w.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${u}\\`));const n=i.length;let o=0,a="",l=!1;const P=i.charCodeAt(0);if(n===1)d(P)&&(o=1,l=!0);else if(d(P))if(l=!0,d(i.charCodeAt(1))){let M=2,T=M;for(;M<n&&!d(i.charCodeAt(M));)M++;if(M<n&&M!==T){const W=i.slice(T,M);for(T=M;M<n&&d(i.charCodeAt(M));)M++;if(M<n&&M!==T){for(T=M;M<n&&!d(i.charCodeAt(M));)M++;(M===n||M!==T)&&(a=`\\\\${W}\\${i.slice(T,M)}`,o=M)}}}else o=1;else b(P)&&i.charCodeAt(1)===C&&(a=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(l=!0,o=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(r){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,r=l,l&&u.length>0)break}return c=p(c,!r,"\\",d),r?`${u}\\${c}`:`${u}${c}`||"."},normalize(f){g(f,"path");const u=f.length;if(u===0)return".";let c=0,r,s=!1;const i=f.charCodeAt(0);if(u===1)return E(i)?"\\":f;if(d(i))if(s=!0,d(f.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(f.charCodeAt(o));)o++;if(o<u&&o!==a){const l=f.slice(a,o);for(a=o;o<u&&d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(f.charCodeAt(o));)o++;if(o===u)return`\\\\${l}\\${f.slice(a)}\\`;o!==a&&(r=`\\\\${l}\\${f.slice(a,o)}`,c=o)}}}else c=1;else b(i)&&f.charCodeAt(1)===C&&(r=f.slice(0,2),c=2,u>2&&d(f.charCodeAt(2))&&(s=!0,c=3));let n=c<u?p(f.slice(c),!s,"\\",d):"";return n.length===0&&!s&&(n="."),n.length>0&&d(f.charCodeAt(u-1))&&(n+="\\"),r===void 0?s?`\\${n}`:n:s?`${r}\\${n}`:`${r}${n}`},isAbsolute(f){g(f,"path");const u=f.length;if(u===0)return!1;const c=f.charCodeAt(0);return d(c)||u>2&&b(c)&&f.charCodeAt(1)===C&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,c;for(let i=0;i<f.length;++i){const n=f[i];g(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let r=!0,s=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++s;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++s,i>2&&(d(c.charCodeAt(2))?++s:r=!1))}if(r){for(;s<u.length&&d(u.charCodeAt(s));)s++;s>=2&&(u=`\\${u.slice(s)}`)}return e.win32.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u)return"";const c=e.win32.resolve(f),r=e.win32.resolve(u);if(c===r||(f=c.toLowerCase(),u=r.toLowerCase(),f===u))return"";let s=0;for(;s<f.length&&f.charCodeAt(s)===m;)s++;let i=f.length;for(;i-1>s&&f.charCodeAt(i-1)===m;)i--;const n=i-s;let o=0;for(;o<u.length&&u.charCodeAt(o)===m;)o++;let a=u.length;for(;a-1>o&&u.charCodeAt(a-1)===m;)a--;const l=a-o,P=n<l?n:l;let M=-1,T=0;for(;T<P;T++){const U=f.charCodeAt(s+T);if(U!==u.charCodeAt(o+T))break;U===m&&(M=T)}if(T!==P){if(M===-1)return r}else{if(l>P){if(u.charCodeAt(o+T)===m)return r.slice(o+T+1);if(T===2)return r.slice(o+T)}n>P&&(f.charCodeAt(s+T)===m?M=T:T===2&&(M=3)),M===-1&&(M=0)}let W="";for(T=s+M+1;T<=i;++T)(T===i||f.charCodeAt(T)===m)&&(W+=W.length===0?"..":"\\..");return o+=M,W.length>0?`${W}${r.slice(o,a)}`:(r.charCodeAt(o)===m&&++o,r.slice(o,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===m){if(u.charCodeAt(1)===m){const c=u.charCodeAt(2);if(c!==I&&c!==v)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===C&&u.charCodeAt(2)===m)return`\\\\?\\${u}`;return f},dirname(f){g(f,"path");const u=f.length;if(u===0)return".";let c=-1,r=0;const s=f.charCodeAt(0);if(u===1)return d(s)?f:".";if(d(s)){if(c=r=1,d(f.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&d(f.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(f.charCodeAt(o));)o++;if(o===u)return f;o!==a&&(c=r=o+1)}}}}else b(s)&&f.charCodeAt(1)===C&&(c=u>2&&d(f.charCodeAt(2))?3:2,r=c);let i=-1,n=!0;for(let o=u-1;o>=r;--o)if(d(f.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,r=-1,s=!0,i;if(f.length>=2&&b(f.charCodeAt(0))&&f.charCodeAt(1)===C&&(c=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=c;--i){const a=f.charCodeAt(i);if(d(a)){if(!s){c=i+1;break}}else o===-1&&(s=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return c===r?r=o:r===-1&&(r=f.length),f.slice(c,r)}for(i=f.length-1;i>=c;--i)if(d(f.charCodeAt(i))){if(!s){c=i+1;break}}else r===-1&&(s=!1,r=i+1);return r===-1?"":f.slice(c,r)},extname(f){g(f,"path");let u=0,c=-1,r=0,s=-1,i=!0,n=0;f.length>=2&&f.charCodeAt(1)===C&&b(f.charCodeAt(0))&&(u=r=2);for(let o=f.length-1;o>=u;--o){const a=f.charCodeAt(o);if(d(a)){if(!i){r=o+1;break}continue}s===-1&&(i=!1,s=o+1),a===v?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||s===-1||n===0||n===1&&c===s-1&&c===r+1?"":f.slice(c,s)},format:S.bind(null,"\\"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.length;let r=0,s=f.charCodeAt(0);if(c===1)return d(s)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(d(s)){if(r=1,d(f.charCodeAt(1))){let M=2,T=M;for(;M<c&&!d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&d(f.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!d(f.charCodeAt(M));)M++;M===c?r=M:M!==T&&(r=M+1)}}}}else if(b(s)&&f.charCodeAt(1)===C){if(c<=2)return u.root=u.dir=f,u;if(r=2,d(f.charCodeAt(2))){if(c===3)return u.root=u.dir=f,u;r=3}}r>0&&(u.root=f.slice(0,r));let i=-1,n=r,o=-1,a=!0,l=f.length-1,P=0;for(;l>=r;--l){if(s=f.charCodeAt(l),d(s)){if(!a){n=l+1;break}continue}o===-1&&(a=!1,o=l+1),s===v?i===-1?i=l:P!==1&&(P=1):i!==-1&&(P=-1)}return o!==-1&&(i===-1||P===0||P===1&&i===o-1&&i===n+1?u.base=u.name=f.slice(n,o):(u.name=f.slice(n,i),u.base=f.slice(n,o),u.ext=f.slice(i,o))),n>0&&n!==r?u.dir=f.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",c=!1;for(let r=f.length-1;r>=-1&&!c;r--){const s=r>=0?f[r]:w.cwd();g(s,"path"),s.length!==0&&(u=`${s}/${u}`,c=s.charCodeAt(0)===h)}return u=p(u,!c,"/",E),c?`/${u}`:u.length>0?u:"."},normalize(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h,c=f.charCodeAt(f.length-1)===h;return f=p(f,!u,"/",E),f.length===0?u?"/":c?"./":".":(c&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return g(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let u;for(let c=0;c<f.length;++c){const r=f[c];g(r,"path"),r.length>0&&(u===void 0?u=r:u+=`/${r}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(g(f,"from"),g(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const c=1,r=f.length,s=r-c,i=1,n=u.length-i,o=s<n?s:n;let a=-1,l=0;for(;l<o;l++){const M=f.charCodeAt(c+l);if(M!==u.charCodeAt(i+l))break;M===h&&(a=l)}if(l===o)if(n>o){if(u.charCodeAt(i+l)===h)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else s>o&&(f.charCodeAt(c+l)===h?a=l:l===0&&(a=0));let P="";for(l=c+a+1;l<=r;++l)(l===r||f.charCodeAt(l)===h)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(i+a)}`},toNamespacedPath(f){return f},dirname(f){if(g(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===h;let c=-1,r=!0;for(let s=f.length-1;s>=1;--s)if(f.charCodeAt(s)===h){if(!r){c=s;break}}else r=!1;return c===-1?u?"/":".":u&&c===1?"//":f.slice(0,c)},basename(f,u){u!==void 0&&g(u,"ext"),g(f,"path");let c=0,r=-1,s=!0,i;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let n=u.length-1,o=-1;for(i=f.length-1;i>=0;--i){const a=f.charCodeAt(i);if(a===h){if(!s){c=i+1;break}}else o===-1&&(s=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=o))}return c===r?r=o:r===-1&&(r=f.length),f.slice(c,r)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===h){if(!s){c=i+1;break}}else r===-1&&(s=!1,r=i+1);return r===-1?"":f.slice(c,r)},extname(f){g(f,"path");let u=-1,c=0,r=-1,s=!0,i=0;for(let n=f.length-1;n>=0;--n){const o=f.charCodeAt(n);if(o===h){if(!s){c=n+1;break}continue}r===-1&&(s=!1,r=n+1),o===v?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||r===-1||i===0||i===1&&u===r-1&&u===c+1?"":f.slice(u,r)},format:S.bind(null,"/"),parse(f){g(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const c=f.charCodeAt(0)===h;let r;c?(u.root="/",r=1):r=0;let s=-1,i=0,n=-1,o=!0,a=f.length-1,l=0;for(;a>=r;--a){const P=f.charCodeAt(a);if(P===h){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),P===v?s===-1?s=a:l!==1&&(l=1):s!==-1&&(l=-1)}if(n!==-1){const P=i===0&&c?1:i;s===-1||l===0||l===1&&s===n-1&&s===i+1?u.base=u.name=f.slice(P,n):(u.name=f.slice(P,s),u.base=f.slice(P,n),u.ext=f.slice(s,n))}return i>0?u.dir=f.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[78],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(v,...h){const m=h.reduce((y,g)=>(y[g]=!0,y),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(y=>!m[y]).forEach(y=>{for(let g=0;g<C.length;g++)if(y.search(C[g])!==-1){delete v[y];break}})}e.sanitizeProcessEnvironment=R;function D(v){!v||(delete v.DEBUG,w.isMacintosh&&delete v.DYLD_LIBRARY_PATH,w.isLinux&&delete v.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(J[79],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[3],Z([0,1,18,49,2,127,79]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const v=!1,h=!1;var m;(function(a){a.None=()=>k.Disposable.None;function l(O){if(h){const{onListenerDidAdd:N}=O,V=d.create();let Q=0;O.onListenerDidAdd=()=>{++Q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),N?.()}}}function P(O){return(N,V=null,Q)=>{let ne=!1,j;return j=O(te=>{if(!ne)return j?j.dispose():ne=!0,N.call(V,te)},null,Q),ne&&j.dispose(),j}}a.once=P;function M(O,N,V){return le((Q,ne=null,j)=>O(te=>Q.call(ne,N(te)),null,j),V)}a.map=M;function T(O,N,V){return le((Q,ne=null,j)=>O(te=>{N(te),Q.call(ne,te)},null,j),V)}a.forEach=T;function W(O,N,V){return le((Q,ne=null,j)=>O(te=>N(te)&&Q.call(ne,te),null,j),V)}a.filter=W;function U(O){return O}a.signal=U;function x(...O){return(N,V=null,Q)=>(0,k.combinedDisposable)(...O.map(ne=>ne(j=>N.call(V,j),null,Q)))}a.any=x;function re(O,N,V,Q){let ne=V;return M(O,j=>(ne=N(ne,j),ne),Q)}a.reduce=re;function le(O,N){let V;const Q={onFirstListenerAdd(){V=O(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};N||l(Q);const ne=new b(Q);return N?.add(ne),ne.event}function ue(O,N,V=100,Q=!1,ne,j){let te,ie,ce,fe=0;const ke={leakWarningThreshold:ne,onFirstListenerAdd(){te=O(Me=>{fe++,ie=N(ie,Me),Q&&!ce&&(Le.fire(ie),ie=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ie;ie=void 0,ce=void 0,(!Q||fe>1)&&Le.fire(Ae),fe=0},V)})},onLastListenerRemove(){te.dispose()}};j||l(ke);const Le=new b(ke);return j?.add(Le),Le.event}a.debounce=ue;function se(O,N=(Q,ne)=>Q===ne,V){let Q=!0,ne;return W(O,j=>{const te=Q||!N(j,ne);return Q=!1,ne=j,te},V)}a.latch=se;function de(O,N,V){return[a.filter(O,N,V),a.filter(O,Q=>!N(Q),V)]}a.split=de;function K(O,N=!1,V=[]){let Q=V.slice(),ne=O(ie=>{Q?Q.push(ie):te.fire(ie)});const j=()=>{Q?.forEach(ie=>te.fire(ie)),Q=null},te=new b({onFirstListenerAdd(){ne||(ne=O(ie=>te.fire(ie)))},onFirstListenerDidAdd(){Q&&(N?setTimeout(j):j())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}a.buffer=K;class ${constructor(N){this.event=N,this.disposables=new k.DisposableStore}map(N){return new $(M(this.event,N,this.disposables))}forEach(N){return new $(T(this.event,N,this.disposables))}filter(N){return new $(W(this.event,N,this.disposables))}reduce(N,V){return new $(re(this.event,N,V,this.disposables))}latch(){return new $(se(this.event,void 0,this.disposables))}debounce(N,V=100,Q=!1,ne){return new $(ue(this.event,N,V,Q,ne,this.disposables))}on(N,V,Q){return this.event(N,V,Q)}once(N,V,Q){return P(this.event)(N,V,Q)}dispose(){this.disposables.dispose()}}function _(O){return new $(O)}a.chain=_;function A(O,N,V=Q=>Q){const Q=(...ie)=>te.fire(V(...ie)),ne=()=>O.on(N,Q),j=()=>O.removeListener(N,Q),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromNodeEventEmitter=A;function F(O,N,V=Q=>Q){const Q=(...ie)=>te.fire(V(...ie)),ne=()=>O.addEventListener(N,Q),j=()=>O.removeEventListener(N,Q),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromDOMEventEmitter=F;function z(O){return new Promise(N=>P(O)(N))}a.toPromise=z;function ee(O,N){return N(void 0),O(V=>N(V))}a.runAndSubscribe=ee;function B(O,N){let V=null;function Q(j){V?.dispose(),V=new k.DisposableStore,N(j,V)}Q(void 0);const ne=O(j=>Q(j));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=B;class H{constructor(N,V){this.obs=N,this._counter=0,this._hasChanged=!1;const Q={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};V||l(Q),this.emitter=new b(Q),V&&V.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,V){this._hasChanged=!0}endUpdate(N){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,N){return new H(O,N).emitter.event}a.fromObservable=L})(m=e.Event||(e.Event={}));class C{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${C._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let I=-1;function y(a){const l=I;return I=a,{dispose(){I=l}}}e.setGlobalLeakWarningThreshold=y;class g{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=I;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let W,U=0;for(const[x,re]of this._stacks)(!W||U<re)&&(W=x,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(W)}return()=>{const W=this._stacks.get(l.value)||0;this._stacks.set(l.value,W-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class b{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=I>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(v){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let W,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),W=this._leakageMon.check(U,this._listeners.size+1)),v&&(U=U??d.create());const x=new E(l,P,U),re=this._listeners.push(x);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const le=x.subscription.set(()=>{W?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(le):Array.isArray(M)&&M.push(le),le}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new f(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,w.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=p;class S extends p{clear(l){this._queue.clear()}}class f{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class u extends b{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,W]=this._asyncDeliveryQueue.shift(),U=[],x={...W,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,T.callback)),U.push(re)}};try{T.invoke(x)}catch(re){(0,w.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,w.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=u;class c extends b{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class r extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=r;class s extends b{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]})}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,T)=>l(W=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,W)):P.call(M,W)},void 0,T)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(J[22],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(v,h){const m=setTimeout(v.bind(h),0);return{dispose(){clearTimeout(m)}}});var k;(function(v){function h(m){return m===v.None||m===v.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}v.isCancellationToken=h,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(J[140],Z([0,1,22]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new w.CancellationTokenSource,h=this.task(v.token);return this.result={promise:h,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=t;class k{constructor(v){this.fn=v,this.lastCache=void 0,this.lastArgKey=void 0}get(v){const h=JSON.stringify(v);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(v)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(v){this.fn=v,this._map=new Map}get cachedValues(){return this._map}get(v){if(this._map.has(v))return this._map.get(v);const h=this.fn(v);return this._map.set(v,h),h}}e.CachedFunction=R}),define(J[93],Z([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:w.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(v){super();this._value=v,this.changeEmitter=this._register(new w.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}}e.MutableObservableValue=R}),define(J[25],Z([0,1,140,126]),function(q,e,w,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function v(G,...oe){return oe.length===0?G:G.replace(D,function(me,Se){const we=parseInt(Se,10);return isNaN(we)||we<0||we>=oe.length?me:oe[we]})}e.format=v;const h=/{([^}]+)}/g;function m(G,oe){return G.replace(h,(me,Se)=>oe[Se]??me)}e.format2=m;function C(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=C;function I(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function y(G,oe){let me=0;const Se=oe.charCodeAt(0);for(let we=G.length-1;we>=0;we--)G.charCodeAt(we)===Se&&me++;return me}e.count=y;function g(G,oe,me="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${me}`}e.truncate=g;function d(G,oe=" "){const me=E(G,oe);return b(me,oe)}e.trim=d;function E(G,oe){if(!G||!oe)return G;const me=oe.length;if(me===0||G.length===0)return G;let Se=0;for(;G.indexOf(oe,Se)===Se;)Se=Se+me;return G.substring(Se)}e.ltrim=E;function b(G,oe){if(!G||!oe)return G;const me=oe.length,Se=G.length;if(me===0||Se===0)return G;let we=Se,Ie=-1;for(;Ie=G.lastIndexOf(oe,we-1),!(Ie===-1||Ie+me!==we);){if(Ie===0)return"";we=Ie}return G.substring(0,we)}e.rtrim=b;function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function S(G){return G.replace(/\*/g,"")}e.stripWildcards=S;function f(G,oe,me={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=I(G)),me.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Se="";return me.global&&(Se+="g"),me.matchCase||(Se+="i"),me.multiline&&(Se+="m"),me.unicode&&(Se+="u"),new RegExp(G,Se)}e.createRegExp=f;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function r(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=r;function s(G){return G.split(/\r\n|\r|\n/)}e.splitLines=s;function i(G){for(let oe=0,me=G.length;oe<me;oe++){const Se=G.charCodeAt(oe);if(Se!==32&&Se!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function n(G,oe=0,me=G.length){for(let Se=oe;Se<me;Se++){const we=G.charCodeAt(Se);if(we!==32&&we!==9)return G.substring(oe,Se)}return G.substring(oe,me)}e.getLeadingWhitespace=n;function o(G,oe=G.length-1){for(let me=oe;me>=0;me--){const Se=G.charCodeAt(me);if(Se!==32&&Se!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function a(G,oe,me){const Se=[];let we=0;for(const Ie of G.matchAll(oe)){if(Se.push(G.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,Se.push(me(Ie[0],...Ie.slice(1),Ie.index,G,Ie.groups))}return Se.push(G.slice(we)),Promise.all(Se).then(Ie=>Ie.join(""))}e.replaceAsync=a;function l(G,oe){return G<oe?-1:G>oe?1:0}e.compare=l;function P(G,oe,me=0,Se=G.length,we=0,Ie=oe.length){for(;me<Se&&we<Ie;me++,we++){const Ke=G.charCodeAt(me),Qe=oe.charCodeAt(we);if(Ke<Qe)return-1;if(Ke>Qe)return 1}const Fe=Se-me,$e=Ie-we;return Fe<$e?-1:Fe>$e?1:0}e.compareSubstring=P;function M(G,oe){return T(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=M;function T(G,oe,me=0,Se=G.length,we=0,Ie=oe.length){for(;me<Se&&we<Ie;me++,we++){let Ke=G.charCodeAt(me),Qe=oe.charCodeAt(we);if(Ke===Qe)continue;if(Ke>=128||Qe>=128)return P(G.toLowerCase(),oe.toLowerCase(),me,Se,we,Ie);U(Ke)&&(Ke-=32),U(Qe)&&(Qe-=32);const Ye=Ke-Qe;if(Ye!==0)return Ye}const Fe=Se-me,$e=Ie-we;return Fe<$e?-1:Fe>$e?1:0}e.compareSubstringIgnoreCase=T;function W(G){return G>=48&&G<=57}e.isAsciiDigit=W;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function x(G){return G>=65&&G<=90}e.isUpperAsciiLetter=x;function re(G,oe){return G.length===oe.length&&T(G,oe)===0}e.equalsIgnoreCase=re;function le(G,oe){const me=oe.length;return oe.length>G.length?!1:T(G,oe,0,me)===0}e.startsWithIgnoreCase=le;function ue(G,oe){const me=Math.min(G.length,oe.length);let Se;for(Se=0;Se<me;Se++)if(G.charCodeAt(Se)!==oe.charCodeAt(Se))return Se;return me}e.commonPrefixLength=ue;function se(G,oe){const me=Math.min(G.length,oe.length);let Se;const we=G.length-1,Ie=oe.length-1;for(Se=0;Se<me;Se++)if(G.charCodeAt(we-Se)!==oe.charCodeAt(Ie-Se))return Se;return me}e.commonSuffixLength=se;function de(G){return 55296<=G&&G<=56319}e.isHighSurrogate=de;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function $(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=$;function _(G,oe,me){const Se=G.charCodeAt(me);if(de(Se)&&me+1<oe){const we=G.charCodeAt(me+1);if(K(we))return $(Se,we)}return Se}e.getNextCodePoint=_;function A(G,oe){const me=G.charCodeAt(oe-1);if(K(me)&&oe>1){const Se=G.charCodeAt(oe-2);if(de(Se))return $(Se,me)}return me}class F{constructor(oe,me=0){this._str=oe,this._len=oe.length,this._offset=me}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=A(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=_(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class z{constructor(oe,me=0){this._iterator=new F(oe,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ye.getInstance(),me=this._iterator,Se=me.offset;let we=oe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ie=me.offset,Fe=oe.getGraphemeBreakType(me.nextCodePoint());if(ae(we,Fe)){me.setOffset(Ie);break}we=Fe}return me.offset-Se}prevGraphemeLength(){const oe=ye.getInstance(),me=this._iterator,Se=me.offset;let we=oe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ie=me.offset,Fe=oe.getGraphemeBreakType(me.prevCodePoint());if(ae(Fe,we)){me.setOffset(Ie);break}we=Fe}return Se-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function ee(G,oe){return new z(G,oe).nextGraphemeLength()}e.nextCharLength=ee;function B(G,oe){return new z(G,oe).prevGraphemeLength()}e.prevCharLength=B;function H(G,oe){oe>0&&K(G.charCodeAt(oe))&&oe--;const me=oe+ee(G,oe);return[me-B(G,me),me]}e.getCharContainingOffset=H;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(G){return L.test(G)}e.containsRTL=O;const N=/^[\t\n\r\x20-\x7E]*$/;function V(G){return N.test(G)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Q;function ne(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ne;function j(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=j;function te(G,oe){if(G.length<oe)return G;const me=/\b/g;let Se=0;for(;me.test(G)&&!(G.length-me.lastIndex<oe);)Se=me.lastIndex,me.lastIndex+=1;return G.substring(Se).replace(/^\s/,"")}e.lcut=te;const ie=/\x1B\x5B[12]?K/g,ce=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function ke(G){return G&&(G=G.replace(ie,""),G=G.replace(ce,""),G=G.replace(fe,"")),G}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Me(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=Me;function Ae(G,oe){if(!G||!oe||G.length<oe.length)return!1;const me=oe.length,Se=G.toLowerCase();let we=0,Ie=-1;for(;we<me;){const Fe=Se.indexOf(oe[we],Ie+1);if(Fe<0)return!1;Ie=Fe,we++}return!0}e.fuzzyContains=Ae;function Ve(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ve;function ge(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=ge;function pe(G,oe=1){if(oe===0)return"";let me=-1;do me=G.indexOf(`
`,me+1),oe--;while(oe>0&&me>=0);return me===-1?G:(G[me-1]==="\r"&&me--,G.substr(0,me))}e.getNLines=pe;function be(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=be;function X(G){return ye.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=X;function ae(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}var he;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=Ce()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const me=this._data,Se=me.length/3;let we=1;for(;we<=Se;)if(oe<me[3*we])we=2*we;else if(oe>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}ye._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(G,oe){if(G===0)return 0;const me=Oe(G,oe);if(me!==void 0)return me;const Se=new F(oe,G);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Te;function Oe(G,oe){const me=new F(oe,G);let Se=me.prevCodePoint();for(;Be(Se)||Se===65039||Se===8419;){if(me.offset===0)return;Se=me.prevCodePoint()}if(!j(Se))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function Be(G){return 127995<=G&&G<=127999}var ze;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class _e{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return _e.cache.get(Array.from(oe))}static getLocales(){return _e._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,k=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new w.LRUCachedFunction(G=>{function oe(Qe){const Ye=new Map;for(let et=0;et<Qe.length;et+=2)Ye.set(Qe[et],Qe[et+1]);return Ye}function me(Qe,Ye){const et=new Map(Qe);for(const[ot,at]of Ye)et.set(ot,at);return et}function Se(Qe,Ye){if(!Qe)return Ye;const et=new Map;for(const[ot,at]of Qe)Ye.has(ot)&&et.set(ot,at);return et}const we=k.ambiguousCharacterData.getValue();let Ie=G.filter(Qe=>!Qe.startsWith("_")&&Qe in we);Ie.length===0&&(Ie=["_default"]);let Fe;for(const Qe of Ie){const Ye=oe(we[Qe]);Fe=Se(Fe,Ye)}const $e=oe(we._common),Ke=me($e,Fe);return new _e(Ke)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(oe){return He.getData().has(oe)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(J[31],Z([0,1,9,4,25,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function v(o){return o.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=v;function h(o){return o.indexOf("/")===-1&&(o=v(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function m(o,a=w.posix.sep){if(!o)return"";const l=o.length,P=o.charCodeAt(0);if(D(P)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let T=3;const W=T;for(;T<l&&!D(o.charCodeAt(T));T++);if(W!==T&&!D(o.charCodeAt(T+1))){for(T+=1;T<l;T++)if(D(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(p(P)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let M=o.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(o.charCodeAt(M)))return o.slice(0,M+1)}return""}e.getRoot=m;function C(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let l=2;const P=l;for(;l<o.length&&(a=o.charCodeAt(l),a!==92);l++);return!(P===l||(a=o.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=C;const I=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,a=t.isWindows){const l=a?I:y;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||a&&g.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function E(o,a,l){const P=o===a;return!l||P?P:!o||!a?!1:(0,k.equalsIgnoreCase)(o,a)}e.isEqual=E;function b(o,a,l,P=w.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,o.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),o.indexOf(a)===0}e.isEqualOrParent=b;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function S(o,a){return t.isWindows&&o.endsWith(":")&&(o+=w.sep),(0,w.isAbsolute)(o)||(o=(0,w.join)(a,o)),o=(0,w.normalize)(o),t.isWindows?(o=(0,k.rtrim)(o,w.sep),o.endsWith(":")&&(o+=w.sep)):(o=(0,k.rtrim)(o,w.sep),o||(o=w.sep)),o}e.sanitizeFilePath=S;function f(o){const a=(0,w.normalize)(o);return t.isWindows?o.length>3?!1:u(a)&&(o.length===2||a.charCodeAt(2)===92):a===w.posix.sep}e.isRootOrDriveLetter=f;function u(o,a=t.isWindows){return a?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function r(o,a,l){return a.length>o.length?-1:o===a?0:(l&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=r;function s(o){const a=o.split(":");let l,P,M;for(const T of a){const W=Number(T);(0,R.isNumber)(W)?P===void 0?P=W:M===void 0&&(M=W):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,a,l=8){let P="";for(let T=0;T<l;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let M;return a?M=`${a}-${P}`:M=P,o?(0,w.join)(o,M):M}e.randomPath=n}),define(J[66],Z([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,S){switch(typeof p){case"object":return p===null?R(349,S):Array.isArray(p)?h(p,S):m(p,S);case"string":return v(p,S);case"boolean":return D(p,S);case"number":return R(p,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(p,S){return(S<<5)-S+p|0}e.numberHash=R;function D(p,S){return R(p?433:863,S)}function v(p,S){S=R(149417,S);for(let f=0,u=p.length;f<u;f++)S=R(p.charCodeAt(f),S);return S}e.stringHash=v;function h(p,S){return S=R(104579,S),p.reduce((f,u)=>k(u,f),S)}function m(p,S){return S=R(181387,S),Object.keys(p).sort().reduce((f,u)=>(f=v(u,f),k(p[u],f)),S)}class C{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=C;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function y(p,S,f=32){const u=f-S,c=~((1<<u)-1);return(p<<S|(c&p)>>>u)>>>0}function g(p,S=0,f=p.byteLength,u=0){for(let c=0;c<f;c++)p[S+c]=u}function d(p,S,f="0"){for(;p.length<S;)p=f+p;return p}function E(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),S/4)}e.toHexString=E;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f===0)return;const u=this._buff;let c=this._buffLen,r=this._leftoverHighSurrogate,s,i;for(r!==0?(s=r,i=-1,r=0):(s=S.charCodeAt(0),i=0);;){let n=s;if(w.isHighSurrogate(s))if(i+1<f){const o=S.charCodeAt(i+1);w.isLowSurrogate(o)?(i++,n=w.computeCodePoint(s,o)):n=65533}else{r=s;break}else w.isLowSurrogate(s)&&(n=65533);if(c=this._push(u,c,n),i++,i<f)s=S.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=r}_push(S,f,u){return u<128?S[f++]=u:u<2048?(S[f++]=192|(u&1984)>>>6,S[f++]=128|(u&63)>>>0):u<65536?(S[f++]=224|(u&61440)>>>12,S[f++]=128|(u&4032)>>>6,S[f++]=128|(u&63)>>>0):(S[f++]=240|(u&1835008)>>>18,S[f++]=128|(u&258048)>>>12,S[f++]=128|(u&4032)>>>6,S[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=b._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)S.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)S.setUint32(l,y(S.getUint32(l-12,!1)^S.getUint32(l-32,!1)^S.getUint32(l-56,!1)^S.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,r=this._h2,s=this._h3,i=this._h4,n,o,a;for(let l=0;l<80;l++)l<20?(n=c&r|~c&s,o=1518500249):l<40?(n=c^r^s,o=1859775393):l<60?(n=c&r|c&s|r&s,o=2400959708):(n=c^r^s,o=3395469782),a=y(u,5)+n+i+o+S.getUint32(l*4,!1)&4294967295,i=s,s=r,r=y(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[32],Z([0,1,24,25]),function(q,e,w,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function v(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.getOrSet=v;function h(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function m(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=m;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=C;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class y{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var g;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(g||(g={}));class d{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(b||(b={}));class p{constructor(n){this._iter=n}static forUris(n=()=>!1,o=()=>!1){return new p(new d(n,o))}static forPaths(n=!1){return new p(new y(void 0,!n))}static forStrings(){return new p(new C)}static forConfigKeys(){return new p(new I)}clear(){this._root=void 0}fill(n,o){if(o){const a=o.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l,n)}else{const a=n.slice(0);(0,w.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(n,o){const a=this._iter.reset(n);let l;this._root||(this._root=new E,this._root.segment=a.value());const P=[];for(l=this._root;;){const T=a.cmp(l.segment);if(T>0)l.left||(l.left=new E,l.left.segment=a.value()),P.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new E,l.right.segment=a.value()),P.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new E,l.mid.segment=a.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=o,l.key=n;for(let T=P.length-1;T>=0;T--){const W=P[T][1];W.updateHeight();const U=W.balanceFactor();if(U<-1||U>1){const x=P[T][0],re=P[T+1][0];if(x===1&&re===1)P[T][1]=W.rotateLeft();else if(x===-1&&re===-1)P[T][1]=W.rotateRight();else if(x===1&&re===-1)W.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=W.rotateLeft();else if(x===-1&&re===1)W.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=W.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const a=this._iter.reset(n),l=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(a.hasNext())a.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(o?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:T,value:W,segment:U}=M;this._delete(M.key,!1),P.key=T,P.value=W,P.segment=U}else{const M=P.left??P.right;if(l.length>0){const[T,W]=l[l.length-1];switch(T){case-1:W.left=M;break;case 0:W.mid=M;break;case 1:W.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const T=l[M][1];T.updateHeight();const W=T.balanceFactor();if(W>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[M][1]=T.rotateLeft()):W<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[M][1]=T.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let a=this._root,l;for(;a;){const P=o.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(o.hasNext())o.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[o,a]of this)n(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=p;class S{constructor(n,o){this.uri=n,this.value=o}}class f{constructor(n,o){this[k]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=o??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new S(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(const[a,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=f,f.defaultToKey=i=>i.toString();class u{constructor(n,o){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new f(n):(this._map=new f(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,l)=>n.call(o,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class r{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(!!a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let l=this._map.get(n);if(l)l.value=o,a!==0&&this.touch(l,a);else{switch(l={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let l=this._head;for(;l;){if(o?n.bind(o)(l.value,l.key,this):n(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}values(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}entries(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,l=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=r;class s extends r{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(J[80],Z([0,1,32]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new w.LRUCache(1e4);function k(m){return h(m,"NFC",t)}e.normalizeNFC=k;const R=new w.LRUCache(1e4);function D(m){return h(m,"NFD",R)}e.normalizeNFD=D;const v=/[^\u0000-\u0080]/;function h(m,C,I){if(!m)return m;const y=I.get(m);if(y)return y;let g;return v.test(m)?g=m.normalize(C):g=m,I.set(m,g),g}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(C){return D(C).replace(m,"")}}()}),define(J[94],Z([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",v="warn",h="info",m="ignore";function C(y){return y?w.equalsIgnoreCase(R,y)?k.Error:w.equalsIgnoreCase(D,y)||w.equalsIgnoreCase(v,y)?k.Warning:w.equalsIgnoreCase(h,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=C;function I(y){switch(y){case k.Error:return R;case k.Warning:return D;case k.Info:return h;default:return m}}k.toString=I}(t||(t={})),e.default=t}),define(J[7],Z([0,1,9,4]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function v(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function m(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const C="",I="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,o,a,l,P,M=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=h(n,M),this.authority=o||C,this.path=m(this.scheme,a||C),this.query=l||C,this.fragment=P||C,v(this,M))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:a,path:l,query:P,fragment:M}=n;return o===void 0?o=this.scheme:o===null&&(o=C),a===void 0?a=this.authority:a===null&&(a=C),l===void 0?l=this.path:l===null&&(l=C),P===void 0?P=this.query:P===null&&(P=C),M===void 0?M=this.fragment:M===null&&(M=C),o===this.scheme&&a===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new E(o,a,l,P,M)}static parse(n,o=!1){const a=y.exec(n);return a?new E(a[2]||C,s(a[4]||C),s(a[5]||C),s(a[7]||C),s(a[9]||C),o):new E(C,C,C,C,C)}static file(n){let o=C;if(t.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const a=n.indexOf(I,2);a===-1?(o=n.substring(2),n=I):(o=n.substring(2,a),n=n.substring(a)||I)}return new E("file",o,n,C,C)}static from(n){const o=new E(n.scheme,n.authority,n.path,n.query,n.fragment);return v(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&n.scheme==="file"?a=g.file(w.win32.join(f(n,!0),...o)).path:a=w.posix.join(n.path,...o),n.with({path:a})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const o=new E(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=g;const d=t.isWindows?1:void 0;class E extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(i,n){let o,a=-1;for(let l=0;l<i.length;l++){const P=i.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o!==void 0&&(o+=i.charAt(l));else{o===void 0&&(o=i.substr(0,l));const M=b[P];M!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o+=M):a===-1&&(a=l)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function S(i){let n;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(n===void 0&&(n=i.substr(0,o)),n+=b[a]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function f(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=f;function u(i,n){const o=n?S:p;let a="",{scheme:l,authority:P,path:M,query:T,fragment:W}=i;if(l&&(a+=l,a+=":"),(P||l==="file")&&(a+=I,a+=I),P){let U=P.indexOf("@");if(U!==-1){const x=P.substr(0,U);P=P.substr(U+1),U=x.indexOf(":"),U===-1?a+=o(x,!1):(a+=o(x.substr(0,U),!1),a+=":",a+=o(x.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=o(P,!1):(a+=o(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=o(M,!0)}return T&&(a+="?",a+=o(T,!1)),W&&(a+="#",a+=n?W:p(W,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,n=>c(n)):i}}),define(J[141],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const C=m;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const C=[];let I;try{const y=JSON.parse(m.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),I=g.__$stack),C.push(...y)}catch{C.push("Unable to log remote console arguments",m.arguments)}return{args:C,stack:I}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const C=m;if(C){const I=D(C),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(y&&y.length===4)return{uri:w.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function D(m){if(!m)return m;const C=m.indexOf(`
`);return C===-1?m:m.substring(0,C)}function v(m,C){const{args:I,stack:y}=k(m),g=typeof I[0]=="string"&&I.length===1;let d=D(y);d&&(d=`(${d.trim()})`);let E=[];if(typeof I[0]=="string"?d&&g?E=[`%c[${C}] %c${I[0]} %c${d}`,h("blue"),h(""),h("grey")]:E=[`%c[${C}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:E=[`%c[${C}]%`,h("blue"),...I],d&&!g&&E.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,E)}e.log=v;function h(m){return`color: ${m}`}}),define(J[67],Z([0,1,17,25,7]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,v)}e.stringify=R;function D(m){let C=JSON.parse(m);return C=h(C),C}e.parse=D;function v(m,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function h(m,C=0){if(!m||C>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=h(m[I],C+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=h(m[I],C+1))}return m}e.revive=h}),define(J[13],Z([0,1,4,7]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebook="vscode-notebook",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${k.vscodeRemoteResource}`}set(h,m,C){this._hosts[h]=m,this._ports[h]=C}setConnectionToken(h,m){this._connectionTokens[h]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)return this._delegate(h);const m=h.authority;let C=this._hosts[m];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const I=this._ports[m],y=this._connectionTokens[m];let g=`path=${encodeURIComponent(h.path)}`;return typeof y=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${I}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(h,m){const C=this.toUri(h,m);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(h,m){const C=this.toUri(h,m);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(h,m){return t.URI.isUri(h)?h:t.URI.parse(m.toUrl(h))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(J[16],Z([0,1,31,13,9,4,25,7]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(g){return(0,v.uriToFsPath)(g,!0)}e.originalFSPath=h;class m{constructor(d){this._ignorePathCasing=d}compare(d,E,b=!1){return d===E?0:(0,D.compare)(this.getComparisonKey(d,b),this.getComparisonKey(E,b))}isEqual(d,E,b=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,b)===this.getComparisonKey(E,b)}getComparisonKey(d,E=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,E,b=!1){if(d.scheme===E.scheme){if(d.scheme===t.Schemas.file)return w.isEqualOrParent(h(d),h(E),this._ignorePathCasing(d))&&d.query===E.query&&(b||d.fragment===E.fragment);if((0,e.isEqualAuthority)(d.authority,E.authority))return w.isEqualOrParent(d.path,E.path,this._ignorePathCasing(d),"/")&&d.query===E.query&&(b||d.fragment===E.fragment)}return!1}joinPath(d,...E){return v.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===t.Schemas.file?E=v.URI.file(k.dirname(h(d))).path:(E=k.posix.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===t.Schemas.file?E=v.URI.file(k.normalize(h(d))).path:E=k.posix.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.isEqualAuthority)(d.authority,E.authority))return;if(d.scheme===t.Schemas.file){const S=k.relative(h(d),h(E));return R.isWindows?w.toSlashes(S):S}let b=d.path||"/";const p=E.path||"/";if(this._ignorePathCasing(d)){let S=0;for(const f=Math.min(b.length,p.length);S<f&&!(b.charCodeAt(S)!==p.charCodeAt(S)&&b.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);b=p.substr(0,S)+b.substr(S)}return k.posix.relative(b,p)}resolvePath(d,E){if(d.scheme===t.Schemas.file){const b=v.URI.file(k.resolve(h(d),E));return d.with({authority:b.authority,path:b.path})}return E=w.toPosixPath(E),d.with({path:k.posix.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,D.equalsIgnoreCase)(d,E)}hasTrailingPathSeparator(d,E=k.sep){if(d.scheme===t.Schemas.file){const b=h(d);return b.length>w.getRoot(b).length&&b[b.length-1]===E}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=k.sep){return(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=k.sep){let b=!1;if(d.scheme===t.Schemas.file){const p=h(d);b=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===E}else{E="/";const p=d.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(g=>g.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(g,d){const E=[];for(let b=0;b<g.length;b++){const p=d(g[b]);g.some((S,f)=>f===b?!1:(0,e.isEqualOrParent)(p,d(S)))||E.push(g[b])}return E}e.distinctParents=C;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(E){const b=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,c]=f.split(":");u&&c&&b.set(u,c)});const S=E.path.substring(0,E.path.indexOf(";"));return S&&b.set(g.META_DATA_MIME,S),b}g.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function y(g,d,E){if(d){let b=g.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),g.with({scheme:E,authority:d,path:b})}return g.with({scheme:E})}e.toLocalResource=y}),define(J[8],Z([0,1,22,18,3,2,16,4]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(H){return!!H&&typeof H.then=="function"}e.isThenable=h;function m(H){const L=new w.CancellationTokenSource,O=H(L.token),N=new Promise((V,Q)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),Q(new t.CancellationError)});Promise.resolve(O).then(j=>{ne.dispose(),L.dispose(),V(j)},j=>{ne.dispose(),L.dispose(),Q(j)})});return new class{cancel(){L.cancel()}then(V,Q){return N.then(V,Q)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=m;function C(H,L,O){return new Promise((N,V)=>{const Q=L.onCancellationRequested(()=>{Q.dispose(),N(O)});H.then(N,V).finally(()=>Q.dispose())})}e.raceCancellation=C;function I(H,L){return new Promise((O,N)=>{const V=L.onCancellationRequested(()=>{V.dispose(),N(new t.CancellationError)});H.then(O,N).finally(()=>V.dispose())})}e.raceCancellationError=I;async function y(H){let L=-1;const O=H.map((V,Q)=>V.then(ne=>(L=Q,ne))),N=await Promise.race(O);return H.forEach((V,Q)=>{Q!==L&&V.cancel()}),N}e.raceCancellablePromises=y;function g(H,L,O){let N;const V=setTimeout(()=>{N?.(void 0),O?.()},L);return Promise.race([H.finally(()=>clearTimeout(V)),new Promise(Q=>N=Q)])}e.raceTimeout=g;function d(H){return new Promise((L,O)=>{const N=H();h(N)?N.then(L,O):L(N)})}e.asPromise=d;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=L(),new Promise((O,N)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=E;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=p;const S=(H,L)=>{let O=!0;const N=setTimeout(()=>{O=!1,L()},H);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},f=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Q)=>{this.doResolve=V,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?f(N):S(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(L){this.delayer=new u(L),this.throttler=new E}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class r{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class s extends r{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(H,L){return L?new Promise((O,N)=>{const V=setTimeout(()=>{Q.dispose(),O()},H),Q=L.onCancellationRequested(()=>{clearTimeout(V),Q.dispose(),N(new t.CancellationError)})}):m(O=>i(H,O))}e.timeout=i;function n(H,L=0){const O=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function o(H){const L=[];let O=0;const N=H.length;function V(){return O<N?H[O++]():null}function Q(ne){ne!=null&&L.push(ne);const j=V();return j?j.then(Q):Promise.resolve(L)}return Promise.resolve(null).then(Q)}e.sequence=o;function a(H,L=N=>!!N,O=null){let N=0;const V=H.length,Q=()=>{if(N>=V)return Promise.resolve(O);const ne=H[N++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):Q())};return Q()}e.first=a;function l(H,L=N=>!!N,O=null){if(H.length===0)return Promise.resolve(O);let N=H.length;const V=()=>{N=-1;for(const Q of H)Q.cancel?.()};return new Promise((Q,ne)=>{for(const j of H)j.then(te=>{--N>=0&&L(te)?(V(),Q(te)):N===0&&Q(O)}).catch(te=>{--N>=0&&(V(),ne(te))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:L,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new _;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const N=O.getComparisonKey(L);let V=this.queues.get(N);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class W{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=W;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class x{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class re{constructor(L,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends x{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class ue extends R.Disposable{constructor(L,O){super();this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,v.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(H,L)=>{const O=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function de(H,L,O){let N;for(let V=0;V<O;V++)try{return await H()}catch(Q){N=Q,await i(L)}throw N}e.retry=de;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,N){return this._pending={taskId:L,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,N;const V=new Promise((Q,ne)=>{O=Q,N=ne});this._next={run:L,promise:V,promiseResolve:O,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=K;class ${constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=_;var A;(function(H){async function L(N){let V;const Q=await Promise.all(N.map(ne=>ne.then(j=>j,j=>{V||(V=j)})));if(typeof V!="undefined")throw V;return Q}H.settled=L;function O(N){return new Promise(async(V,Q)=>{try{await N(V,Q)}catch(ne){Q(ne)}})}H.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var F;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(F||(F={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(L(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async N=>O.emitOne(await N)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async N=>{for await(const V of N)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async N=>{for await(const V of L)N.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async N=>{for await(const V of L)O(V)&&N.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const N of L)O.push(N);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class ee extends z{constructor(L,O){super(O);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function B(H){const L=new w.CancellationTokenSource,O=H(L.token);return new ee(L,async N=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),N.reject(new t.CancellationError)});try{for await(const Q of O){if(L.token.isCancellationRequested)return;N.emitOne(Q)}V.dispose(),L.dispose()}catch(Q){V.dispose(),L.dispose(),N.reject(Q)}})}e.createCancelableAsyncIterable=B}),define(J[95],Z([0,1,24,8,31,32,9,4,25]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",I="[^/\\\\]",y=/\//g;function g(_,A){switch(_){case 0:return"";case 1:return`${I}*?`;default:return`(?:${C}|${I}+${C}${A?`|${C}${I}+`:""})*?`}}function d(_,A){if(!_)return[];const F=[];let z=!1,ee=!1,B="";for(const H of _){switch(H){case A:if(!z&&!ee){F.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}B+=H}return B&&F.push(B),F}e.splitGlobAware=d;function E(_){if(!_)return"";let A="";const F=d(_,e.GLOB_SPLIT);if(F.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;F.forEach((ee,B)=>{if(ee===e.GLOBSTAR){if(z)return;A+=g(2,B===F.length-1)}else{let H=!1,L="",O=!1,N="";for(const V of ee){if(V!=="}"&&H){L+=V;continue}if(O&&(V!=="]"||!N)){let Q;V==="-"?Q=V:(V==="^"||V==="!")&&!N?Q="^":V===e.GLOB_SPLIT?Q="":Q=(0,h.escapeRegExpCharacters)(V),N+=Q;continue}switch(V){case"{":H=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(j=>E(j)).join("|")})`,H=!1,L="";break}case"]":{A+="["+N+"]",O=!1,N="";break}case"?":A+=I;continue;case"*":A+=g(1);continue;default:A+=(0,h.escapeRegExpCharacters)(V)}}B<F.length-1&&(F[B+1]!==e.GLOBSTAR||B+2<F.length)&&(A+=C)}z=ee===e.GLOBSTAR})}return A}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),s=function(){return!1},i=function(){return null};function n(_,A){if(!_)return i;let F;typeof _!="string"?F=_.pattern:F=_,F=F.trim();const z=`${F}_${!!A.trimForExclusions}`;let ee=r.get(z);if(ee)return o(ee,_);let B;return b.test(F)?ee=l(F.substr(4),F):(B=p.exec(a(F,A)))?ee=P(B[1],F):(A.trimForExclusions?f:S).test(F)?ee=M(F,A):(B=u.exec(a(F,A)))?ee=T(B[1].substr(1),F,!0):(B=c.exec(a(F,A)))?ee=T(B[1],F,!1):ee=W(F),r.set(z,ee),o(ee,_)}function o(_,A){if(typeof A=="string")return _;const F=function(z,ee){return(0,k.isEqualOrParent)(z,A.base,!v.isLinux)?_(z.substr(A.base.length+1),ee):null};return F.allBasenames=_.allBasenames,F.allPaths=_.allPaths,F.basenames=_.basenames,F.patterns=_.patterns,F}function a(_,A){return A.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function l(_,A){return function(F,z){return typeof F=="string"&&F.endsWith(_)?A:null}}function P(_,A){const F=`/${_}`,z=`\\${_}`,ee=function(H,L){return typeof H!="string"?null:L?L===_?A:null:H===_||H.endsWith(F)||H.endsWith(z)?A:null},B=[_];return ee.basenames=B,ee.patterns=[A],ee.allBasenames=B,ee}function M(_,A){const F=K(_.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==i),_),z=F.length;if(!z)return i;if(z===1)return F[0];const ee=function(L,O){for(let N=0,V=F.length;N<V;N++)if(F[N](L,O))return _;return null},B=F.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function T(_,A,F){const z=D.sep===D.posix.sep,ee=z?_:_.replace(y,D.sep),B=D.sep+ee,H=D.posix.sep+_;let L;return F?L=function(O,N){return typeof O=="string"&&(O===ee||O.endsWith(B)||!z&&(O===_||O.endsWith(H)))?A:null}:L=function(O,N){return typeof O=="string"&&(O===ee||!z&&O===_)?A:null},L.allPaths=[(F?"*/":"./")+_],L}function W(_){try{const A=new RegExp(`^${E(_)}$`);return function(F){return A.lastIndex=0,typeof F=="string"&&A.test(F)?_:null}}catch{return i}}function U(_,A,F){return!_||typeof A!="string"?!1:x(_)(A,void 0,F)}e.match=U;function x(_,A={}){if(!_)return s;if(typeof _=="string"||re(_)){const F=n(_,A);if(F===i)return s;const z=function(ee,B){return!!F(ee,B)};return F.allBasenames&&(z.allBasenames=F.allBasenames),F.allPaths&&(z.allPaths=F.allPaths),z}return se(_,A)}e.parse=x;function re(_){const A=_;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function le(_){return _.allBasenames||[]}e.getBasenameTerms=le;function ue(_){return _.allPaths||[]}e.getPathTerms=ue;function se(_,A){const F=K(Object.getOwnPropertyNames(_).map(L=>de(L,_[L],A)).filter(L=>L!==i)),z=F.length;if(!z)return i;if(!F.some(L=>!!L.requiresSiblings)){if(z===1)return F[0];const L=function(V,Q){let ne;for(let j=0,te=F.length;j<te;j++){const ie=F[j](V,Q);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const j of ne){const te=await j;if(typeof te=="string")return te}return null})():null},O=F.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const N=F.reduce((V,Q)=>Q.allPaths?V.concat(Q.allPaths):V,[]);return N.length&&(L.allPaths=N),L}const ee=function(L,O,N){let V,Q;for(let ne=0,j=F.length;ne<j;ne++){const te=F[ne];te.requiresSiblings&&N&&(O||(O=(0,D.basename)(L)),V||(V=O.substr(0,O.length-(0,D.extname)(L).length)));const ie=te(L,O,V,N);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(Q||(Q=[]),Q.push(ie))}return Q?(async()=>{for(const ne of Q){const j=await ne;if(typeof j=="string")return j}return null})():null},B=F.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const H=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(ee.allPaths=H),ee}function de(_,A,F){if(A===!1)return i;const z=n(_,F);if(z===i)return i;if(typeof A=="boolean")return z;if(A){const ee=A.when;if(typeof ee=="string"){const B=(H,L,O,N)=>{if(!N||!z(H,L))return null;const V=ee.replace("$(basename)",O),Q=N(V);return(0,t.isThenable)(Q)?Q.then(ne=>ne?_:null):Q?_:null};return B.requiresSiblings=!0,B}}return z}function K(_,A){const F=_.filter(L=>!!L.basenames);if(F.length<2)return _;const z=F.reduce((L,O)=>{const N=O.basenames;return N?L.concat(N):L},[]);let ee;if(A){ee=[];for(let L=0,O=z.length;L<O;L++)ee.push(A)}else ee=F.reduce((L,O)=>{const N=O.patterns;return N?L.concat(N):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const Q=L.charCodeAt(V-1);if(Q===47||Q===92)break}O=L.substr(V)}const N=z.indexOf(O);return N!==-1?ee[N]:null};B.basenames=z,B.patterns=ee,B.allBasenames=z;const H=_.filter(L=>!L.basenames);return H.push(B),H}function $(_,A){return(0,w.equals)(_,A,(F,z)=>typeof F=="string"&&typeof z=="string"?F===z:typeof F!="string"&&typeof z!="string"?F.base===z.base&&F.pattern===z.pattern:!1)}e.patternsEquals=$}),define(J[35],Z([0,1,24,31,9,4,16,25]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:a,relative:l}=n;if(l){const T=m(i,l,o);if(typeof T=="string")return T}let P=i.fsPath;if(o===1&&!R.isWindows?P=P.replace(/\//g,"\\"):o!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),o!==1&&a?.userHome){const T=a.userHome.fsPath;let W;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?W=a.userHome.with({path:i.path}).fsPath:W=i.fsPath,P=y(W,T,o)}return(o===1?k.win32:k.posix).normalize(C(P,o===1))}e.getPathLabel=h;function m(i,n,o){const a=o===1?k.win32:k.posix,l=o===3?D.extUri:D.extUriIgnorePathCase,P=n.getWorkspace(),M=(0,w.firstOrDefault)(P.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let W;if(l.isEqual(T.uri,i)?W="":W=l.relativePath(T.uri,i)??"",W&&(W=a.normalize(W)),P.folders.length>1&&!n.noPrefix){const U=T.name?T.name:l.basenameOrAuthority(T.uri);W=W?`${U} \u2022 ${W}`:U}return W}function C(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let I=Object.create(null);function y(i,n,o=R.OS){if(o===1||!i||!n)return i;let a=I.original===n?I.normalized:void 0;a||(a=n,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,v.rtrim)(a,k.posix.sep)}${k.posix.sep}`,I={original:n,normalized:a});let l=i;return R.isWindows&&(l=(0,t.toSlashes)(l)),(o===3?l.startsWith(a):(0,v.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:i}e.tildify=y;function g(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=g;const d="\u2026",E="\\\\",b="~";function p(i,n=k.sep){const o=new Array(i.length);let a=!1;for(let l=0;l<i.length;l++){const P=i[l];if(P===""){o[l]=`.${n}`;continue}if(!P){o[l]=P;continue}a=!0;let M="",T=P;T.indexOf(E)===0?(M=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length)):T.indexOf(n)===0?(M=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(b)===0&&(M=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const W=T.split(n);for(let U=1;a&&U<=W.length;U++)for(let x=W.length-U;a&&x>=0;x--){a=!1;let re=W.slice(x,x+U).join(n);for(let le=0;!a&&le<i.length;le++)if(le!==l&&i[le]&&i[le].indexOf(re)>-1){const ue=x+U===W.length,se=x>0&&i[le].indexOf(n)>-1?n+re:re,de=i[le].endsWith(se);a=!ue||de}if(!a){let le="";(W[0].endsWith(":")||M!=="")&&(x===1&&(x=0,U++,re=W[0]+n+re),x>0&&(le=W[0]+n),le=M+le),x>0&&(le=le+d+n),le=le+re,x+U<W.length&&(le=le+n+d),o[l]=le}}a&&(o[l]=P)}return o}e.shorten=p;var S;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function f(i,n=Object.create(null)){const o=[];let a=!1,l="";for(const P of i)if(P==="$"||a&&P==="{")l&&o.push({value:l,type:S.TEXT}),l="",a=!0;else if(P==="}"&&a){const M=n[l];if(typeof M=="string")M.length&&o.push({value:M,type:S.VARIABLE});else if(M){const T=o[o.length-1];(!T||T.type!==S.SEPARATOR)&&o.push({value:M.label,type:S.SEPARATOR})}l="",a=!1}else l+=P;return l&&!a&&o.push({value:l,type:S.TEXT}),o.filter((P,M)=>{if(P.type===S.SEPARATOR){const T=o[M-1],W=o[M+1];return[T,W].every(U=>U&&(U.type===S.VARIABLE||U.type===S.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function u(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,o=n.basename(i),a=n.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=s}),define(J[142],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const y=this._uriTransformer.transformIncoming(I);return y===I?I:t(w.URI.from(y))}transformOutgoing(I){const y=this._uriTransformer.transformOutgoing(I);return y===I?I:t(w.URI.from(y))}transformOutgoingURI(I){const y=this._uriTransformer.transformOutgoing(I);return y===I?I:w.URI.from(y)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,I,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof w.URI)return I.transformOutgoing(C);for(const g in C)if(Object.hasOwnProperty.call(C,g)){const d=R(C[g],I,y+1);d!==null&&(C[g]=d)}}return null}function D(C,I){const y=R(C,I,0);return y===null?C:y}e.transformOutgoingURIs=D;function v(C,I,y,g){if(!C||g>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?w.URI.revive(I.transformIncoming(C)):I.transformIncoming(C);for(const d in C)if(Object.hasOwnProperty.call(C,d)){const E=v(C[d],I,y,g+1);E!==null&&(C[d]=E)}}return null}function h(C,I){const y=v(C,I,!1,0);return y===null?C:y}e.transformIncomingURIs=h;function m(C,I){const y=v(C,I,!0,0);return y===null?C:y}e.transformAndReviveIncomingURIs=m}),define(J[81],Z([0,1,30,18,32,28,130]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,I=0;const y=(0,w.networkInterfaces)();for(const g in y){const d=y[g];if(d)for(const{mac:E,internal:b}of d)b||(I+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(C+=1))}this._value=I>0?C/I:0}return this._value}};let v;async function h(){return v||(v=(async()=>await m()||R.generateUuid())()),v}e.getMachineId=h;async function m(){try{const C=await new Promise((y,g)=>{q(["crypto"],y,g)}),I=(0,D.getMac)();return C.createHash("sha256").update(I,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(J[23],Z([0,1,29,30,143,8,31,80,9,4,16,7]),function(q,e,w,t,k,R,D,v,h,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function g(se,de=y.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return de===y.UNLINK?E(se):d(se)}async function d(se){try{const de=(0,D.randomPath)((0,t.tmpdir)());try{await w.promises.rename(se,de)}catch{return E(se)}E(de).catch(K=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function E(se){return(0,k.promisify)(w.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(se,de){return u(await(de?S(se):(0,k.promisify)(w.readdir)(se)))}async function S(se){try{return await(0,k.promisify)(w.readdir)(se,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const de=[],K=await p(se);for(const $ of K){let _=!1,A=!1,F=!1;try{const z=await e.Promises.lstat((0,h.join)(se,$));_=z.isFile(),A=z.isDirectory(),F=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:$,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>F})}return de}function f(se){return u(w.readdirSync(se))}e.readdirSync=f;function u(se){return se.map(de=>typeof de=="string"?m.isMacintosh?(0,v.normalizeNFC)(de):de:(de.name=m.isMacintosh?(0,v.normalizeNFC)(de.name):de.name,de))}async function c(se){const de=await p(se),K=[];for(const $ of de)await s.existsDirectory((0,h.join)(se,$))&&K.push($);return K}function r(se,de=1e3){return new Promise(K=>{let $=!1;const _=setInterval(()=>{$||($=!0,w.access(se,A=>{$=!1,A&&(clearInterval(_),K(void 0))}))},de)})}e.whenDeleted=r;var s;(function(se){async function de(_){let A;try{if(A=await e.Promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw F}}se.stat=de;async function K(_){try{const{stat:A,symbolicLink:F}=await se.stat(_);return A.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=K;async function $(_){try{const{stat:A,symbolicLink:F}=await se.stat(_);return A.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=$})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(se,de,K){return i.queueFor(I.URI.file(se),C.extUriBiasedIgnorePathCase).queue(()=>{const $=M(K);return new Promise((_,A)=>l(se,de,$,F=>F?A(F):_()))})}let o=!0;function a(se){o=se}e.configureFlushOnWrite=a;function l(se,de,K,$){if(!o)return w.writeFile(se,de,{mode:K.mode,flag:K.flag},$);w.open(se,K.flag,K.mode,(_,A)=>{if(_)return $(_);w.writeFile(A,de,F=>{if(F)return w.close(A,()=>$(F));w.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a(!1)),w.close(A,ee=>$(ee))))})})}function P(se,de,K){const $=M(K);if(!o)return w.writeFileSync(se,de,{mode:$.mode,flag:$.flag});const _=w.openSync(se,$.flag,$.mode);try{w.writeFileSync(_,de);try{w.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{w.closeSync(_)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,de){if(se!==de)try{await e.Promises.rename(se,de)}catch(K){if(se.toLowerCase()!==de.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await W(se,de,{preserveSymlinks:!1}),await g(se,y.MOVE);else throw K}}async function W(se,de,K){return x(se,de,{root:{source:se,target:de},options:K,handledSourcePaths:new Set})}const U=511;async function x(se,de,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:$,symbolicLink:_}=await s.stat(se);if(_){if(K.options.preserveSymlinks)try{return await ue(se,de,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return $.isDirectory()?re(se,de,$.mode&U,K):le(se,de,$.mode&U)}async function re(se,de,K,$){await e.Promises.mkdir(de,{recursive:!0,mode:K});const _=await p(se);for(const A of _)await x((0,h.join)(se,A),(0,h.join)(de,A),$)}async function le(se,de,K){await e.Promises.copyFile(se,de),await e.Promises.chmod(de,K)}async function ue(se,de,K){let $=await e.Promises.readlink(se);(0,D.isEqualOrParent)($,K.root.source,!m.isLinux)&&($=(0,h.join)(K.root.target,$.substr(K.root.source.length+1))),await e.Promises.symlink($,de)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(se,de,K,$,_)=>new Promise((A,F)=>{w.read(se,de,K,$,_,(z,ee,B)=>z?F(z):A({bytesRead:ee,buffer:B}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(se,de,K,$,_)=>new Promise((A,F)=>{w.write(se,de,K,$,_,(z,ee,B)=>z?F(z):A({bytesWritten:ee,buffer:B}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return g}get move(){return T}get copy(){return W}}}),define(J[96],Z([0,1,29,9,4,25,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function v(y){if(k.isLinux)return y;const g=(0,t.dirname)(y);if(y===g)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const b=(0,D.readdirSync)(g).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=v(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const S=v(g);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcaseSync=v;async function h(y){if(k.isLinux)return y;const g=(0,t.dirname)(y);if(y===g)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const b=(await D.Promises.readdir(g)).filter(p=>p.toLowerCase()===d);if(b.length===1){const p=await h(g);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(d);if(p>=0){const S=await h(g);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcase=h;async function m(y){try{return await D.Promises.realpath(y)}catch{const d=I(y);return await D.Promises.access(d,w.constants.R_OK),d}}e.realpath=m;function C(y){try{return w.realpathSync(y)}catch{const d=I(y);return w.accessSync(d,w.constants.R_OK),d}}e.realpathSync=C;function I(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(J[144],Z([0,1,30,9,23]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class I{constructor(c,r,s){this.exePath=c,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:u=!1}={}){return u?m===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:u=!1,findPreview:c=!1}={}){const r=y({useAlternateBitness:u});if(!r)return null;const s=t.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const l of await k.Promises.readdir(s)){let P=-1;if(c){const T=l.indexOf("-");if(T<0)continue;const W=l.substring(0,T);if(!R.test(W)||l.substring(T+1)!=="preview")continue;P=parseInt(W,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const M=t.join(s,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(n=M,i=P)}if(!n)return null;const o=r.includes("x86")?" (x86)":"",a=c?" Preview":"";return new I(n,`PowerShell${a}${o}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=u?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(r.test(i)){const n=t.join(c,i,"pwsh.exe");return new I(n,s)}return null}function E(){const u=t.join(w.homedir(),".dotnet","tools","pwsh.exe");return new I(u,".NET Core PowerShell Global Tool")}function b(){const u=t.join(process.env.windir,m===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(u,"Windows PowerShell",!0)}async function*p(){let u=await g();u&&(yield u),u=await g({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=E(),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await g({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*S(){for await(const u of p())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=S;async function f(){for await(const u of S())return u;return null}e.getFirstAvailablePowerShellInstallation=f}),define(J[82],Z([0,1,9,4,34,78,12,23]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(I=k.env){return I.comspec||"cmd.exe"}e.getWindowsShell=h;function m(I){let y=[],g=!1;const d=function(E){if(g){y.push(E);return}(!I.send(E,p=>{if(p&&console.error(p),g=!1,y.length>0){const S=y.slice(0);y=[],S.forEach(f=>d(f))}})||t.isWindows)&&(g=!0)};return{send:d}}e.createQueuedSender=m;var C;(function(I){async function y(g,d,E){if(w.isAbsolute(g))return g;if(d===void 0&&(d=k.cwd()),w.dirname(g)!=="."||(E===void 0&&D.isString(k.env.PATH)&&(E=k.env.PATH.split(w.delimiter)),E===void 0||E.length===0))return w.join(d,g);async function p(S){if(await v.Promises.exists(S)){let f;try{f=await v.Promises.stat(S)}catch(u){u.message.startsWith("EACCES")&&(f=await v.Promises.lstat(S))}return f?!f.isDirectory():!1}return!1}for(const S of E){let f;if(w.isAbsolute(S)?f=w.join(S,g):f=w.join(d,S,g),await p(f))return f;let u=f+".com";if(await p(u)||(u=f+".exe",await p(u)))return u}return w.join(d,g)}I.findExecutable=y})(C=e.win32||(e.win32={}))}),define(J[97],Z([0,1,51,13]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((v,h)=>{let m;const C=new Map;function I(g,d,E,b,p){const S=C.get(d);if(g===D||S){const f={name:y(E),cmd:E,pid:g,ppid:d,load:b,mem:p};C.set(g,f),g===D&&(m=f),S&&(S.children||(S.children=[]),S.children.push(f),S.children.length>1&&(S.children=S.children.sort((u,c)=>u.pid-c.pid)))}}function y(g){const d=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(f.exec(g))return"electron-crash-reporter";if(u.exec(g))return"winpty-process";if(c.exec(g))return"console-window-host (Windows internal process)";let s=r.exec(g);if(s&&s.length===2){if(s[1]==="renderer")return d.exec(g)?"shared-process":E.exec(g)?"issue-reporter":b.exec(g)?"process-explorer":"window";if(s[1]==="utility"){if(p.exec(g))return"utility-network-service";if(S.exec(g))return"extension-host"}return s[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do s=i.exec(g),s&&(n+=s+" ");while(s);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${n}`:g}if(process.platform==="win32"){const g=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,E)=>{q(["windows-process-tree"],d,E)}).then(d=>{d.getProcessList(D,E=>{if(!E){h(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(E,b=>{const p=new Map;b.forEach(S=>{const f=g(S.commandLine||"");p.set(S.pid,{name:y(f),cmd:f,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),m=p.get(D),m?(p.forEach(S=>{const f=p.get(S.ppid);f&&(f.children||(f.children=[]),f.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((f,u)=>f.pid-u.pid))}),v(m)):h(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let g=function(){let d=[m];const E=[];for(;d.length;){const p=d.shift();p&&(E.push(p.pid),p.children&&(d=d.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);b+=" "+E.join(" "),(0,w.exec)(b,{},(p,S,f)=>{if(p||f)h(p||new Error(f.toString()));else{const u=S.toString().split(`
`);for(let c=0;c<E.length;c++){const r=C.get(E[c]);r.load=parseFloat(u[c])}if(!m){h(new Error(`Root process ${D} not found`));return}v(m)}})};(0,w.exec)("which ps",{},(d,E,b)=>{if(d||b)if(process.platform!=="linux")h(d||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(p,{},(S,f,u)=>{S||u?h(S||new Error(u.toString())):(R(f,I),g())})}else{const p=E.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,c)=>{f||c&&!c.includes("screen size is bogus")?h(f||new Error(c.toString())):(R(u,I),process.platform==="linux"?g():m?v(m):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,v){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const C of m){const I=h.exec(C.trim());I&&I.length===6&&v(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[145],Z([0,1,30,4,144,82]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(g,d){return g===1?t.isWindows?I():R.getWindowsShell(d):m(g,d)}e.getSystemShell=D;function v(g,d){return g===1?t.isWindows?y(d):R.getWindowsShell(d):m(g,d)}e.getSystemShellSync=v;let h=null;function m(g,d){if(t.isLinux&&g===2||t.isMacintosh&&g===3)return"/bin/bash";if(!h){let E;if(t.isWindows)E="/bin/bash";else{if(E=d.SHELL,!E)try{E=(0,w.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}h=E}return h}let C=null;async function I(){return C||(C=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),C}function y(g){if(C)return C;const d=t.isWindows&&parseFloat((0,w.release)())>=10,E=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${g.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:R.getWindowsShell(g)}});var ve=this&&this.__decorate||function(q,e,w,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,w):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,w,t);else for(var v=q.length-1;v>=0;v--)(D=q[v])&&(R=(k<3?D(R):k>3?D(e,w,R):D(e,w))||R);return k>3&&R&&Object.defineProperty(e,w,R),R};define(J[45],Z([0,1,24,8,17,22,52,18,3,2,67,25,12]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function b(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(p||(p={}));class S{constructor(A){this.buffer=A,this.pos=0}read(A){const F=this.buffer.slice(this.pos,this.pos+A);return this.pos+=F.byteLength,F}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var u;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(u||(u={}));function c(_){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function r(_){return _.read(4).readUInt32BE(0)}function s(_){const A=k.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const i={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object)},n=typeof Buffer!="undefined";function o(_,A){if(typeof A=="undefined")_.write(i.Undefined);else if(typeof A=="string"){const F=k.VSBuffer.fromString(A);_.write(i.String),_.write(c(F.byteLength)),_.write(F)}else if(n&&Buffer.isBuffer(A)){const F=k.VSBuffer.wrap(A);_.write(i.Buffer),_.write(c(F.byteLength)),_.write(F)}else if(A instanceof k.VSBuffer)_.write(i.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(i.Array),_.write(c(A.length));for(const F of A)o(_,F)}else{const F=k.VSBuffer.fromString(JSON.stringify(A));_.write(i.Object),_.write(c(F.byteLength)),_.write(F)}}function a(_){switch(_.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return _.read(r(_)).toString();case u.Buffer:return _.read(r(_)).buffer;case u.VSBuffer:return _.read(r(_));case u.Array:{const F=r(_),z=[];for(let ee=0;ee<F;ee++)z.push(a(_));return z}case u.Object:return JSON.parse(_.read(r(_)).toString())}}class l{constructor(A,F,z=null,ee=1e3){this.protocol=A,this.ctx=F,this.logger=z,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,F){this.channels.set(A,F),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const F=this.send([A.type]);this.logger?.logOutgoing(F,0,1,b(A.type));return}case 201:case 202:case 204:case 203:{const F=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(F,A.id,1,b(A.type),A.data);return}}}send(A,F=void 0){const z=new f;return o(z,A),o(z,F),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const F=new S(A),z=a(F),ee=a(F),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,ee),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,ee),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let ee;try{ee=F.call(this.ctx,A.name,A.arg,z.token)}catch(L){ee=Promise.reject(L)}const B=A.id;ee.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const H=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,H)}onEventListen(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const z=A.id,B=F.listen(this.ctx,A.name,A.arg)(H=>this.sendResponse({id:z,data:H,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const F=this.activeRequests.get(A.id);F&&(F.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let F=this.pendingRequests.get(A.channelName);F||(F=[],this.pendingRequests.set(A.channelName,F));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const F=this.pendingRequests.get(A);if(F){for(const z of F)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,F=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=F}getChannel(A){const F=this;return{call(z,ee,B){return F.isDisposed?Promise.reject(new v.CancellationError):F.requestPromise(A,z,ee,B)},listen(z,ee){return F.isDisposed?h.Event.None:F.requestEvent(A,z,ee)}}}requestPromise(A,F,z,ee=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:F,arg:z};if(ee.isCancellationRequested)return Promise.reject(new v.CancellationError);let O;return new Promise((V,Q)=>{if(ee.isCancellationRequested)return Q(new v.CancellationError);const ne=()=>{const ce=fe=>{switch(fe.type){case 201:this.handlers.delete(B),V(fe.data);break;case 202:{this.handlers.delete(B);const ke=new Error(fe.data.message);ke.stack=fe.data.stack,ke.name=fe.data.name,Q(ke);break}case 203:this.handlers.delete(B),Q(fe.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let j=null;this.state===p.Idle?ne():(j=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),j.then(()=>{j=null,ne()}));const te=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),Q(new v.CancellationError)},ie=ee.onCancellationRequested(te);O=(0,m.combinedDisposable)((0,m.toDisposable)(te),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,F,z){const ee=this.lastRequestId++,H={id:ee,type:102,channelName:A,name:F,arg:z};let L=null;const O=new h.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(H)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:ee,type:103}))}}),N=V=>O.fire(V.data);return this.handlers.set(ee,N),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const F=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(F,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const F=this.send([A.type,A.id]);this.logger?.logOutgoing(F,A.id,0,d(A.type));return}}}send(A,F=void 0){const z=new f;return o(z,A),o(z,F),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const F=new S(A),z=a(F),ee=a(F),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,b(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,b(B),ee),this.onResponse({type:z[0],id:z[1],data:ee})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:F,onDidClientDisconnect:z})=>{h.Event.once(F.onMessage)(B=>{const H=new S(B),L=a(H),O=new l(F,L),N=new M(F);this.channels.forEach((Q,ne)=>O.registerChannel(ne,Q));const V={channelServer:O,channelClient:N,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),N.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(F=>A.push(F)),A}getChannel(A,F){const z=this;return{call(ee,B,H){let L;if((0,y.isFunction)(F)){const N=(0,w.getRandomElement)(z.connections.filter(F));L=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(z.onDidAddConnection,F))}else L=F.routeCall(z,ee,B);const O=L.then(N=>N.channelClient.getChannel(A));return U(O).call(ee,B,H)},listen(ee,B){if((0,y.isFunction)(F))return z.getMulticastEvent(A,F,ee,B);const H=F.routeEvent(z,ee,B).then(L=>L.channelClient.getChannel(A));return U(H).listen(ee,B)}}}getMulticastEvent(A,F,z,ee){const B=this;let H=new m.DisposableStore;const L=new h.Emitter({onFirstListenerAdd:()=>{H=new m.DisposableStore;const O=new h.EventMultiplexer,N=new Map,V=ne=>{const te=ne.channelClient.getChannel(A).listen(z,ee),ie=O.add(te);N.set(ne,ie)},Q=ne=>{const j=N.get(ne);!j||(j.dispose(),N.delete(ne))};B.connections.filter(F).forEach(V),h.Event.filter(B.onDidAddConnection,F)(V,void 0,H),B.onDidRemoveConnection(Q,void 0,H),O.event(L.fire,L,H),H.add(O)},onLastListenerRemove:()=>{H.dispose()}});return L.event}registerChannel(A,F){this.channels.set(A,F),this._connections.forEach(z=>{z.channelServer.registerChannel(A,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class W{constructor(A,F,z=null){const ee=new f;o(ee,F),A.send(ee.buffer),this.channelClient=new M(A,z),this.channelServer=new l(A,F,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,F){this.channelServer.registerChannel(A,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function U(_){return{call(A,F,z){return _.then(ee=>ee.call(A,F,z))},listen(A,F){const z=new h.Relay;return _.then(ee=>z.input=ee.listen(A,F)),z.event}}}e.getDelayedChannel=U;function x(_){let A=!1;return{call(F,z,ee){return A?_.call(F,z,ee):(0,t.timeout)(0).then(()=>A=!0).then(()=>_.call(F,z,ee))},listen(F,z){if(A)return _.listen(F,z);const ee=new h.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ee.input=_.listen(F,z)),ee.event}}}e.getNextTickChannel=x;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const F of A.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await h.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var le;(function(_){function A(B,H){const L=B,O=H&&H.disableMarshalling,N=new Map;for(const V in L)z(V)&&N.set(V,h.Event.buffer(L[V],!0));return new class{listen(V,Q,ne){const j=N.get(Q);if(j)return j;if(ee(Q)){const te=L[Q];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${Q}`)}call(V,Q,ne){const j=L[Q];if(typeof j=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,C.revive)(ne[te]);return j.apply(L,ne)}throw new Error(`Method not found: ${Q}`)}}}_.fromService=A;function F(B,H){const L=H&&H.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return H?.properties?.has(N)?H.properties.get(N):ee(N)?function(V){return B.listen(N,V)}:z(N)?B.listen(N):async function(...V){let Q;H&&!(0,y.isUndefinedOrNull)(H.context)?Q=[H.context,...V]:Q=V;const ne=await B.call(N,Q);return L?ne:(0,C.revive)(ne)};throw new Error(`Property not found: ${String(N)}`)}})}_.toService=F;function z(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function ee(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const A=_.toString();if(A!=="[object Object]")return A}return _}function de(_){return Array.isArray(_)?_.map(se):se(_)}function K(_,A,F,z,ee,B,H){H=de(H);const L=ue[ee],O=L[z%L.length];let N=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(N=N.concat(H),N.push(")")):N.push(H),console.log.apply(console,N)}e.logWithColors=K;class ${constructor(A,F){this._outgoingPrefix=A,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,F,z,ee,B){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,F,z,ee,B)}logIncoming(A,F,z,ee,B){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,F,z,ee,B)}}e.IPCLogger=$}),define(J[146],Z([0,1,17,3,45]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(h){this.port=h,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(h,m){const C=new R(h);super(C,m);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=D}),define(J[98],Z([0,1,17,3,2,45]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var v;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let a=0;function l(M,T){if(!o.has(M)){const W=String(++a);o.set(M,W)}return o.get(M)}function P(M,T,W,U){if(!n.enableDiagnostics)return;const x=l(M,T);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=w.VSBuffer.alloc(U.byteLength);re.set(U),n.records.push({timestamp:Date.now(),id:x,label:T,type:W,buff:re})}else n.records.push({timestamp:Date.now(),id:x,label:T,type:W,data:U})}n.traceSocketEvent=P})(v=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function C(){return m||(m=w.VSBuffer.alloc(0)),m}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return C();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),T}if(this._chunks[0].byteLength>o){const T=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),T}const l=w.VSBuffer.alloc(o);let P=0,M=0;for(;o>0;){const T=this._chunks[M];if(T.byteLength>o){const W=T.slice(0,o);l.set(W,P),P+=o,a&&(this._chunks[M]=T.slice(o),this._totalLength-=o),o-=o}else l.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,o-=T.byteLength}return l}}e.ChunkStream=I;var y;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(y||(y={}));function g(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(o,a,l,P){this.type=o,this.id=a,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new E(l,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=w.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const l=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,l}_bufferTake(){const o=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class S extends k.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new E(1,0,0,o))}}e.Protocol=S;class f extends R.IPCClient{constructor(o,a,l=null){super(o,a,l);this.protocol=o}static fromSocket(o,a){return new f(new S(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=f;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}length(){let o=0,a=this._first;for(;a;)a=a.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,l=this._first;for(;l;)o[a++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new c(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<s._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=s._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),a=(1+s._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<s._HISTORY_LENGTH;P++)o-this.lastRuns[P]<=a&&l++;return 1-l/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class i{constructor(o,a=null,l=s.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new E(5,0,0,C());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new E(7,0,0,C());this._socketWriter.write(o)}sendResume(){const o=new E(8,0,0,C());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,C());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new E(6,0,0,C())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new E(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const a=new E(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-a,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,C());this._socketWriter.write(o)}_sendKeepAlive(){const o=new E(9,0,0,C());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(J[147],Z([0,1,40,17,3,2,45,132]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(C,I){const y=k.Event.fromNodeEventEmitter(w.validatedIpcMain,I,(d,E)=>({event:d,message:E})),g=k.Event.filter(y,({event:d})=>d.sender.id===C);return k.Event.map(g,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends D.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:hello",({sender:y})=>y);return k.Event.map(I,y=>{const g=y.id;m.Clients.get(g)?.dispose();const E=new k.Emitter;m.Clients.set(g,(0,R.toDisposable)(()=>E.fire()));const b=h(g,"vscode:message"),p=k.Event.any(k.Event.signal(h(g,"vscode:disconnect")),E.event);return{protocol:new v.Protocol(y,b),onDidClientDisconnect:p}})}}e.Server=m,m.Clients=new Map}),define(J[99],Z([0,1,40,3,28,146]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(m,C){super({addEventListener:(I,y)=>m.addListener(I,y),removeEventListener:(I,y)=>m.removeListener(I,y),postMessage:I=>m.postMessage(I),start:()=>m.start(),close:()=>m.close()},C)}}e.Client=D;async function v(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();h.webContents.send("vscode:createMessageChannel",m);const C=t.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:I}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,y=>y.nonce===m)));return I}e.connect=v}),define(J[148],Z([0,1,51,8,17,22,141,18,3,2,50,82,78,45]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends g.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class E{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(p){const S=this;return{call(f,u,c){return S.requestPromise(p,f,u,c)},listen(f,u){return S.requestEvent(p,f,u)}}}requestPromise(p,S,f,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),r=(0,t.createCancelablePromise)(n=>c.call(S,f,n)),s=u.onCancellationRequested(()=>r.cancel()),i=(0,m.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(p,S,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const c=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(p).listen(S,f)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(S.env),this.child=(0,w.fork)(this.modulePath,p,S);const f=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),s=f.event,i={send:r,onMessage:s};this._client=new g.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,m.dispose)(l)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(J[83],Z([0,1,17,18,3,2,9,4,28,45,98]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class y{constructor(l,P=""){this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,P){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(w.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{this.traceSocketEvent("close",{hadError:M}),l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=y;var g;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class E extends R.Disposable{constructor(l,P,M,T){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new b(this,P,M,T,this._onData,(W,U)=>this._write(W,U))),this._register(this._flowManager.onError(W=>{console.error(W),(0,t.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const T=w.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let W=1;T.writeUInt8(l.byteLength>>>8&255,++W),T.writeUInt8(l.byteLength>>>0&255,++W)}else{T.writeUInt8(127,1);let W=1;T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(0,++W),T.writeUInt8(l.byteLength>>>24&255,++W),T.writeUInt8(l.byteLength>>>16&255,++W),T.writeUInt8(l.byteLength>>>8&255,++W),T.writeUInt8(l.byteLength>>>0&255,++W)}this.socket.write(w.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,W=(M&64)>>>6,U=P.readUInt8(1),x=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let W=M&127,U=1;W===126?W=P.readUInt8(++U)*2**8+P.readUInt8(++U):W===127&&(W=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let x=0;T&&(x=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=W,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),f(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class b extends R.Disposable{constructor(l,P,M,T,W,U){super();this._tracer=l,this._onData=W,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new p(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:w.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,T)=>{l.write(P),l.flush(W=>M(W))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((T,W)=>{l.write(P),M&&l.write(w.VSBuffer.fromByteArray([0,0,255,255])),l.flush(U=>T(U))})}}class p extends R.Disposable{constructor(l,P,M,T){super();this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(T),this._zlibInflate.on("error",W=>{this._tracer.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this._onError.fire(W)}),this._zlibInflate.on("data",W=>{this._tracer.traceSocketEvent("zlibInflateData",W),this._pendingInflateData.push(w.VSBuffer.wrap(W))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?w.VSBuffer.concat(this._recordedInflateBytes):w.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=w.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class S extends R.Disposable{constructor(l,P){super();this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(w.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=w.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function f(a,l){if(l===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const le=a.readUInt32BE(re*4);a.writeUInt32BE(le^l,re*4)}const M=P*4,T=a.byteLength-M,W=l>>>24&255,U=l>>>16&255,x=l>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(M)^W,M),T>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),T>=3&&a.writeUInt8(a.readUInt8(M+2)^x,M+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const a=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(I().os.tmpdir(),`vscode-ipc-${a}.sock`),s(l),l}e.createRandomIPCHandle=c;function r(a,l,P){const M=I().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):T=(0,D.join)(a,`${P}-${l}.sock`),s(T),T}e.createStaticIPCHandle=r;function s(a){const l=u[v.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new C.Protocol(new y(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(a){return new Promise((l,P)=>{const M=I().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),l(new i(M))})})}e.serve=n;function o(a,l){return new Promise((P,M)=>{const T=I().net.createConnection(a,()=>{T.removeListener("error",M),P(C.Client.fromSocket(new y(T,`ipc-client${l}`),l))});T.once("error",M)})}e.connect=o}),define(J[100],Z([0,1,8,3,2,12]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function v(I){const y=I;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=v;var h;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(y,g=Object.create(null)){super();this.database=y,this.options=g,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((g,d)=>this.accept(d,g)),y.deleted?.forEach(g=>this.accept(g,void 0))}accept(y,g){if(this.state===h.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(g)?d=this.cache.delete(y):this.cache.get(y)!==g&&(this.cache.set(y,g),d=!0),d&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,g){const d=this.cache.get(y);return(0,R.isUndefinedOrNull)(d)?g:d}getBoolean(y,g){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?g:d==="true"}getNumber(y,g){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?g:parseInt(d,10)}async set(y,g){if(this.state===h.Closed)return;if((0,R.isUndefinedOrNull)(g))return this.delete(y);const d=String(g);if(this.cache.get(y)!==d)return this.cache.set(y,d),this.pendingInserts.set(y,d),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===h.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((g,d)=>this.items.set(d,g)),y.delete?.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=C}),define(J[149],Z([0,1,8,3,32,9,23]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class v{constructor(C,I=Object.create(null)){this.path=C,this.options=I,this.name=(0,R.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const C=await this.whenConnected,I=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(g=>I.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(C){const I=await this.whenConnected;return this.doUpdateItems(I,C)}doUpdateItems(C,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(C,()=>{const y=I.insert,g=I.delete;if(y&&y.size>0){const d=[];d.push([]);let E=0;y.forEach((b,p)=>{let S=d[E];S.length>v.MAX_HOST_PARAMETERS&&(E++,S=[],d.push(S)),S.push(p,b)}),d.forEach(b=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let S=0;return y.forEach((f,u)=>{p.push(u),S+=f.length}),`Keys: ${p.join(", ")} Length: ${S}`})})}if(g&&g.size){const d=[];d.push([]);let E=0;g.forEach(b=>{let p=d[E];p.length>v.MAX_HOST_PARAMETERS&&(E++,p=[],d.push(p)),p.push(b)}),d.forEach(b=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return g.forEach(S=>{p.push(S)}),`Keys: ${p.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,C)}doClose(C,I){return new Promise((y,g)=>{C.db.close(d=>(d&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${d}`),this.path===v.IN_MEMORY_PATH?y():!C.isErroneous&&!C.isInMemory?this.backup().then(y,E=>(this.logger.error(`[storage ${this.name}] backup(): ${E}`),y())):typeof I=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(E=>{const b=()=>this.doClose(E,void 0);return this.doUpdateItems(E,{insert:I()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(y,g):g(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return D.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const I=await this.whenConnected,y=await this.get(I,C?"PRAGMA integrity_check":"PRAGMA quick_check"),g=C?y.integrity_check:y.quick_check;return I.isErroneous?`${g} (last error: ${I.lastError})`:I.isInMemory?`${g} (in-memory!)`:g}async connect(C,I=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${I})`);try{return await this.doConnect(C)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&I)return await(0,w.timeout)(v.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await D.Promises.unlink(C);try{await D.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(v.IN_MEMORY_PATH)}}}handleSQLiteError(C,I){C.isErroneous=!0,C.lastError=I,this.logger.error(I)}doConnect(C){return new Promise((I,y)=>{new Promise((g,d)=>{q(["@vscode/sqlite3"],g,d)}).then(g=>{const d={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(C,E=>E?d.db&&E.code!=="SQLITE_CANTOPEN"?d.db.close(()=>y(E)):y(E):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(d),b=>d.db.close(()=>y(b)))),isInMemory:C===v.IN_MEMORY_PATH};d.db.on("error",E=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${E}`)),this.logger.isTracing&&d.db.on("trace",E=>this.logger.trace(`[storage ${this.name}] Trace (event): ${E}`))},y)})}exec(C,I){return new Promise((y,g)=>{C.db.exec(I,d=>d?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${d}`),g(d)):y())})}get(C,I){return new Promise((y,g)=>{C.db.get(I,(d,E)=>d?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${d}`),g(d)):y(E))})}all(C,I){return new Promise((y,g)=>{C.db.all(I,(d,E)=>d?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${d}`),g(d)):y(E))})}transaction(C,I){return new Promise((y,g)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),I(),C.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${d}`),g(d)):y())})})}prepare(C,I,y,g){const d=C.db.prepare(I),E=b=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${g()}`)};d.on("error",E),y(d),d.finalize(b=>{b&&E(b),d.removeListener("error",E)})}}e.SQLiteStorageDatabase=v,v.IN_MEMORY_PATH=":memory:",v.BUSY_OPEN_TIMEOUT=2e3,v.MAX_HOST_PARAMETERS=256;class h{constructor(C){C&&typeof C.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[150],Z([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[151],Z([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[152],Z([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[153],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[154],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[155],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[156],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(J[157],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(J[158],Z([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[159],Z([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[160],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[161],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[162],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[163],Z([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[164],Z([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[165],Z([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[166],Z([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[167],Z([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[168],Z([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[169],Z([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(J[170],Z([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[171],Z([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[172],Z([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[173],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(J[174],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[175],Z([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(J[176],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[177],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[178],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(J[179],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(J[180],Z([0,1,3,2]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(v,h,m){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(v,h,m){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(v){super();this.channel=v}reload(v){this.channel.call("reload",[v])}get onReload(){return this.channel.listen("reload")}close(v){this.channel.call("close",[v])}get onClose(){return this.channel.listen("close")}attachSession(v,h,m){this.channel.call("attach",[v,h,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(v,h){this.channel.call("terminate",[v,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(v,h){return this.channel.call("openExtensionDevelopmentHostWindow",[v,h])}}e.ExtensionHostDebugChannelClient=R}),define(J[181],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=w}),define(J[182],Z([0,1,135,52,13,9,34,16,7]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(E,b,p){this._args=E,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(h.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,R.resolve)(E):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,R.resolve)(E):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,R.resolve)(E);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=D.env.VSCODE_PORTABLE;return E?h.URI.file((0,R.join)(E,"policy.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function C(d,E){return g(d["inspect-extensions"],d["inspect-brk-extensions"],5870,E,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=C;function I(d,E){return g(d["inspect-search"],d["inspect-brk-search"],5876,E,d.extensionEnvironment)}e.parseSearchPort=I;function y(d,E){return g(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,E,d.extensionEnvironment)}e.parsePtyHostPort=y;function g(d,E,b,p,S,f){const c=Number(E||d)||(p?null:b),r=c?Boolean(!!E):!1;let s;if(f)try{s=JSON.parse(f)}catch{}return{port:c,break:r,debugId:S,env:s}}}),define(J[101],Z([0,1,272,4,153]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function v(d,E,b=D){const p={},S=["_"],f=[];for(const s in E){const i=E[s];i.alias&&(p[s]=i.alias),i.type==="string"||i.type==="string[]"?(S.push(s),i.deprecates&&S.push(...i.deprecates)):i.type==="boolean"&&(f.push(s),i.deprecates&&f.push(...i.deprecates))}const u=w(d,{string:S,boolean:f,alias:p}),c={},r=u;c._=u._.map(s=>String(s)).filter(s=>s.length>0),delete r._;for(const s in E){const i=E[s];i.alias&&delete r[i.alias];let n=r[s];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(n||(n=r[o],n&&b.onDeprecatedOption(o,i.deprecationMessage||(0,k.localize)(35,null,s))),delete r[o]);if(typeof n!="undefined"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const o=n.filter(a=>a.length>0);o.length!==n.length&&(b.onEmptyValue(s),n=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),b.onMultipleValues(s,n)):!n&&!i.allowEmptyValue&&(b.onEmptyValue(s),n=void 0));c[s]=n,i.deprecationMessage&&b.onDeprecatedOption(s,i.deprecationMessage)}delete r[s]}for(const s in r)b.onUnknownOption(s);return c}e.parseArgs=v;function h(d,E){let b="";return E.args&&(Array.isArray(E.args)?b=` <${E.args.join("> <")}>`:b=` <${E.args}>`),E.alias?`-${E.alias} --${d}${b}`:`--${d}${b}`}function m(d,E){let b=0;const p=[];for(const c in d){const r=d[c],s=h(c,r);b=Math.max(b,s.length),p.push([s,r.description])}const S=b+2+1;if(E-S<25)return p.reduce((c,r)=>c.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const f=E-S-1,u=[];for(const c of p){const r=c[0],s=I(c[1],f),i=C(S-r.length-2);u.push("  "+r+i+s[0]);for(let n=1;n<s.length;n++)u.push(C(S)+s[n])}return u}e.formatOptions=m;function C(d){return" ".repeat(d)}function I(d,E){const b=[];for(;d.length;){const p=d.length<E?d.length:d.lastIndexOf(" ",E),S=d.slice(0,p).trim();d=d.slice(p),b.push(S)}return b}function y(d,E,b,p,S){const f=process.stdout.isTTY&&process.stdout.columns||80,u=S?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${b}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${E} [${(0,k.localize)(38,null)}]${u}`),c.push(""),S?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,E)):c.push((0,k.localize)(40,null,E)),c.push(""));const r={};for(const s in p){const i=p[s];if(i.description&&i.cat){let n=r[i.cat];n||(r[i.cat]=n={}),n[s]=i}}for(const s in r){const i=s,n=r[i];n&&(c.push(R[i]),c.push(...m(n,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=y;function g(d,E){return`${d||(0,k.localize)(41,null)}
${E||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=g}),define(J[183],Z([0,1,77,180,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(v,h){super();this.windowsMainService=v,this.userDataProfilesMainService=h}call(v,h,m){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(v,h,m)}async openExtensionDevelopmentHostWindow(v,h){const m=(0,k.parseArgs)(v,k.OPTIONS);m.debugRenderer=h;const C=m.extensionDevelopmentPath;if(!C)return{success:!1};const I=this.userDataProfilesMainService.checkAndCreateProfileFromCli(m);I&&await I;const[y]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:m});if(!h)return{success:!0};const g=y.win;if(!g)return{success:!0};const d=g.webContents.debugger;let E=d.isAttached()?1/0:0;const b=(0,w.createServer)(p=>{E++==0&&d.attach();let S=!1;const f=r=>{S||p.write(JSON.stringify(r)+"\0")},u=(r,s,i,n)=>f({method:s,params:i,sessionId:n});g.on("close",()=>{d.removeListener("message",u),p.end(),S=!0}),d.addListener("message",u);let c=Buffer.alloc(0);p.on("data",r=>{c=Buffer.concat([c,r]);for(let s=c.indexOf(0);s!==-1;s=c.indexOf(0)){let i;try{const n=c.slice(0,s).toString("utf8");c=c.slice(s+1),i=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}d.sendCommand(i.method,i.params,i.sessionId).then(n=>f({id:i.id,sessionId:i.sessionId,result:n})).catch(n=>f({id:i.id,sessionId:i.sessionId,error:{code:0,message:n.message}}))}}),p.on("error",r=>{console.error("error on cdp pipe:",r)}),p.on("close",()=>{S=!0,--E==0&&d.detach()})});return await new Promise(p=>b.listen(0,p)),g.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(J[59],Z([0,1,273,154,101]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(y,g){const d={onUnknownOption:b=>{console.warn((0,t.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,t.localize)(1,null,b,p))},onEmptyValue:b=>{console.warn((0,t.localize)(2,null,b))},onDeprecatedOption:(b,p)=>{console.warn((0,t.localize)(3,null,b,p))}},E=(0,k.parseArgs)(y,k.OPTIONS,g?d:void 0);return E.goto&&E._.forEach(b=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,t.localize)(4,null))),E["max-memory"]&&w(parseInt(E["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),E}function v(y){const g=y.findIndex(d=>!/^-/.test(d));if(g>-1)return[...y.slice(0,g),...y.slice(g+1)]}function h(y){let[,...g]=y;process.env.VSCODE_DEV&&(g=v(g)||[]);const d=!I(process.env);return D(g,d)}e.parseMainProcessArgv=h;function m(y){const[,,...g]=y;return D(g,!0)}e.parseCLIProcessArgv=m;function C(y,...g){const d=y.indexOf("--");return d===-1?y.push(...g):y.splice(d,0,...g),y}e.addArg=C;function I(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function q(e,w,t,k){function R(v){const h=D(v),m=[h];return e.isAbsolute(h)||m.unshift(k),e.resolve(...m)}function D(v){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const C=v["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(J[102],Z([0,274,30,13,16,34]),function(e,w,t,k,R,D){const v=R.dirname(k.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return q(w,t,h.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),t=require("os");module.exports=q(w,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[184],Z([0,1,30,182,102]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(v,h){super(v,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(v)},h)}}e.NativeEnvironmentService=R}),define(J[185],Z([0,1,29,30,31]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const v=(0,k.randomPath)((0,t.tmpdir)());try{return(0,w.writeFileSync)(v,""),D&&console.log(`Marker file for --wait created: ${v}`),v}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=R}),define(J[186],Z([0,1,12,156]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,v,h){try{R(D,v,h)}catch{}return D}e.localizeManifest=k;function R(D,v,h){const m=(C,I,y)=>{const g=C[I];if((0,w.isString)(g)){const d=g,E=d.length;if(E>1&&d[0]==="%"&&d[E-1]==="%"){const b=d.substr(1,E-2);let p=v[b];p===void 0&&h&&(p=h[b]);const S=typeof p=="string"?p:p.message;if(S!==void 0){const f=h?.[b],u=typeof f=="string"?f:f?.message;if(y&&(I==="title"||I==="category")&&u&&u!==S){const c={value:S,original:u};C[I]=c}else C[I]=S}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,b)}`)}}else if((0,w.isObject)(g))for(const d in g)g.hasOwnProperty(d)&&(d==="commands"?m(g,d,!0):m(g,d,y));else if(Array.isArray(g))for(let d=0;d<g.length;d++)m(g,d,y)};for(const C in D)D.hasOwnProperty(C)&&m(D,C)}}),define(J[187],Z([0,1,16,94,158,188]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function h(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=h;function m(p){if(!h(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=p.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=m;function C(p){if(!p)return null;const S=p.majorBase,f=p.majorMustEqual,u=p.minorBase;let c=p.minorMustEqual;const r=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(S===0||(c=!1),s=!1);let i=0;if(p.preRelease){const n=v.exec(p.preRelease);if(n){const[,o,a,l]=n;i=Date.UTC(Number(o),Number(a)-1,Number(l))}}return{majorBase:S,majorMustEqual:f,minorBase:u,minorMustEqual:c,patchBase:r,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:i}}e.normalizeVersion=C;function I(p,S,f){let u;typeof p=="string"?u=C(m(p)):u=p;let c;S instanceof Date?c=S.getTime():typeof S=="string"&&(c=new Date(S).getTime());let r;if(typeof f=="string"?r=C(m(f)):r=f,!u||!r)return!1;const s=u.majorBase,i=u.minorBase,n=u.patchBase;let o=r.majorBase,a=r.minorBase,l=r.patchBase;const P=r.notBefore;let M=r.majorMustEqual,T=r.minorMustEqual,W=r.patchMustEqual;return r.isMinimum?s>o?!0:s<o?!1:i>a?!0:i<a||c&&c<P?!1:n>=l:(s===1&&o===0&&(!M||!T||!W)&&(o=1,a=0,l=0,M=!0,T=!1,W=!1),s<o?!1:s>o?!M:i<a?!1:i>a?!T:n<l?!1:n>l?!W:!(c&&c<P))}e.isValidVersion=I;function y(p,S,f,u,c){const r=[];if(typeof u.publisher!="undefined"&&typeof u.publisher!="string")return r.push([t.default.Error,k.localize(0,null)]),r;if(typeof u.name!="string")return r.push([t.default.Error,k.localize(1,null,"name")]),r;if(typeof u.version!="string")return r.push([t.default.Error,k.localize(2,null,"version")]),r;if(!u.engines)return r.push([t.default.Error,k.localize(3,null,"engines")]),r;if(typeof u.engines.vscode!="string")return r.push([t.default.Error,k.localize(4,null,"engines.vscode")]),r;if(typeof u.extensionDependencies!="undefined"&&!b(u.extensionDependencies))return r.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),r;if(typeof u.activationEvents!="undefined"){if(!b(u.activationEvents))return r.push([t.default.Error,k.localize(6,null,"activationEvents")]),r;if(typeof u.main=="undefined"&&typeof u.browser=="undefined")return r.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),r}if(typeof u.extensionKind!="undefined"&&typeof u.main=="undefined"&&r.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main!="undefined"){if(typeof u.main!="string")return r.push([t.default.Error,k.localize(9,null,"main")]),r;{const n=(0,w.joinPath)(f,u.main);(0,w.isEqualOrParent)(n,f)||r.push([t.default.Warning,k.localize(10,null,n.path,f.path)])}if(typeof u.activationEvents=="undefined")return r.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),r}if(typeof u.browser!="undefined"){if(typeof u.browser!="string")return r.push([t.default.Error,k.localize(12,null,"browser")]),r;{const n=(0,w.joinPath)(f,u.browser);(0,w.isEqualOrParent)(n,f)||r.push([t.default.Warning,k.localize(13,null,n.path,f.path)])}if(typeof u.activationEvents=="undefined")return r.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),r}if(!R.valid(u.version))return r.push([t.default.Error,k.localize(15,null)]),r;const s=[];if(!g(p,S,u,c,s))for(const n of s)r.push([t.default.Error,n]);return r}e.validateExtensionManifest=y;function g(p,S,f,u,c){return u||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:E(p,S,f.engines.vscode,c)}e.isValidExtensionVersion=g;function d(p,S,f){return p==="*"||E(S,f,p)}e.isEngineValid=d;function E(p,S,f,u=[]){const c=C(m(f));if(!c)return u.push(k.localize(16,null,f)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return u.push(k.localize(17,null,f)),!1}else if(!c.majorMustEqual)return u.push(k.localize(18,null,f)),!1;return I(p,S,c)?!0:(u.push(k.localize(19,null,p,f)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let S=0,f=p.length;S<f;S++)if(typeof p[S]!="string")return!1;return!0}}),define(J[189],Z([0,1,17,28]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,v){let h=v&&v.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const C=(await D.readFile(R.serviceMachineIdResource)).value.toString();h=(0,t.isUUID)(C)?C:null}catch{h=null}if(!h){h=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,w.VSBuffer.fromString(h))}catch{}}return v?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(J[68],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w}),define(J[190],Z([0,1,68]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,v,h){v instanceof w.SyncDescriptor||(v=new w.SyncDescriptor(v,[],h)),t.push([D,v])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(J[191],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=w;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const v=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(D);v.outgoing.set(this._hashFn(D),h),h.incoming.set(this._hashFn(R),v)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const v of this._nodes.values())v.outgoing.delete(D),v.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let v=this._nodes.get(D);return v||(v=new w(R),this._nodes.set(D,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,v]of this._nodes)R.push(`${D}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const v=new Set([R]),h=this._findCycle(D,v);if(h)return h}}_findCycle(R,D){for(const[v,h]of R.outgoing){if(D.has(v))return[...D,v].join(" -> ");D.add(v);const m=this._findCycle(h,D);if(m)return m;D.delete(v)}}}e.Graph=t}),define(J[5],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function v(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=v})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,v,h){v[w.DI_TARGET]===v?v[w.DI_DEPENDENCIES].push({id:D,index:h}):(v[w.DI_DEPENDENCIES]=[{id:D,index:h}],v[w.DI_TARGET]=v)}function k(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const v=function(h,m,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(v,h,C)};return v.toString=()=>D,w.serviceIds.set(D,v),v}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(J[60],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(J[19],Z([0,1,12,7,5]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var v;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function m(p,S){const f=Object.create(null);for(const u in p)C(f,u,p[u],S);return f}e.toValuesTree=m;function C(p,S,f,u){const c=S.split("."),r=c.pop();let s=p;for(let i=0;i<c.length;i++){const n=c[i];let o=s[n];switch(typeof o){case"undefined":o=s[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${S} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[r]=f}catch{u(`Ignoring ${S} as ${c.join(".")} is ${JSON.stringify(s)}`)}else u(`Ignoring ${S} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=C;function I(p,S){const f=S.split(".");y(p,f)}e.removeFromValueTree=I;function y(p,S){const f=S.shift();if(S.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const u=p[f];typeof u=="object"&&!Array.isArray(u)&&(y(u,S),Object.keys(u).length===0&&delete p[f])}}function g(p,S,f){function u(s,i){let n=s;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=S.split("."),r=u(p,c);return typeof r=="undefined"?f:r}e.getConfigurationValue=g;function d(p,S,f){Object.keys(S).forEach(u=>{u!=="__proto__"&&(u in p?w.isObject(p[u])&&w.isObject(S[u])?d(p[u],S[u],f):f&&(p[u]=S[u]):p[u]=S[u])})}e.merge=d;function E(p,S,f){const u=p.inspect(S),c=p.inspect(f);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=E;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(J[69],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,v){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=v}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const v of Object.keys(this.secretVault[R]||{}))D.push({account:v,password:this.secretVault[R][v]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(J[84],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,v){return{}}async getSystemInfo(D,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,v){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(J[103],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(J[36],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[26],Z([0,1,52,9,83,36,184,5]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,v.refineServiceDecorator)(R.IEnvironmentService);class h extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([w.memoize],h.prototype,"cachedLanguagesPath",null),ve([w.memoize],h.prototype,"backupHome",null),ve([w.memoize],h.prototype,"backupWorkspacesPath",null),ve([w.memoize],h.prototype,"mainIPCHandle",null),ve([w.memoize],h.prototype,"mainLockfile",null),ve([w.memoize],h.prototype,"disableUpdates",null),ve([w.memoize],h.prototype,"disableKeytar",null),ve([w.memoize],h.prototype,"codeCachePath",null),ve([w.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(J[192],Z([0,1,155,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,S){switch(p){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function v(p,S){return S==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=v;function h(p,S,f){return v(S,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:m(f).includes(p)}e.isTargetPlatformCompatible=h;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C;var I;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var y;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var E;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(S,f){super(S);this.code=f,this.name=f}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(J[193],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[194],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[104],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[195],Z([0,1,51,13,9,4,78,23,82,159,104]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{openTerminal(u,c){return this.spawnTerminal(w,u,h.getWindowsShell(),c)}spawnTerminal(u,c,r,s){const i=c.windowsExec||g.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((a,l)=>{const P=b(process),M=u.spawn(r,o,{cwd:s,env:P});M.on("error",l),M.on("exit",()=>a())})}runInTerminal(u,c,r,s,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((o,a)=>{const l=`"${c} - ${I}"`,P=`""${r.join('" "')}" & pause"`,M=["/c","start",l,"/wait",n,"/c",P],T=Object.assign({},b(process),s);Object.keys(T).filter(x=>T[x]===null).forEach(x=>delete T[x]);const W={cwd:c,env:T,windowsVerbatimArguments:!0};w.spawn(g.CMD,M,W).on("error",x=>{a(p(x))}),o(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends y{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,r,s,i){const n=i.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(n===C.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,q).fsPath,"-t",u||I,"-w",c];for(const U of r)M.push("-a"),M.push(U);if(s){const U=Object.assign({},b(process),s);for(const x in U){const re=U[x];re===null?(M.push("-u"),M.push(x)):(M.push("-e"),M.push(`${x}=${re}`))}}let T="";const W=w.spawn(d.OSASCRIPT,M);W.on("error",U=>{a(p(U))}),W.stderr.on("data",U=>{T+=U.toString()}),W.on("exit",U=>{if(U===0)o(void 0);else if(T){const x=T.split(`
`,1);a(new Error(x[0]))}else a(new Error(m.localize(1,null,l,U)))})}else a(new Error(m.localize(2,null,n)))})}spawnTerminal(u,c,r){const s=c.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",s];r&&o.push(r);const a=b(process),l=u.spawn("/usr/bin/open",o,{cwd:r,env:a});l.on("error",n),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class E extends y{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,r,s,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const l=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${S(r)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const T=Object.assign({},b(process),s);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const W={cwd:c,env:T};let U="";const x=w.spawn(P,l,W);x.on("error",re=>{a(p(re))}),x.stderr.on("data",re=>{U+=re.toString()}),x.on("exit",re=>{if(re===0)o(void 0);else if(U){const le=U.split(`
`,1);a(new Error(le[0]))}else a(new Error(m.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await v.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,r){const s=c.linuxExec?Promise.resolve(c.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{s.then(o=>{const a=b(process),l=u.spawn(o,[],{cwd:r,env:a});l.on("error",n),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=E,E.WAIT_MESSAGE=m.localize(3,null);function b(f){const u={...f.env};return(0,D.sanitizeProcessEnvironment)(u),u}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function S(f){let u="";for(const c of f)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(J[14],Z([0,1,32,9,25,12,7,161,5]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var C;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var I;(function(K){K[K.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var y;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=g;function d(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=d;function E(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=E;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=p;function S(K){return g(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var f;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor($,_){super($);this.code=_}}e.FileSystemProviderError=u;function c(K,$){const _=new u(K.toString(),$);return s(_,$),_}e.createFileSystemProviderError=c;function r(K){return K||c((0,v.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=r;function s(K,$){return K.name=$?`${$} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=s;function i(K){if(!K)return f.Unknown;if(K instanceof u)return K.code;const $=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!$)return f.Unknown;switch($[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=i;function n(K){if(K instanceof T)return K.fileOperationResult;switch(i(K)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor($,_,A){this.resource=$,this.operation=_,this.target=A}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var l;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class P{constructor($,_){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const A=new Map;for(const F of $){const z=A.get(F.type);switch(z?z.push([F.resource,F]):A.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,z]of A)switch(F){case 1:this.added=w.TernarySearchTree.forUris(()=>_),this.added.fill(z);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>_),this.updated.fill(z);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>_),this.deleted.fill(z);break}}contains($,..._){return this.doContains($,{includeChildren:!1},..._)}affects($,..._){return this.doContains($,{includeChildren:!0},..._)}doContains($,_,...A){if(!$)return!1;const F=A.length>0;return!!((!F||A.includes(1))&&(this.added?.get($)||_.includeChildren&&this.added?.findSuperstr($))||(!F||A.includes(0))&&(this.updated?.get($)||_.includeChildren&&this.updated?.findSuperstr($))||(!F||A.includes(2))&&(this.deleted?.findSubstr($)||_.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function M(K,$,_){return!K||!$||K===$||$.length>K.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),_?(0,k.startsWithIgnoreCase)(K,$):K.indexOf($)===0)}e.isParent=M;class T extends Error{constructor($,_,A){super($);this.fileOperationResult=_,this.options=A}}e.FileOperationError=T;class W extends T{constructor($,_,A){super($,2,A);this.stat=_}}e.NotModifiedSinceFileOperationError=W;var U;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=re;async function le(K,$){if(!$.hasProvider(D.URI.from({scheme:K.scheme})))return new Promise(_=>{const A=$.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===K.scheme&&F.added&&(A.dispose(),_())})})}e.whenProviderRegistered=le,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize($){return(0,R.isNumber)($)||($=0),$<ue.KB?(0,v.localize)(1,null,$.toFixed(0)):$<ue.MB?(0,v.localize)(2,null,($/ue.KB).toFixed(2)):$<ue.GB?(0,v.localize)(3,null,($/ue.MB).toFixed(2)):$<ue.TB?(0,v.localize)(4,null,($/ue.GB).toFixed(2)):(0,v.localize)(5,null,($/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function de(K){return{maxFileSize:K===0?300*ue.MB:16*ue.GB,maxHeapSize:K===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=de}),define(J[196],Z([0,1,17,44,18,3,2,58,7,28,14]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends D.Disposable{constructor(g,d){super();this.channel=g,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,d){const{buffer:E}=await this.channel.call("readFile",[g,d]);return E}readFileStream(g,d,E){const b=(0,v.newWriteableStream)(S=>w.VSBuffer.concat(S.map(f=>w.VSBuffer.wrap(f))).buffer),p=this.channel.listen("readFileStream",[g,d])(S=>{if(S instanceof w.VSBuffer)b.write(S.buffer);else{if(S==="end")b.end();else{let f=S;f instanceof Error||(f=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(f),C.FileSystemProviderErrorCode.Unknown)),b.error(f),b.end()}p.dispose()}});return E.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),p.dispose()}),b}writeFile(g,d,E){return this.channel.call("writeFile",[g,w.VSBuffer.wrap(d),E])}open(g,d){return this.channel.call("open",[g,d])}close(g){return this.channel.call("close",[g])}async read(g,d,E,b,p){const[S,f]=await this.channel.call("read",[g,d,p]);return E.set(S.buffer.slice(0,f),b),f}write(g,d,E,b,p){return this.channel.call("write",[g,d,w.VSBuffer.wrap(E),b,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,d){return this.channel.call("delete",[g,d])}rename(g,d,E){return this.channel.call("rename",[g,d,E])}copy(g,d,E){return this.channel.call("copy",[g,d,E])}cloneFile(g,d){return this.channel.call("cloneFile",[g,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const d=g;this._onDidChange.fire(d.map(E=>({resource:h.URI.revive(E.resource),type:E.type})))}else{const d=g;this._onDidWatchError.fire(d)}}))}watch(g,d){const E=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,E,g,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=I}),define(J[105],Z([0,1,17,18,162,14]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(C,I,y,g,d,E){let b;try{await v(C,I,y,g,d,E)}catch(p){b=p}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b!="undefined"&&y.error(b),y.end()}}e.readFileIntoStream=D;async function v(C,I,y,g,d,E){h(E);const b=await C.open(I,{create:!1});try{h(E);let p=0,S=0,f=d&&typeof d.length=="number"?d.length:void 0,u=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,r=0;do S=await C.read(b,c,u.buffer,r,u.byteLength-r),c+=S,r+=S,p+=S,typeof f=="number"&&(f-=S),r===u.byteLength&&(await y.write(g(u)),u=w.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),r=0);while(S>0&&(typeof f!="number"||f>0)&&h(E)&&m(p,d));if(r>0){let s=r;typeof f=="number"&&(s=Math.min(r,f)),y.write(g(u.slice(0,s)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await C.close(b)}}function h(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function m(C,I){if(I?.limits){if(typeof I.limits.memory=="number"&&C>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&C>I.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[70],Z([0,1,95,2,9,4,7,14]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(p){return p.recursive===!0}e.isRecursiveWatchRequest=h;class m extends t.Disposable{constructor(S,f,u,c){super();this.onFileChanges=S,this.onLogMessage=f,this.verboseLogging=u,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),S.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),S.add(this.watcher.onDidError(f=>this.onError(f)))}onError(S){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class C extends m{constructor(S,f,u){super(S,f,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class I extends m{constructor(S,f,u){super(S,f,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function y(p){return p.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=y;function g(p){const S=new b;for(const f of p)S.processEvent(f);return S.coalesce()}e.coalesceEvents=g;function d(p,S){return typeof S=="string"&&!S.startsWith(w.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:p,pattern:S}:S}e.normalizeWatcherPattern=d;function E(p,S){const f=[];for(const u of S)f.push((0,w.parse)(d(p,u)));return f}e.parseWatcherPatterns=E;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const f=this.mapPathToChange.get(this.toKey(S));let u=!1;if(f){const c=f.type,r=S.type;f.path!==S.path&&(S.type===2||S.type===1)?u=!0:c===1&&r===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(f)):c===2&&r===1?f.type=0:c===1&&r===0||(f.type=r)}else u=!0;u&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],f=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(S.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>f.some(c=>(0,v.isParent)(u.path,c,!R.isLinux))?!1:(f.push(u.path),!0)).concat(S)}}}),define(J[197],Z([0,1,29,8,22,31,2,80,9,4,96,23,70]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(b,p,S,f){super();this.request=b,this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(g.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await I.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await I.Promises.realpath(b.path),b.path===p&&(p=await(0,C.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const u=(0,h.basename)(b),c=(0,w.watch)(b);f.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${b}'`);const r=new Set;if(p)try{for(const i of await I.Promises.readdir(b))r.add(i)}catch(i){this.error(i)}const s=new Map;f.add((0,D.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),m.isMacintosh&&(o=(0,v.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(p)if(i==="rename"){s.get(o)?.dispose();const a=setTimeout(async()=>{if(s.delete(o),o===u&&!await I.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,h.join)(b,o));if(S.token.isCancellationRequested)return;let P;l?r.has(o)?P=0:(P=1,r.add(o)):(r.delete(o),P=2),this.onFileChange({path:(0,h.join)(this.request.path,o),type:P})},g.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;r.has(o)?a=0:(a=1,r.add(o)),this.onFileChange({path:(0,h.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==u){const a=setTimeout(async()=>{const l=await I.Promises.exists(b);S.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},g.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await I.Promises.exists(b)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),f.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,y.coalesceEvents)(S);if(f.length>0){if(this.verboseLogging)for(const c of f)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(m.isLinux)return I.Promises.exists(b);try{const p=(0,h.basename)(b);return(await I.Promises.readdir((0,h.dirname)(b))).some(f=>f===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.FILE_DELETE_HANDLER_DELAY=100,g.FILE_CHANGES_HANDLER_DELAY=50;async function d(E,b,p,S,f=512){const u=await I.Promises.open(E,"r"),c=Buffer.allocUnsafe(f),r=new k.CancellationTokenSource(S);let s,i=!1;const n={path:E,excludes:[],recursive:!1},o=new g(n,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:P}=await I.Promises.read(u,c,0,f,null);if(!P||r.token.isCancellationRequested)break;b(c.slice(0,P))}}catch(P){s=new Error(P),r.dispose(!0)}finally{i=!1}}})()});return await o.ready,p(),new Promise((a,l)=>{r.token.onCancellationRequested(async()=>{o.dispose();try{await I.Promises.close(u)}catch(P){s=new Error(P)}s?l(s):a()})})}e.watchFileContents=d}),define(J[198],Z([0,1,3,95,2,4,197]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new w.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=w.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const C=this.normalizeRequests(m),I=C.filter(g=>{const d=this.watchers.get(g.path);return d?!(0,t.patternsEquals)(d.request.excludes,g.excludes)||!(0,t.patternsEquals)(d.request.includes,g.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:g})=>!C.find(d=>d.path===g.path&&(0,t.patternsEquals)(d.excludes,g.excludes)&&(0,t.patternsEquals)(d.includes,g.includes))).map(({request:g})=>g.path);I.length&&this.trace(`Request to start watching: ${I.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.stopWatching(g);for(const g of I)this.startWatching(g)}startWatching(m){const C=new D.NodeJSFileWatcherLibrary(m,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),I={request:m,instance:C};this.watchers.set(m.path,I)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const C=this.watchers.get(m);C&&(this.watchers.delete(m),C.instance.dispose())}normalizeRequests(m){const C=new Map;for(const I of m){const y=R.isLinux?I.path:I.path.toLowerCase();C.set(y,I)}return Array.from(C.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,C]of this.watchers)C.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,C){return C?`[File Watcher (node.js)] ${m} (path: ${C.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=v}),define(J[199],Z([0,1,70,198]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends w.AbstractNonRecursiveWatcherClient{constructor(D,v,h){super(D,v,h);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(J[200],Z([0,1,13,45,148,70]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(h,m,C){super(h,m,C);this.init()}createWatcher(h){const m=h.add(new k.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(m.onDidProcessExit(({code:C,signal:I})=>this.onError(`terminated by itself with code ${C}, signal: ${I}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(J[85],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(J[201],Z([0,1,8,18,68,191,5,85]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class C{constructor(d=new v.ServiceCollection,E=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=E,this._parent=b,this._services.set(D.IInstantiationService,this)}createChild(d){return new C(d,this._strict,this)}invokeFunction(d,...E){const b=y.traceInvocation(d);let p=!1;try{return d({get:f=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(f,b);if(!u)throw new Error(`[invokeFunction] unknown service '${f}'`);return u}},...E)}finally{p=!0,b.stop()}}createInstance(d,...E){let b,p;return d instanceof k.SyncDescriptor?(b=y.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(E),b)):(b=y.traceCreation(d),p=this._createInstance(d,E,b)),b.stop(),p}_createInstance(d,E=[],b){const p=D._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),S=[];for(const u of p){const c=this._getOrCreateServiceInstance(u.id,b);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),S.push(c)}const f=p.length>0?p[0].index:E.length;if(E.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${E.length} static arguments`);const u=f-E.length;u>0?E=E.concat(new Array(u)):E=E.slice(0,f)}return new d(...[...E,...S])}_setServiceInstance(d,E){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,E);else if(this._parent)this._parent._setServiceInstance(d,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const E=this._services.get(d);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):E}_getOrCreateServiceInstance(d,E){const b=this._getServiceInstanceOrDescriptor(d);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,E.branch(d,!0)):(E.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,E,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,E,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,E,b){const p=new R.Graph(u=>u.id.toString());let S=0;const f=[{id:d,desc:E,_trace:b}];for(;f.length;){const u=f.pop();if(p.lookupOrInsertNode(u),S++>1e3)throw new m(p);for(const c of D._util.getServiceDependencies(u.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(c.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),r instanceof k.SyncDescriptor){const s={id:c.id,desc:r,_trace:u._trace.branch(c.id,!0)};p.insertEdge(u,s),f.push(s)}}}for(;;){const u=p.roots();if(u.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,E,b=[],p,S){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(E,b,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,E,b,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(d,E=[],b,p){if(b){const S=new w.IdleValue(()=>this._createInstance(d,E,p));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];const c=S.value;let r=c[u];return typeof r!="function"||(r=r.bind(c),f[u]=r),r},set(f,u,c){return S.value[u]=c,!0}})}else return this._createInstance(d,E,p)}_throwIfStrict(d,E){if(E&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=C;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class y{constructor(d,E){this.type=d,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return h?new y(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(d){return h?new y(0,d.name):y._None}branch(d,E){const b=new y(2,d.toString());return this._dep.push([d,E,b]),b}stop(){const d=Date.now()-this._start;y._totals+=d;let E=!1;function b(S,f){const u=[],c=new Array(S+1).join("	");for(const[r,s,i]of f._dep)if(s&&i){E=!0,u.push(`${c}CREATES -> ${r}`);const n=b(S+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${r}`);return u.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(d>2||E)&&console.log(p.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(J[6],Z([0,1,44,3,2,4,5]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function v(){return new Date().toISOString()}var h;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function m(s,i,n){switch(i){case h.Trace:s.trace(n);break;case h.Debug:s.debug(n);break;case h.Info:s.info(n);break;case h.Warning:s.warn(n);break;case h.Error:s.error(n);break;case h.Critical:s.critical(n);break;default:throw new Error("Invalid log level")}}e.log=m;function C(s){let i="";for(let n=0;n<s.length;n++){let o=s[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=C;class I extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class y extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,C([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,C([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,C([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,C([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(h.Error,C(o))}else this.log(h.Error,C([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,C([i,...n]))}flush(){}}e.AbstractMessageLogger=y;class g extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...n):console.log(`[main ${v()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...n):console.log(`[main ${v()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,i,...n):console.log(`[main ${v()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,i,...n):console.warn(`[main ${v()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,i,...n):console.error(`[main ${v()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,i,...n):console.error(`[main ${v()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class d extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class E extends I{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class b extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=b;class p extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=p;class S extends k.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=f;function u(s){if(s.verbose)return h.Trace;if(typeof s.logLevel=="string"){const i=c(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(s){switch(s){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function r(s){switch(s){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=r});var Y=this&&this.__param||function(q,e){return function(w,t){e(w,t,q)}};define(J[202],Z([0,1,69,3,2,6,4]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=class yt extends k.Disposable{constructor(m){super();this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,C){let I;try{I=await this.withKeytar()}catch{return null}const y=await I.getPassword(m,C);if(y)try{let{content:g,hasNextChunk:d}=JSON.parse(y);if(!g||!d)return y;let E=1;for(;d;){const b=await I.getPassword(m,`${C}-${E}`),p=JSON.parse(b);g+=p.content,d=p.hasNextChunk,E++}return g}catch{return y}return y}async setPassword(m,C,I){let y;try{y=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const g=3,d=async(E,b,p)=>{let S=0,f;for(;S<g;)try{await y.setPassword(E,b,p);return}catch(u){f=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),S++,await new Promise(c=>setTimeout(c,200))}throw f};if(D.isWindows&&I.length>yt.MAX_PASSWORD_LENGTH){let E=0,b=0,p=!0;for(;p;){const S=I.substring(E,E+yt.PASSWORD_CHUNK_SIZE);E+=yt.PASSWORD_CHUNK_SIZE,p=I.length-E>0;const f={content:S,hasNextChunk:p};await d(m,b?`${C}-${b}`:C,JSON.stringify(f)),b++}}else await d(m,C,I);this._onDidChangePassword.fire({service:m,account:C})}async deletePassword(m,C){let I;try{I=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const y=await I.getPassword(m,C);if(!y)return!1;const g=await I.deletePassword(m,C);try{let{content:d,hasNextChunk:E}=JSON.parse(y);if(d&&E){let b=1;for(;E;){const p=`${C}-${b}`,S=await I.getPassword(m,p);await I.deletePassword(m,p),E=JSON.parse(S).hasNextChunk,b++}}}catch{}return g&&this._onDidChangePassword.fire({service:m,account:C}),g}async findPassword(m){let C;try{C=await this.withKeytar()}catch{return null}return C.findPassword(m)}async findCredentials(m){let C;try{C=await this.withKeytar()}catch{return[]}return C.findCredentials(m)}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};v.MAX_PASSWORD_LENGTH=2500,v.PASSWORD_CHUNK_SIZE=v.MAX_PASSWORD_LENGTH-100,v=ve([Y(0,R.ILogService)],v),e.BaseCredentialsMainService=v}),define(J[203],Z([0,1,24,8,18,3,2,9,70,6]),function(q,e,w,t,k,R,D,v,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends D.Disposable{constructor(y,g){super();this.logService=y,this.options=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(y,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,g):this.watchNonRecursive(y,g)}watchUniversal(y,g){const d={path:this.toFilePath(y),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,w.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&y.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,g){const d={path:this.toFilePath(y),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,w.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,h.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,v.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(J[204],Z([0,1,24,8,17,22,3,66,57,2,32,13,71,16,58,160,14,105,6]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,r){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const s=new m.DisposableStore;return this.provider.set(c,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:r}),s.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new b.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&s.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:c}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:r}),this.provider.delete(c),(0,m.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){r.push(s)}}),!this.provider.has(c)&&await t.Promises.settled(r)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,r){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&r)}listCapabilities(){return h.Iterable.map(this.provider,([c,r])=>({scheme:c,capabilities:r.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new b.FileOperationError((0,E.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const r=this.provider.get(c.scheme);if(!r){const s=new Error;throw s.name="ENOPRO",s.message=(0,E.localize)(1,null,c.toString()),s}return r}async withReadProvider(c){const r=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)||(0,b.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const r=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,r){try{return await this.doResolveFile(c,r)}catch(s){throw(0,b.toFileSystemProviderErrorCode)(s)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,E.localize)(2,null,this.resourceForError(c)),1):(0,b.ensureFileSystemProviderError)(s)}}async doResolveFile(c,r){const s=await this.withProvider(c),i=this.isPathCaseSensitive(s),n=r?.resolveTo,o=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,l=await s.stat(c);let P;return this.toFileStat(s,c,l,void 0,!!a,(M,T)=>(P||(P=C.TernarySearchTree.forUris(()=>!i),P.set(c,!0),n&&P.fill(!0,n)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&o?T===1:!1))}async toFileStat(c,r,s,i,n,o){const{providerExtUri:a}=this.getExtUri(c),l={resource:r,name:a.basename(r),isFile:(s.type&b.FileType.File)!=0,isDirectory:(s.type&b.FileType.Directory)!=0,isSymbolicLink:(s.type&b.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(l.isDirectory&&o(l,i)){try{const P=await c.readdir(r),M=await t.Promises.settled(P.map(async([T,W])=>{try{const U=a.joinPath(r,T),x=n?await c.stat(U):{type:W};return await this.toFileStat(c,U,x,P.length,n,o)}catch(U){return this.logService.trace(U),null}}));l.children=(0,w.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(c){const r=await this.withProvider(c),s=await r.stat(c);return this.toFileStat(r,c,s,void 0,!0,()=>!1)}async exists(c){const r=await this.withProvider(c);try{return!!await r.stat(c)}catch{return!1}}async canCreateFile(c,r){try{await this.doValidateCreateFile(c,r)}catch(s){return s}return!0}async doValidateCreateFile(c,r){if(!r?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,E.localize)(3,null,this.resourceForError(c)),3,r)}async createFile(c,r=k.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const i=await this.writeFile(c,r);return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,i)),i}async writeFile(c,r,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,s)||await this.mkdirp(i,n.dirname(c));let a;if((0,b.hasReadWriteCapability)(i)&&!(r instanceof k.VSBuffer))if((0,d.isReadableStream)(r)){const l=await(0,d.peekStream)(r,3);l.ended?a=k.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(r,l=>k.VSBuffer.concat(l),3);else a=r;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,s,a):await this.doWriteBuffered(i,c,s,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new b.FileOperationEvent(c,4))}catch(o){throw new b.FileOperationError((0,E.localize)(4,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,r,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(r)));let n;try{n=await c.stat(r)}catch{return}if((n.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,E.localize)(6,null,this.resourceForError(r)),0,s);if(this.throwIfFileIsReadonly(r,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,b.etag)({mtime:s.mtime,size:n.size}))throw new b.FileOperationError((0,E.localize)(7,null),3,s);return n}async readFile(c,r,s){const i=await this.withReadProvider(c);return r?.atomic?this.doReadFileAtomic(i,c,r,s):this.doReadFile(i,c,r,s)}async doReadFileAtomic(c,r,s,i){return new Promise((n,o)=>{this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,r,s,i);n(a)}catch(a){o(a)}})})}async doReadFile(c,r,s,i){const n=await this.doReadFileStream(c,r,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(c,r,s){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,r,s)}async doReadFileStream(c,r,s,i){const n=new R.CancellationTokenSource(i),o=this.validateReadFile(r,s).then(l=>l,l=>{throw n.cancel(),l});let a;try{return typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&await o,s?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&s?.preferUnbuffered?a=this.readFileUnbuffered(c,r,s):(0,b.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,r,n.token,s):a=this.readFileBuffered(c,r,n.token,s),{...await o,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const P=(0,E.localize)(8,null,this.resourceForError(r),(0,b.ensureFileSystemProviderError)(l).toString());throw l instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(P,l.stat,s):new b.FileOperationError(P,(0,b.toFileOperationResult)(l),s)}}readFileStreamed(c,r,s,i=Object.create(null)){const n=c.readFileStream(r,i,s);return(0,d.transform)(n,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new b.FileOperationError((0,E.localize)(9,null,this.resourceForError(r),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,r,s,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,r,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError((0,E.localize)(10,null,this.resourceForError(r),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},s),n}readFileUnbuffered(c,r,s){const i=(0,d.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?n=await c.readFile(r,{atomic:!0}):n=await c.readFile(r),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(r,n.byteLength,s),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,r){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new b.FileOperationError((0,E.localize)(11,null,this.resourceForError(c)),0,r);if(typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&r.etag===s.etag)throw new b.NotModifiedSinceFileOperationError((0,E.localize)(12,null),s,r);return this.validateReadFileLimits(c,s.size,r),s}validateReadFileLimits(c,r,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&r>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&r>s.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,E.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,r,s){return this.doCanMoveCopy(c,r,"move",s)}async canCopy(c,r,s){return this.doCanMoveCopy(c,r,"copy",s)}async doCanMoveCopy(c,r,s,i){if(c.toString()!==r.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,c,o,r,s,i)}catch(n){return n}return!0}async move(c,r,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,n,r,"move",!!s),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="move"?2:3,a)),a}async copy(c,r,s){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,c,n,r,"copy",!!s),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="copy"?3:2,a)),a}async doMoveCopy(c,r,s,i,n,o){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,r,s,i,n,o);if(a&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),n==="copy"){if(c===s&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(r,i,{overwrite:o});else{const P=await this.resolve(r);P.isDirectory?await this.doCopyFolder(c,P,s,i):await this.doCopyFile(c,r,s,i)}return n}else return c===s?(await c.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(c,r,s,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(c,r,s,i){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,r,s,i);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,r,s,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,r,s,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,r,s,i)}async doCopyFolder(c,r,s,i){await s.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),s,o):this.doCopyFile(c,n.resource,s,o)}))}async doValidateMoveCopy(c,r,s,i,n,o){let a=!1;if(c===s){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(r,i)),a&&n==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,r))throw new Error((0,E.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new b.FileOperationError((0,E.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(c===s){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(r,i))throw new Error((0,E.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const r=this.isPathCaseSensitive(c);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(r,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,s)),s}async mkdirp(c,r){const s=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(r,i.dirname(r));)try{if(((await c.stat(r)).type&b.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(r)),r=i.dirname(r)}for(let n=s.length-1;n>=0;n--){r=i.joinPath(r,s[n]);try{await c.mkdir(r)}catch(o){if((0,b.toFileSystemProviderErrorCode)(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,r){try{await this.doValidateDelete(c,r)}catch(s){return s}return!0}async doValidateDelete(c,r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!r?.useTrash&&!(s.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(c)));let n;try{n=await s.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new b.FileOperationError((0,E.localize)(20,null,this.resourceForError(c)),1);if(!!!r?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(c)))}return s}async del(c,r){const s=await this.doValidateDelete(c,r),i=!!r?.useTrash,n=!!r?.recursive;await s.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,r){const s=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(c,r))return;if(s===i&&(0,b.hasFileCloneCapability)(s))return s.cloneFile(c,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const n=this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri);return s===i&&(0,b.hasFileFolderCopyCapability)(s)?n.queue(()=>s.copy(c,r,{overwrite:!0})):n.queue(()=>this.doCopyFile(s,c,i,r))}watch(c,r={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let i=!1,n=()=>{i=!0};return s.add((0,m.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,r);i?(0,m.dispose)(o):n=()=>(0,m.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(c,r){const s=await this.withProvider(c),i=(0,v.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(c),r]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:s.watch(c,r)},this.activeWatchers.set(i,n)),n.count+=1,(0,m.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,m.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,r,s,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(r,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,r,s){let i=0,n;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=k.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,r,o,o.byteLength,i,0),i+=o.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((o,a)=>{(0,d.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,r,l,l.byteLength,i,0)}catch(P){return a(P)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,r,s){let i=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(c,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,r,s,i,n,o){let a=0;for(;a<i;)a+=await c.write(r,n+a,s.buffer,o+a,i-a)}async doWriteUnbuffered(c,r,s,i){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,r,s,i))}async doWriteUnbufferedQueued(c,r,s,i){let n;i instanceof k.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await c.writeFile(r,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,r,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,r,s,i))}async doPipeBufferedQueued(c,r,s,i){let n,o;try{n=await c.open(r,{create:!1}),o=await s.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await c.read(n,l,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(s,o,a,M,l,P),l+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,r,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,r,s,i))}async doPipeUnbufferedQueued(c,r,s,i){return s.writeFile(i,await c.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,r,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,r,s,i))}async doPipeUnbufferedToBufferedQueued(c,r,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(r);await this.doWriteBuffer(s,n,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(c,r,s,i){const n=await(0,k.streamToBuffer)(this.readFileBuffered(c,r,R.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,n)}throwIfFileSystemIsReadonly(c,r){if(c.capabilities&2048)throw new b.FileOperationError((0,E.localize)(22,null,this.resourceForError(r)),6);return c}throwIfFileIsReadonly(c,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,E.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};f=ve([Y(0,S.ILogService)],f),e.FileService=f}),define(J[86],Z([0,1,29,275,8,32,17,3,31,2,9,4,16,58,23,164,14,105,203,44,200,199]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(w)}catch(s){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(s)}`)}})();class r extends S.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,y.joinPath)(i,a.name))).type:l=this.toType(a),o.push([a.name,l])}catch(l){this.logService.trace(l)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=b.FileType.Unknown:i.isFile()?o=b.FileType.File:i.isDirectory()?o=b.FileType.Directory:o=b.FileType.Unknown,n&&(o|=b.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,n,o){const a=(0,g.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,p.readFileIntoStream)(this,i,a,l=>l.buffer,{...n,bufferSize:256*1024},o),a}async writeFile(i,n,o){let a;try{const l=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(l)){if(!o.overwrite)throw(0,b.createFileSystemProviderError)((0,E.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,b.createFileSystemProviderError)((0,E.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){r.canFlush=i}async open(i,n){const o=this.toFilePath(i);let a;(0,b.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let l;try{if((0,b.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(o);M.mode&128||await d.Promises.chmod(o,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,b.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await d.Promises.truncate(o,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await d.Promises.open(o,P)}catch(P){throw a?.dispose(),(0,b.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,b.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,i),a){const P=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.mapHandleToLock.set(l,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),P.dispose())}return l}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&r.canFlush)try{await d.Promises.fdatasync(i)}catch(o){r.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.read(i,o,a,l,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,M)}return M}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,a,l){return(0,k.retry)(()=>this.doWrite(i,n,o,a,l),100,3)}async doWrite(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.write(i,o,a,l,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,M)}return M}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(a,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,E.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,n,o,a){const l=this.toFilePath(i),P=this.toFilePath(n);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(l,P,!0)),M&&o==="copy")throw(0,b.createFileSystemProviderError)((0,E.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(P)){if(!a)throw(0,b.createFileSystemProviderError)((0,E.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n),P=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!P))return;const M=new m.DisposableStore;try{const[T,W]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);M.add(T),M.add(W),o&&await d.Promises.mkdir((0,C.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(T){if(T.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(a=>i(a),a=>n(a),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(a=>i(a),a=>n(a),o)}toFileSystemProviderError(i){if(i instanceof b.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,b.createFileSystemProviderError)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=r,r.canFlush=!0}),define(J[205],Z([0,1,3,86,2,17,58,22]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends k.Disposable{constructor(I,y){super();this.provider=I,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,y,g){const d=this.getUriTransformer(I);switch(y){case"stat":return this.stat(d,g[0]);case"readdir":return this.readdir(d,g[0]);case"open":return this.open(d,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(d,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(d,g[0],g[1],g[2]);case"rename":return this.rename(d,g[0],g[1],g[2]);case"copy":return this.copy(d,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(d,g[0],g[1]);case"mkdir":return this.mkdir(d,g[0]);case"delete":return this.delete(d,g[0],g[1]);case"watch":return this.watch(d,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(I,y,g){const d=this.getUriTransformer(I);switch(y){case"fileChange":return this.onFileChange(d,g[0]);case"readFileStream":return this.onReadFileStream(d,g[0],g[1])}throw new Error(`Unknown event ${y}`)}stat(I,y){const g=this.transformIncoming(I,y,!0);return this.provider.stat(g)}readdir(I,y){const g=this.transformIncoming(I,y);return this.provider.readdir(g)}async readFile(I,y,g){const d=this.transformIncoming(I,y,!0),E=await this.provider.readFile(d,g);return R.VSBuffer.wrap(E)}onReadFileStream(I,y,g){const d=this.transformIncoming(I,y,!0),E=new v.CancellationTokenSource,b=new w.Emitter({onLastListenerRemove:()=>{E.cancel()}}),p=this.provider.readFileStream(d,g,E.token);return(0,D.listenStream)(p,{onData:S=>b.fire(R.VSBuffer.wrap(S)),onError:S=>b.fire(S),onEnd:()=>{b.fire("end"),b.dispose(),E.dispose()}}),b.event}writeFile(I,y,g,d){const E=this.transformIncoming(I,y);return this.provider.writeFile(E,g.buffer,d)}open(I,y,g){const d=this.transformIncoming(I,y,!0);return this.provider.open(d,g)}close(I){return this.provider.close(I)}async read(I,y,g){const d=R.VSBuffer.alloc(g),E=0,b=await this.provider.read(I,y,d.buffer,E,g);return[d,b]}write(I,y,g,d,E){return this.provider.write(I,y,g.buffer,d,E)}mkdir(I,y){const g=this.transformIncoming(I,y);return this.provider.mkdir(g)}delete(I,y,g){const d=this.transformIncoming(I,y);return this.provider.delete(d,g)}rename(I,y,g,d){const E=this.transformIncoming(I,y),b=this.transformIncoming(I,g);return this.provider.rename(E,b,d)}copy(I,y,g,d){const E=this.transformIncoming(I,y),b=this.transformIncoming(I,g);return this.provider.copy(E,b,d)}cloneFile(I,y,g){const d=this.transformIncoming(I,y),E=this.transformIncoming(I,g);return this.provider.cloneFile(d,E)}onFileChange(I,y){const g=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(I,g))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return g.event}async watch(I,y,g,d,E){const b=this.sessionToWatcher.get(y);if(b){const p=this.transformIncoming(I,d),S=b.watch(g,p,E);this.watchRequests.set(y+g,S)}}async unwatch(I,y){const g=I+y,d=this.watchRequests.get(g);d&&((0,k.dispose)(d),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class m extends k.Disposable{constructor(I,y,g,d){super();this.uriTransformer=I,this.logService=g,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(I){const y=this._register(new w.Emitter);this._register(y.event(g=>{I.fire(g.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(g=>y.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>I.fire(g)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,y,g){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(g.excludes=[...g.excludes,...d]),this.watcherRequests.set(I,this.fileWatcher.watch(y,g)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(J[206],Z([0,1,15,163,4,7,14,9,205,142]),function(q,e,w,t,k,R,D,v,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends h.AbstractDiskFileSystemProviderChannel{constructor(g,d,E){super(g,d);this.environmentService=E}getUriTransformer(g){return m.DefaultURITransformer}transformIncoming(g,d){return R.URI.revive(d)}async delete(g,d,E){if(!E.useTrash)return super.delete(g,d,E);const b=this.transformIncoming(g,d),p=(0,v.normalize)(b.fsPath);try{await w.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,v.basename)(p)):(0,t.localize)(1,null,(0,v.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(g,d){return new I(g,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class I extends h.AbstractSessionFileWatcher{watch(g,d,E){if(E.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,d,E)}}}),define(J[106],Z([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case w.LogLevel.Trace:return R.trace;case w.LogLevel.Debug:return R.debug;case w.LogLevel.Info:return R.info;case w.LogLevel.Warning:return R.warn;case w.LogLevel.Error:return R.error;case w.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(D=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}set logger(D){this._logger=D;for(const{level:v,args:h}of this.buffer)t(D,v).apply(D,h);this.buffer=[]}_log(D,...v){this._logger?t(this._logger,D).apply(this._logger,v):this.getLevel()<=D&&this.buffer.push({level:D,args:v})}trace(D,...v){this._log(w.LogLevel.Trace,D,...v)}debug(D,...v){this._log(w.LogLevel.Debug,D,...v)}info(D,...v){this._log(w.LogLevel.Info,D,...v)}warn(D,...v){this._log(w.LogLevel.Warning,D,...v)}error(D,...v){this._log(w.LogLevel.Error,D,...v)}critical(D,...v){this._log(w.LogLevel.Critical,D,...v)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(J[207],Z([0,1,8,17,16,14,5,106,6]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let C=class extends h.AbstractLogger{constructor(g,d,E,b,p){super();this.name=g,this.resource=d,this.donotUseFormatters=b,this.fileService=p,this.backupIndex=1,this.setLevel(E),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const g=arguments[0];if(g instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=g.stack,this._log(h.LogLevel.Error,(0,h.format)(d))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(g){if(g.fileOperationResult!==3)throw g}}_log(g,d){this.queue.queue(async()=>{await this.initializePromise;let E=await this.loadContent();E.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(E)),E=""),this.donotUseFormatters?E+=d:E+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(g)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(E))})}getCurrentTimestamp(){const g=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,E=new Date;return`${E.getFullYear()}-${g(E.getMonth()+1)}-${g(E.getDate())} ${g(E.getHours())}:${g(E.getMinutes())}:${g(E.getSeconds())}.${d(E.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(g){switch(g){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};C=ve([Y(4,R.IFileService)],C),e.FileLogger=C;let I=class extends h.AbstractLoggerService{constructor(g,d,E){super(g.getLevel(),g.onDidChangeLogLevel);this.instantiationService=d,this.fileService=E}doCreateLogger(g,d,E){const b=new v.BufferLogService(d);return(0,R.whenProviderRegistered)(g,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(C,E?.name||(0,k.basename)(g),g,b.getLevel(),!!E?.donotUseFormatters)),b}};I=ve([Y(0,h.ILogService),Y(1,D.IInstantiationService),Y(2,R.IFileService)],I),e.FileLoggerService=I}),define(J[208],Z([0,1,3,7,6]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=w.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(y,g,d){switch(g){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=R;class D{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){D.setLevel(this.channel,y)}static setLevel(y,g){return y.call("setLevel",g)}}e.LogLevelChannelClient=D;class v{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,g){throw new Error(`Event not found: ${g}`)}async call(y,g,d){switch(g){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${g}`)}createLogger(y,g){this.loggers.set(y.toString(),this.loggerService.createLogger(y,g))}consoleLog(y,g){let d=console.log;switch(y){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...g)}log(y,g){const d=this.loggers.get(y.toString());if(!d)throw new Error("Create the logger before logging");for(const[E,b]of g)(0,k.log)(d,E,b)}}e.LoggerChannel=v;class h extends k.AbstractLoggerService{constructor(y,g,d){super(y,g);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(y,g)=>{this.channel.call("consoleLog",[y,g])}})}doCreateLogger(y,g,d){return new m(this.channel,y,g,d)}}e.LoggerChannelClient=h;class m extends k.AbstractMessageLogger{constructor(y,g,d,E){super(E?.always);this.channel=y,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[g,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,g){const d=[[y,g]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(y){this.channel.call("log",[this.file,y])}}class C extends k.LogService{constructor(y,g){super(g);this.parent=y,this._register(y.onDidChangeLogLevel(d=>g.setLevel(d)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=C}),define(J[107],Z([0,1,14,6]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(v,h,m,C,I){try{const y=await new Promise((d,E)=>{q(["spdlog"],d,E)});y.setFlushOn(t.LogLevel.Trace);const g=await y.createAsyncRotatingLogger(v,h,m,C);return I&&g.clearFormatters(),g}catch(y){console.error(y)}return null}function R(v,h,m){switch(h){case t.LogLevel.Trace:v.trace(m);break;case t.LogLevel.Debug:v.debug(m);break;case t.LogLevel.Info:v.info(m);break;case t.LogLevel.Warning:v.warn(m);break;case t.LogLevel.Error:v.error(m);break;case t.LogLevel.Critical:v.critical(m);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(h,m,C,I,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(h,m,C,I),this._register(this.onDidChangeLogLevel(g=>{this._logger?.setLevel(g)}))}async _createSpdLogLogger(h,m,C,I){const y=C?6:1,g=30/y*w.ByteSize.MB,d=await k(h,m,g,y,I);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:E,message:b}of this.buffer)R(this._logger,E,b);this.buffer=[]}}log(h,m){this._logger?R(this._logger,h,m):this.getLevel()<=h&&this.buffer.push({level:h,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(J[209],Z([0,1,13,16,28,14,207,6,107]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends v.AbstractLoggerService{constructor(I,y){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=y}doCreateLogger(I,y,g){return I.scheme===w.Schemas.file?new h.SpdLogLogger(g?.name||(0,k.generateUuid)(),I.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,y):new D.FileLogger(g?.name??(0,t.basename)(I),I,y,!!g?.donotUseFormatters,this.fileService)}};m=ve([Y(0,v.ILogService),Y(1,R.IFileService)],m),e.LoggerService=m}),define(J[210],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!w(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(J[38],Z([0,1,3,57,2,5]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(I,[y,g])=>({...I,[y]:g}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[C,I])=>({...m,[C]:{definition:I,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=D;class v{constructor(){this.onDidChange=w.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=v}),define(J[211],Z([0,1,8,3,57,12,14,6,38]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(I,y){const g=[];for(const d of k.Iterable.concat(I.keys(),y.keys()))I.get(d)!==y.get(d)&&g.push(d);return g}let C=class extends h.AbstractPolicyService{constructor(y,g,d){super();this.file=y,this.fileService=g,this.logService=d,this.throttledDelayer=this._register(new w.ThrottledDelayer(500));const E=t.Event.filter(g.onDidFilesChange,b=>b.affects(y));this._register(g.watch(y)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(y){await this.refresh()}async read(){const y=new Map;try{const g=await this.fileService.readFile(this.file),d=JSON.parse(g.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(d))this.policyDefinitions[E]&&y.set(E,d[E])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return y}async refresh(){const y=await this.read(),g=m(this.policies,y);this.policies=y,g.length>0&&this._onDidChange.fire(g)}};C=ve([Y(1,D.IFileService),Y(2,v.ILogService)],C),e.FilePolicyService=C}),define(J[212],Z([0,1,3,2,38]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(h){this.service=h,this.disposables=new t.DisposableStore}listen(h,m){switch(m){case"onDidChange":return w.Event.map(this.service.onDidChange,C=>C.reduce((I,y)=>({...I,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(h,m,C){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(h,m){super();this.channel=m;for(const C in h){const{definition:I,value:y}=h[C];this.policyDefinitions[C]=I,y!==void 0&&this.policies.set(C,y)}this.channel.listen("onDidChange")(C=>{for(const I in C){const y=C[I];y===null?this.policies.delete(I):this.policies.set(I,y)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(h){const m=await this.channel.call("registerPolicyDefinitions",h);for(const C in m)this.policies.set(C,m[C])}}e.PolicyChannelClient=D}),define(J[53],Z([0,1,13,4,34,16,102]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let v;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const h=t.globals.vscode.context.configuration();if(h)v=h.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const h=(0,R.dirname)(w.FileAccess.asFileUri("",q));v=q.__$__nodeRequire((0,R.joinPath)(h,"product.json").fsPath);const m=q.__$__nodeRequire((0,R.joinPath)(h,"package.json").fsPath);try{const E=(...f)=>f.reduce((u,c)=>(Object.keys(c).forEach(r=>{Array.isArray(u[r])&&Array.isArray(c[r])?u[r]=c[r]:typeof u[r]=="object"&&typeof c[r]=="object"?u[r]=E(u[r],c[r]):u[r]=c[r]}),u),{}),b=(0,D.getUserDataPath)({}),p=t.isWindows?`file:///${b}/product.json`:`file://${b}/product.json`,S=q.__$__nodeRequire(w.FileAccess.asFileUri(p,q).fsPath);v=E(v,S)}catch{}k.env.VSCODE_DEV&&Object.assign(v,{nameShort:`${v.nameShort} Dev`,nameLong:`${v.nameLong} Dev`,dataFolderName:`${v.dataFolderName}-dev`,serverDataFolderName:v.serverDataFolderName?`${v.serverDataFolderName}-dev`:void 0});const{serviceUrl:C,cacheUrl:I,itemUrl:y,controlUrl:g,recommendationsUrl:d}=v.extensionsGallery||{};Object.assign(v,{extensionsGallery:{serviceUrl:k.env.VSCODE_GALLERY_SERVICE_URL||C,cacheUrl:k.env.VSCODE_GALLERY_CACHE_URL||I,itemUrl:k.env.VSCODE_GALLERY_ITEM_URL||y,controlUrl:k.env.VSCODE_GALLERY_CONTROL_URL||g,recommendationsUrl:k.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||d}}),Object.assign(v,{version:m.version,release:m.release})}else v={},Object.keys(v).length===0&&Object.assign(v,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=v}),define(J[20],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[213],Z([0,1,76,6,20]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(v,h){this.productService=v,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(v,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(h);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,C,I]=m;let y=this.trustedExtensionUrlPublicKeys.get(v);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[v],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",v),!1;this.trustedExtensionUrlPublicKeys.set(v,[...y])}const g=Buffer.from(decodeURIComponent(I),"base64");if(g.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const d=g.slice(0,6),E=g.readUIntBE(0,6),b=Date.now()-E;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const p=g.slice(6),S=w.createVerify("SHA256");S.write(d),S.write(Buffer.from(C)),S.end();for(let f=0;f<y.length;f++){let u=y[f];if(u!==null){if(typeof u=="string")try{u=w.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),y[f]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${v}:`,c),y[f]=null;continue}if(S.verify(u,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};R=ve([Y(0,k.IProductService),Y(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(J[61],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[46],Z([0,1,121,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,v){w.ok(t.isString(D)),w.ok(t.isObject(v)),w.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,v)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(J[214],Z([0,1,3,46]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,m){this.schemasById[k(h)]=m,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(J[62],Z([0,1,24,3,12,151,19,214,46]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=h.Registry.as(v.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=this.doRegisterConfigurations(r,s);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const s=this.doDeregisterConfigurations(r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=[];i.push(...this.doDeregisterConfigurations(s)),i.push(...this.doRegisterConfigurations(r,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(i)})}registerDefaultConfigurations(r){const s=[],i=[];for(const{overrides:n,source:o}of r)for(const a in n)if(s.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),P=l?.valuesSources??new Map;if(o)for(const U of Object.keys(n[a]))P.set(U,o);const M={...l?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(a),W={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...E(a)),this.configurationProperties[a]=W,this.defaultLanguageConfigurationOverridesNode.properties[a]=W}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:o});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const s=[];for(const{overrides:i,source:n}of r)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),l=k.isString(n)?n:n?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(l===P)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const s of r)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,s){const i=[];return r.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(r){const s=[],i=n=>{if(n.properties)for(const o in n.properties){s.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of r){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(r,s=!0,i,n,o=3){o=k.isUndefinedOrNull(r.scope)?o:r.scope;const a=[],l=r.properties;if(l)for(const M in l){const T=l[M];if(s&&f(M,T)){delete l[M];continue}if(T.source=i,T.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!n?.includes(M):T.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),a.push(M)}const P=r.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,s,i,n,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const s=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(s)};s(r)}updateSchema(r,s){switch(e.allSettings.properties[r]=s,s.scope){case 1:e.applicationSettings.properties[r]=s;break;case 2:e.machineSettings.properties[r]=s;break;case 6:e.machineOverridableSettings.properties[r]=s;break;case 3:e.windowSettings.properties[r]=s;break;case 4:e.resourceSettings.properties[r]=s;break;case 5:e.resourceSettings.properties[r]=s,this.resourceLanguageSettingsSchema.properties[r]=s;break}}removeFromSchema(r,s){switch(delete e.allSettings.properties[r],s.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const s=`[${r}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,s){const i=this.configurationDefaultsOverrides.get(r);let n=i?.value,o=i?.source;k.isUndefined(n)&&(n=s.defaultDefaultValue,o=void 0),k.isUndefined(n)&&(n=p(s.type)),s.default=n,s.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",d=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(c){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=d.exec(c);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=d.exec(c)}}return(0,w.distinct)(r)}e.overrideIdentifiersFromKey=E;function b(c){return c.reduce((r,s)=>`${r}[${s}]`,"")}e.keyFromOverrideIdentifiers=b;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const S=new y;h.Registry.add(e.Extensions.Configuration,S);function f(c,r){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):S.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):r.policy?.name&&S.getPolicyConfigurations().get(r.policy?.name)!==void 0?R.localize(9,null,c,r.policy?.name,S.getPolicyConfigurations().get(r.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function u(){const c=[],r=S.getConfigurationProperties();for(const s of Object.keys(r))c.push([s,r[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(J[108],Z([0,1,24,3,43,2,32,50,12,7,19,62,46]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class g{constructor(s={},i=[],n=[]){this._contents=s,this._keys=i,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,C.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,C.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return w.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=v.deepClone(this.contents),n=v.deepClone(this.overrides),o=[...this.keys];for(const a of s)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const l of a.overrides){const[P]=n.filter(M=>w.equals(M.identifiers,l.identifiers));P?(this.mergeContents(P.contents,l.contents),P.keys.push(...l.keys),P.keys=w.distinct(P.keys)):n.push(v.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new g(i,o,n)}freeze(){return this.frozen=!0,this}clone(){return new g(v.deepClone(this.contents),[...this.keys],v.deepClone(this.overrides))}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const l=i[o];l&&(typeof a=="object"&&typeof l=="object"?(a=v.deepClone(a),this.mergeContents(a,l)):a=l),n[o]=a}return new g(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&h.isObject(s[n])&&h.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=v.deepClone(i[n])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?v.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,n=null;const o=a=>{a&&(n?this.mergeContents(n,a):n=v.deepClone(a))};for(const a of this.overrides)w.equals(a.identifiers,[s])?i=a.contents:a.identifiers.includes(s)&&o(a.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,C.addToValueTree)(this.contents,s,i,n=>{throw new Error(n)})}removeValue(s){this.removeKey(s)&&(0,C.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let n=0;n<i;n++)s.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,s)}removeKey(s){const i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!h.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:o,overrides:a,restricted:l}=this.doParseRaw(s,i);this._configurationModel=new g(n,o,a),this._restrictedConfigurations=l||[]}doParseContent(s){let i={},n=null,o=[];const a=[],l=[];function P(T){Array.isArray(o)?o.push(T):n!==null&&(o[n]=T)}const M={onObjectBegin:()=>{const T={};P(T),a.push(o),o=T,n=null},onObjectProperty:T=>{n=T},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const T=[];P(T),a.push(o),o=T,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:P,onError:(T,W,U)=>{l.push({error:T,offset:W,length:U})}};if(s)try{k.visit(s,M),i=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(s,i){const n=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,n,!0,i);s=o.raw;const a=(0,C.toValuesTree)(s,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),l=Object.keys(s),P=this.toOverrides(s,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:l,overrides:P,restricted:o.restricted}}filter(s,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:s,restricted:[]};const a={},l=[];for(const P in s)if(I.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const M=this.filter(s[P],i,!1,o);a[P]=M.raw,l.push(...M.restricted)}else{const M=i[P],T=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&l.push(P),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&M?.restricted||(a[P]=s[P]))}return{raw:a,restricted:l}}toOverrides(s,i){const n=[];for(const o of Object.keys(s))if(I.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in s[o])a[l]=s[o][l];n.push({identifiers:(0,I.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=d;class E extends R.Disposable{constructor(s,i,n,o){super();this.userSettingsResource=s,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class b{constructor(s,i,n,o,a=new g,l=new g,P=new D.ResourceMap,M=new g,T=new D.ResourceMap,W=!0){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=P,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=W,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidatedConfigurationModel(s,i,n).getValue(s)}updateValue(s,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new g,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const o=this.getConsolidatedConfigurationModel(s,i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),M=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(s),T=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),U=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),x=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),re=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,le=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(s):a.freeze().getValue(s):void 0,ue=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(s):l.getValue(s),se=o.getValue(s),de=w.distinct(o.overrides.map(K=>K.identifiers).flat()).filter(K=>o.getOverrideValue(s,K)!==void 0);return{defaultValue:P,policyValue:M,applicationValue:T,userValue:W,userLocalValue:U,userRemoteValue:x,workspaceValue:re,workspaceFolderValue:le,memoryValue:ue,value:se,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,policy:M!==void 0?{value:M}:void 0,application:T!==void 0?{value:T,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:W!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:x!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:re!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:le!==void 0?{value:a?.freeze().getValue(s),override:i.overrideIdentifier?a?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:ue!==void 0?{value:l.getValue(s),override:i.overrideIdentifier?l.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:o,updated:a,removed:l}=u(this._defaultConfiguration,s);i=[...o,...a,...l]}for(const o of i)for(const a of(0,I.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=s.getKeysForOverrideIdentifier(a),M=[...P.filter(T=>l.indexOf(T)===-1),...l.filter(T=>P.indexOf(T)===-1),...l.filter(T=>!v.equals(this._defaultConfiguration.override(a).getValue(T),s.override(a).getValue(T)))];n.push([a,M])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,s),a=[...i,...n,...o];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:o,overrides:a}=u(this.applicationConfiguration,s),l=[...i,...n,...o];return l.length&&this.updateApplicationConfiguration(s),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:a}=u(this.localUserConfiguration,s),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(s),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:o,overrides:a}=u(this.remoteUserConfiguration,s),l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(s),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:o,overrides:a}=u(this.workspaceConfiguration,s),l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(s),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:o,updated:a,removed:l,overrides:P}=u(n,i),M=[...o,...a,...l];return(M.length||!n)&&this.updateFolderConfiguration(s,i),{keys:M,overrides:P}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:o,removed:a,overrides:l}=u(i,void 0);return{keys:[...n,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(s);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:o,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),o=this.parseConfigurationModel(s.application),a=this.parseConfigurationModel(s.user),l=this.parseConfigurationModel(s.workspace),P=s.folders.reduce((M,T)=>(M.set(m.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new b(i,n,o,a,new g,l,P,new g,new D.ResourceMap,!1)}static parseConfigurationModel(s){return new g(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=b;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const o of r)o.keys.forEach(a=>s.add(a)),o.overrides.forEach(([a,l])=>{const P=(0,D.getOrSet)(i,a,new Set);l.forEach(M=>P.add(M))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=p;class S{constructor(s,i,n,o){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;s.keys.forEach(P=>a.add(P)),s.overrides.forEach(([,P])=>P.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const l=new g;this.affectedKeys.forEach(P=>l.setValue(P,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!v.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let n=(0,C.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(s=s[o],!s)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=S;class f extends S{constructor(s,i,n,o){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=f;function u(r,s){const{added:i,removed:n,updated:o}=c(s,r),a=[],l=r?.getAllOverrideIdentifiers()||[],P=s?.getAllOverrideIdentifiers()||[];if(s){const M=P.filter(T=>!l.includes(T));for(const T of M)a.push([T,s.getKeysForOverrideIdentifier(T)])}if(r){const M=l.filter(T=>!P.includes(T));for(const T of M)a.push([T,r.getKeysForOverrideIdentifier(T)])}if(s&&r){for(const M of l)if(P.includes(M)){const T=c({contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)},{contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)});a.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:n,updated:o,overrides:a}}function c(r,s){const i=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],n=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],o=[];if(r&&s){for(const a of s.keys)if(r.keys.indexOf(a)!==-1){const l=(0,C.getConfigurationValue)(s.contents,a),P=(0,C.getConfigurationValue)(r.contents,a);v.equals(l,P)||o.push(a)}}return{added:i,removed:n,updated:o}}}),define(J[215],Z([0,1,24,3,2,50,12,19,108,62,6,38,46]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class g extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(y.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:f})=>this.onDidUpdateConfiguration(S,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=g;class d extends h.ConfigurationModel{constructor(S={}){const f=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(f),c=Object.create(null),r=[];for(const s in f){const i=S[s],n=i!==void 0?i:f[s].default;(0,v.addToValueTree)(c,s,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(c))m.OVERRIDE_PROPERTY_REGEX.test(s)&&r.push({identifiers:(0,m.overrideIdentifiersFromKey)(s),keys:Object.keys(c[s]),contents:(0,v.toValuesTree)(c[s],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,r)}}e.DefaultConfigurationModel=d;class E{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let b=class extends k.Disposable{constructor(S,f,u){super();this.defaultConfiguration=S,this.policyService=f,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const f={},u=[],c=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const r of S){const s=c[r];if(!s){u.push(r);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}u.push(r),f[s.policy.name]={type:s.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),u}onDidChangePolicies(S){const f=y.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),u=(0,w.coalesce)(S.map(c=>f.get(c)));this.update(u,!0)}update(S,f){const u=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),c=[],r=this._configurationModel.isEmpty();for(const s of S){const i=u[s]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(r?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(s),n))&&c.push([s,n])}else this._configurationModel.getValue(s)!==void 0&&c.push([s,void 0])}if(c.length){const s=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const i of s.keys)this._configurationModel.setValue(i,s.getValue(i));for(const[i,n]of c)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=ve([Y(1,I.IPolicyService),Y(2,C.ILogService)],b),e.PolicyConfiguration=b}),define(J[216],Z([0,1,8,3,2,16,19,108,215,38]),function(q,e,w,t,k,R,D,v,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends k.Disposable{constructor(y,g,d,E){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,d,E)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,g)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new v.ConfigurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,g,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(y,g,new v.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(y,g){const d=typeof y=="string"?y:void 0,E=(0,D.isConfigurationOverrides)(y)?y:(0,D.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(d,E,void 0)}updateValue(y,g,d,E){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const g=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(d,g,2)}onDidDefaultConfigurationChange(y,g){const d=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(y,g);this.trigger(E,d,7)}onDidPolicyConfigurationChange(y){const g=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(d,g,7)}trigger(y,g,d){const E=new v.ConfigurationChangeEvent(y,{data:g},this.configuration);E.source=d,E.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(J[217],Z([0,1,18,5]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends w.ErrorNoTelemetry{constructor(v,h=k.Unknown,m){super(v);this._message=v,this._code=h,this._detail=m,this.isHandled=h===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(v){return v instanceof R&&v._code===k.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof R&&v._code===k.NoResolverFound}static isHandled(v){return v instanceof R&&v.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[63],Z([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const C=m.indexOf("+");return C<0?m:m.substr(0,C)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(m){const{host:C,port:I}=h(m);if(typeof I=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:I}}e.parseAuthorityWithPort=D;function v(m,C){let{host:I,port:y}=h(m);return typeof y=="undefined"&&(y=C),{host:I,port:y}}e.parseAuthorityWithOptionalPort=v;function h(m){const C=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=m.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:m,port:void 0}}}),define(J[109],Z([0,1,25,5,63]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var v;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(v=e.ExtensionType||(e.ExtensionType={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,b){if(typeof E=="undefined"||E===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof E=="string"||typeof b=="string"){const p=typeof E=="string"?E:E.value,S=typeof b=="string"?b:b.value;return w.equalsIgnoreCase(p,S)}return E._lower===b._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=m;function C(d){return I(d)}e.isApplicationScopedExtension=C;function I(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function g(d,E){if(E){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return d.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[110],Z([0,1,25,192,109,4,7,18,34]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,w.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=m;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new I(i.identifier,n,o)}static parse(i){const n=C.exec(i);return n&&n[1]&&n[2]?new I({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof I?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=I;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const i=y.exec(s);return i&&i[1]?[E(i[1]),i[2]]:[E(s),void 0]}e.getIdAndVersion=g;function d(s,i){return`${s}.${i}`}e.getExtensionId=d;function E(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function b(s,i){return E(d(s,i))}e.getGalleryExtensionId=b;function p(s,i){const n=[],o=a=>{for(const l of n)if(l.some(P=>m(i(P),i(a))))return l;return null};for(const a of s){const l=o(a);l?l.push(a):n.push([a])}return n}e.groupByExtension=p;function S(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function f(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function u(s,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&n.every(l=>!m(l.identifier,{id:a}))){const l=s.filter(P=>m(P.identifier,{id:a}));l.length===1&&(n.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function c(s,i){if(!R.isLinux)return!1;let n;try{n=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function r(s,i){const n=await c(s,i),o=(0,t.getTargetPlatform)(n?"alpine":R.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(J[72],Z([0,1,8,17,2,32,7,110,14,5,6]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let I=class extends k.Disposable{constructor(g,d){super();this.fileService=g,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,d){return this.withProfileExtensions(d,E=>(E=E.filter(b=>g.some(([p])=>!(0,v.areSameExtensions)(b.identifier,p.identifier))),E.push(...g.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),E))}removeExtensionFromProfile(g,d){return this.withProfileExtensions(d,E=>E.filter(b=>!(0,v.areSameExtensions)(b.identifier,g)))}async withProfileExtensions(g,d){return this.getResourceAccessQueue(g).queue(async()=>{let E=[];try{const b=await this.fileService.readFile(g),p=JSON.parse(b.value.toString());for(const S of p){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}E.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(d){E=d(E);const b=E.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(g,t.VSBuffer.fromString(JSON.stringify(b)))}return E})}getResourceAccessQueue(g){let d=this.resourcesAccessQueueMap.get(g);return d||(d=new w.Queue,this.resourcesAccessQueueMap.set(g,d)),d}};I=ve([Y(0,h.IFileService),Y(1,C.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(J[218],Z([0,1,8,17,22,18,3,2,28,98,217,63]),function(q,e,w,t,k,R,D,v,h,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var g;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function d(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function E(B){const H=new k.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function b(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class p{constructor(H){this._state="pending",this._disposables=new v.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function S(B,H){const L=new p(H);return L.registerDisposable(B.onControlMessage(O=>{const N=JSON.parse(O.toString()),V=_(N);V?L.reject(V):L.resolve(N)})),L.promise}function f(B,H,L,O,N,V,Q,ne){const j=new p(ne);return H.connect(L,O,N,V,Q,(te,ie)=>{j.didTimeout?(te&&B.error(te),ie?.dispose()):te||!ie?j.reject(te):j.resolve(ie)}),j.promise}function u(B,H){const L=new p(H);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,H,L,O){const N=z(B,H);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await f(B.logService,B.socketFactory,B.host,B.port,(0,I.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${d(H)}-${B.reconnectionToken}`,O)}catch(ie){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ie),ie}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let Q,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),Q=B.reconnectionProtocol,ne=!1):(Q=new m.PersistentProtocol(V,null),ne=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const j=await u(B.signService.createNewMessage((0,h.generateUuid)()),O),te={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};Q.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await S(Q,b(O,E(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await u(B.signService.validate(j,ie.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const fe=await u(B.signService.sign(ie.data),O),ke={type:"connectionType",commit:B.commit,signedData:fe,desiredConnectionType:H};return L&&(ke.args=L),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:Q,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(ie)),ne&&$(Q),ie}}async function r(B,H,L,O){const N=Date.now(),V=z(B,H),{protocol:Q,ownsProtocol:ne}=await c(B,H,L,O),j=new p(O);return j.registerDisposable(Q.onControlMessage(te=>{const ie=JSON.parse(te.toString()),ce=_(ie);ce?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ce),ne&&$(Q),j.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ee(N)}!`),j.resolve({protocol:Q,firstMessage:ie}))})),j.promise}async function s(B,H){const{protocol:L}=await r(B,1,void 0,H);return{protocol:L}}async function i(B,H,L){const{protocol:O,firstMessage:N}=await r(B,2,H,L),V=N&&N.debugPort;return{protocol:O,debugPort:V}}async function n(B,H,L){const O=Date.now(),N=z(B,3),{protocol:V}=await c(B,3,H,L);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ee(O)}!`),V}async function o(B,H,L){const{host:O,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:N,connectionToken:V,reconnectionToken:H,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function a(B,H,L){return P(B,async O=>{const{protocol:N}=await s(O,k.CancellationToken.None);return new de(B,H,L,O.reconnectionToken,N)})}e.connectRemoteAgentManagement=a;async function l(B,H){return P(B,async L=>{const{protocol:O,debugPort:N}=await i(L,H,k.CancellationToken.None);return new K(B,H,L.reconnectionToken,O,N)})}e.connectRemoteAgentExtensionHost=l;async function P(B,H){const L=5;for(let O=1;;O++)try{const N=(0,h.generateUuid)(),V=await o(B,N,null);return await H(V)}catch(N){if(O<L)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(N);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(N),se.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(N)),N}}async function M(B,H,L){const O=await o(B,(0,h.generateUuid)(),null);return await n(O,{host:H,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,w.createCancelablePromise)(H=>new Promise((L,O)=>{const N=setTimeout(L,B*1e3);H.onCancellationRequested(()=>{clearTimeout(N),L()})}))}var W;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(W=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class x{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class re{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=le;class ue{constructor(H,L,O,N){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends v.Disposable{constructor(H,L,O,N,V){super();this._connectionType=H,this._options=L,this.reconnectionToken=O,this.protocol=N,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(N.onSocketClose(Q=>{const ne=F(this._connectionType,this.reconnectionToken,!0);Q?Q.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this._options.logService.error(Q.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this._options.logService.error(Q.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(Q=>{const ne=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,v.toDisposable)(()=>{const Q=se._instances.indexOf(this);Q>=0&&se._instances.splice(Q,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(H,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const N=O<L.length?L[O]:L[L.length-1];try{if(N>0){const Q=T(N);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,Q)),this._options.logService.info(`${H} waiting for ${N} seconds before reconnecting...`);try{await Q}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${H} resolving connection...`);const V=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,E(y)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,C.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(H,L,O):this._gotoPermanentFailure(H,L,O)}_gotoPermanentFailure(H,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,H,L,O)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class de extends se{constructor(H,L,O,N,V){super(1,H,N,V,!0);this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},H.ipcLogger))}async _reconnect(H,L){await s(H,L)}}e.ManagementPersistentConnection=de;class K extends se{constructor(H,L,O,N,V){super(2,H,O,N,!1);this._startArguments=L,this.debugPort=V}async _reconnect(H,L){await i(H,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function $(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,R.onUnexpectedError)(H)}}function _(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function A(B,H){for(;B.length<H;)B+=" ";return B}function F(B,H,L){return`[remote-connection][${A(d(B),13)}][${H.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,H){return`${F(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ee(B){return`${Date.now()-B} ms`}}),define(J[219],Z([0,1,77,83]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,v,h,m){const C=y=>m(y,void 0),I=w.createConnection({host:k,port:R},()=>{I.removeListener("error",C);const y=Buffer.alloc(16);for(let b=0;b<16;b++)y[b]=Math.round(Math.random()*256);const g=y.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${v}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];I.write(d.join(`\r
`)+`\r
\r
`);const E=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",E),m(void 0,new t.NodeSocket(I,h)))};I.on("data",E)});I.setNoDelay(!0),I.once("error",C)}}}),define(J[54],Z([0,1,17,168,62,5,46]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function v(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=v;function h(E){return E.res.statusCode===204}async function m(E){return h(E)?null:(await(0,w.streamToBuffer)(E.stream)).toString()}e.asText=m;async function C(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);return m(E)}e.asTextOrError=C;async function I(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);if(h(E))return null;const p=(await(0,w.streamToBuffer)(E.stream)).toString();try{return JSON.parse(p)}catch(S){throw S.message+=`:
`+p,S}}e.asJson=I;function y(E){d(E)}e.updateProxyConfigurationsScope=y;let g;function d(E){const b=D.Registry.as(k.Extensions.Configuration),p=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[g],remove:p?[p]:[]})}d(2)}),define(J[220],Z([0,1,17,22]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(v){this.service=v}listen(v,h){throw new Error("Invalid listen")}call(v,h,m,C=t.CancellationToken.None){switch(h){case"request":return this.service.request(m[0],C).then(async({res:I,stream:y})=>{const g=await(0,w.streamToBuffer)(y);return[{statusCode:I.statusCode,headers:I.headers},g]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(v){this.channel=v}async request(v,h){const[m,C]=await this.channel.call("request",[v],h);return{res:m,stream:(0,w.bufferToStream)(C)}}async resolveProxy(v){return this.channel.call("resolveProxy",[v])}}e.RequestChannelClient=R}),define(J[221],Z([0,1,222,12]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,v){return D.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:D.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(D,v,h={}){const m=(0,w.parse)(D),C=h.proxyUrl||k(m,v);if(!C)return null;const I=(0,w.parse)(C);if(!/^https?:$/.test(I.protocol||""))return null;const y={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,t.isBoolean)(h.strictSSL)?h.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((g,d)=>{q(["http-proxy-agent"],g,d)}))(y):new(await new Promise((g,d)=>{q(["https-proxy-agent"],g,d)}))(y)}e.getProxyAgent=R}),define(J[111],Z([0,1,51,9,169,22,44,18,4,28,145,59,8]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const g=1e4;let d;async function E(p,S,f){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(f)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(u,c)=>{const r=new R.CancellationTokenSource,s=setTimeout(()=>{r.dispose(!0),c(new Error((0,k.localize)(0,null)))},g);try{u(await b(p,r.token))}catch(i){!(0,v.isCancellationError)(i)&&!r.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):u({})}finally{clearTimeout(s),r.dispose()}})),d)}e.getResolvedShellEnv=E;async function b(p,S){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",u);const c=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const i=await(0,C.getSystemShell)(h.OS,s);return p.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(S.isCancellationRequested)return o((0,v.canceled)());const a=(0,t.basename)(i);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const T=(0,w.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});S.onCancellationRequested(()=>(T.kill(),o((0,v.canceled)()))),T.on("error",x=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(x)),o(x)});const W=[];T.stdout.on("data",x=>W.push(x));const U=[];T.stderr.on("data",x=>U.push(x)),T.on("close",(x,re)=>{const le=Buffer.concat(W).toString("utf8");p.trace("getUnixShellEnvironment#raw",le);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&p.trace("getUnixShellEnvironment#stderr",ue),x||re)return o(new Error((0,k.localize)(2,null,x,re)));const se=r.exec(le),de=se?se[1]:"{}";try{const K=JSON.parse(de);f?K.ELECTRON_RUN_AS_NODE=f:delete K.ELECTRON_RUN_AS_NODE,u?K.ELECTRON_NO_ATTACH_CONSOLE=u:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",K),n(K)}catch(K){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),o(K)}})})}}),define(J[87],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[223],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const v=String(w._nextId++);return this.validators.set(v,D),{id:v,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=w,w._nextId=1}),define(J[41],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[21],Z([0,1,15,40,8,3,2,4,34,12,5,6,41,26]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var d;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var E;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen"})(E=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class bt extends D.Disposable{constructor(S,f,u){super();this.logService=S,this.stateMainService=f,this.environmentMainService=u,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(bt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(bt.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),v.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",S);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!v.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",f),w.app.once("will-quit",u=>{this.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",S),w.app.removeListener("window-all-closed",f),w.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:S,join(u){f.push(u)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(u){this.logService.error(u)}try{await this.stateMainService.close()}catch(u){this.logService.error(u)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let f=this.phaseWhen.get(S);f||(f=new k.Barrier,this.phaseWhen.set(S,f)),await f.wait()}registerWindow(S){const f=new D.DisposableStore;this.windowCounter++,f.add(S.onWillLoad(c=>this._onWillLoadWindow.fire({window:S,workspace:c.workspace,reason:c.reason})));const u=(0,m.assertIsDefined)(S.win);u.on("close",c=>{const r=S.id;if(this.windowToCloseRequest.has(r)){this.windowToCloseRequest.delete(r);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),c.preventDefault(),this.unload(S,1).then(s=>{if(s){this.windowToCloseRequest.delete(r);return}this.windowToCloseRequest.add(r),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this._onBeforeCloseWindow.fire(S),S.close()})}),u.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!v.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,f){await this.unload(S,3)||S.reload(f)}unload(S,f){const u=this.mapWindowIdToPendingUnload.get(S.id);if(u)return u;const c=this.doUnload(S,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,c),c}async doUnload(S,f){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const u=this._quitRequested?2:f,c=await this.onBeforeUnloadWindowInRenderer(S,u);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(S,u),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,f){return new Promise(u=>{const c=this.oneTimeListenerTokenGenerator++,r=`vscode:ok${c}`,s=`vscode:cancel${c}`;t.validatedIpcMain.once(r,()=>{u(!1)}),t.validatedIpcMain.once(s,()=>{u(!0)}),S.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:f})})}onWillUnloadWindowInRenderer(S,f){return new Promise(u=>{const r=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(r,()=>u()),S.send("vscode:onWillUnload",{replyChannel:r,reason:f})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(bt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(S?.addArgs&&f.push(...S.addArgs),S?.removeArgs)for(const r of S.removeArgs){const s=f.indexOf(r);s>=0&&f.splice(s,1)}const u=()=>{try{if(v.isWindows){const r=(0,h.cwd)();r!==process.cwd()&&process.chdir(r)}}catch(r){this.logService.error(r)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:f})};w.app.once("quit",u),await this.quit(!0)&&w.app.removeListener("quit",u)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of w.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let u;f.webContents&&!f.webContents.isDestroyed()?u=new Promise(c=>f.once("closed",c)):u=Promise.resolve(),f.destroy(),await u}})()]),w.app.exit(S)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=ve([Y(0,I.ILogService),Y(1,y.IStateMainService),Y(2,g.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(J[224],Z([0,1,4,3,2,5,21]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let v=class extends k.Disposable{constructor(C){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((I,y)=>{q(["native-keymap"],I,y)});this._keyboardLayoutData=h(C),w.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};v=ve([Y(0,D.ILifecycleMainService)],v),e.KeyboardLayoutMainService=v;function h(m){const C=m.getKeyMap(),I=m.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:I}}}),define(J[225],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(J[226],Z([0,1,8,17,12,36,14,6]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(I,y,g){this.storagePath=I,this.logService=y,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,y){const g=this.storage[I];return(0,k.isUndefinedOrNull)(g)?y:g}setItem(I,y){this.setItems([{key:I,data:y}])}setItems(I){let y=!1;for(const{key:g,data:d}of I)this.storage[g]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[g])||(this.storage[g]=void 0,y=!0):(this.storage[g]=d,y=!0));y&&this.save()}removeItem(I){(0,k.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(I){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),I)}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let m=class{constructor(I,y,g){this.fileStorage=new h(I.stateResource,y,g)}async init(){await this.fileStorage.init()}getItem(I,y){return this.fileStorage.getItem(I,y)}};m=ve([Y(0,R.IEnvironmentService),Y(1,v.ILogService),Y(2,D.IFileService)],m),e.StateService=m}),define(J[227],Z([0,1,226]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends w.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(J[112],Z([0,1,4,34,7,28]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function v(m,C,I,y,g,d,E,b,p,S){const f=Object.create(null);f["common.machineId"]=E,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=g,f.version=d,f["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,w.PlatformToString)(w.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=y,f["common.product"]=S||"desktop",b&&(f["common.msftInternal"]=b);let u=0;const c=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),w.isLinuxSnap&&(f["common.snap"]="true");const r=D(I);r&&(f["common.platformDetail"]=r);try{const s=await m.readFile(k.URI.file(p));f["common.source"]=s.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=v;function h(m){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const I=C.toLowerCase();return m.some(y=>I===y)}e.verifyMicrosoftInternalDomain=h}),define(J[37],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[228],Z([0,1,30,57,8,43,13,9,4,7,81,23,97,84,14,20,37]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function S(s,i){const n=`${s}::${i.join(":")}`,o=p.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function T(U,x,re,le){const ue=x.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let de;try{de=await I.Promises.readdir(x,{withFileTypes:!0})}catch{se();return}if(le.count>=M){le.count+=de.length,le.maxReached=!0,se();return}let K=de.length;if(K===0){se();return}let $=de;le.count+de.length>M&&(le.maxReached=!0,K=M-le.count,$=de.slice(0,K)),le.count+=de.length;for(const _ of $)if(_.isDirectory()){if(re.includes(_.name)||await T(U,(0,v.join)(x,_.name),re,le),--K==0){se();return}}else{const A=_.name.lastIndexOf(".");if(A>=0){const F=_.name.substring(A+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of a)F.relativePathPattern?.test(ue)!==!1&&F.filePattern.test(_.name)&&P.set(F.tag,(P.get(F.tag)??0)+1);if(--K==0){se();return}}})}const W=k.Promises.withAsyncBody(async U=>{const x={count:0,maxReached:!1};await T(s,s,i,x);const re=await c(s);U({configFiles:f(P),fileTypes:f(l),fileCount:x.count,maxFilesReached:x.maxReached,launchConfigFiles:re})});return p.set(n,W),W}e.collectWorkspaceStats=S;function f(s){return[...t.Iterable.map(s.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const s={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},i=w.cpus();return i&&i.length>0&&(s.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),s}e.getMachineInfo=u;async function c(s){try{const i=new Map,n=(0,v.join)(s,".vscode","launch.json"),o=await I.Promises.readFile(n),a=[],l=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=c;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const o=w.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(w.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||n.push(`Load (avg):       ${w.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,l]=o,P=this.formatProcessList(i,a);return n.forEach(M=>{if((0,g.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const W=M.workspaceMetadata[T];let U=`${W.fileCount} files`;W.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${T}): ${U}`,l+=this.formatWorkspaceStats(W)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:l,cpus:P}=u(),M={os:l,memory:o,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return h.isWindows||(M.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),h.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,n){const o=[];return(0,y.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,g.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),o.push(`Folder (${P}): ${T}`),o.push(this.formatWorkspaceStats(M))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const l=(W,U)=>{const x=` ${W}(${U})`;a+x.length>o?(n.push(P),P="|                 ",a=P.length):a+=x.length,P+=x};let P="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let W=0;W<T;W++){const U=i.fileTypes[W];l(U.name,U.count)}if(n.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(W=>{l(W.name,W.count)}),n.push(P)),i.launchConfigFiles.length>0){let W="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{W+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),n.push(W)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const P=m.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;o.push(S(M,["node_modules",".git"]).then(T=>{let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),n.push(`|    Folder (${(0,v.basename)(M)}): ${W}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else n.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,l){const P=l===0;let M;P?M=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(M=`${M} (${n.get(a.pid)})`));const T=process.platform==="win32"?a.mem:w.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(W=>this.formatProcessItem(i,n,o,W,l+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const a=m.URI.revive(o);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await S(l,["node_modules",".git"])).fileTypes.forEach(M=>n.add(M.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=m.URI.revive(n);if(o.scheme!==D.Schemas.file)continue;const a=o.fsPath;try{const l=await S(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};r=ve([Y(0,b.ITelemetryService),Y(1,E.IProductService)],r),e.DiagnosticsService=r}),define(J[229],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:v,data:h}){return this.appenders.forEach(m=>m.log(v,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,v=>`Failed to log telemetry: ${console.warn(v)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(J[73],Z([0,1,50,93,12,19,112,37]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,s){return Promise.resolve(void 0)}publicLog2(r,s){return this.publicLog(r,s)}publicLogError(r,s){return Promise.resolve(void 0)}publicLogError2(r,s){return this.publicLogError(r,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class m{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(c,r){return r.onDidChangeConfiguration(s=>{s.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=C;function I(c,r){return!(r.disableTelemetry||!c.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=I;function y(c){const r=c.getValue(v.TELEMETRY_SETTING_ID),s=c.getValue("telemetry.enableCrashReporter");if(c.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function g(c){const r={},s={},i={};b(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?s[n]=o:typeof o=="boolean"?s[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),r[n]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(r[n]=o)}return{properties:r,measurements:s}}e.validateTelemetryData=g;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function E(c){if(!c)return"none";for(const r of d)if(c.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=E;function b(c,r,s=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const o=c[n],a=i?i+n:n;Array.isArray(o)?r[a]=(0,w.safeStringify)(o):o instanceof Date?r[a]=o.toISOString():(0,k.isObject)(o)?s<2?b(o,r,s+1,a+"."):r[a]=(0,w.safeStringify)(o):r[a]=o}}function p(c){if(!c)return[];const r=[];return S(r,"",c),r}function S(c,r,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(i=>S(c,r?`${r}.${i}`:i,s[i])):c.push(r)}function f(c,r){const s=c.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||i}e.isInternalTelemetry=f;function u(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=u}),define(J[230],Z([0,1,189,73]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,v,h,m,C,I){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},g=await(0,w.getServiceMachineId)(v,m,C),{sessionId:d}=await I.getTelemetryInfo();return(0,t.supportsTelemetry)(D,v)&&(0,t.getTelemetryLevel)(h)===3&&(y["X-Market-User-Id"]=g,y["VSCode-SessionId"]=d),y}e.resolveMarketplaceHeaders=k}),define(J[231],Z([0,1,2,50,93,4,25,170,19,62,53,20,46,37,73]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(S,f,u){this._configurationService=f,this._productService=u,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,f){this._experimentProperties[S]=f}_updateTelemetryLevel(){let S=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;S=Math.min(S,u)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,f=S.sessionID,u=S["common.machineId"],c=S["common.firstSessionDate"],r=S["common.msftInternal"];return{sessionId:f,machineId:u,firstSessionDate:c,msftInternal:r}}dispose(){this._disposables.dispose()}_log(S,f,u,c){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(r=>{u=(0,t.mixin)(u,r),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,s=>{if(typeof s=="string")return this._cleanupInfo(s,c)}),this._appenders.forEach(s=>s.log(S,u))},r=>{console.error(r)})}publicLog(S,f,u){return this._log(S,3,f,u)}publicLog2(S,f,u){return this.publicLog(S,f,u)}publicLogError(S,f){return this._sendErrorTelemetry?this._log(S,2,f,!0):Promise.resolve(void 0)}publicLogError2(S,f){return this.publicLogError(S,f)}_anonymizeFilePaths(S){let f=S;const u=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(S);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(f="";;){const i=r.exec(S);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(f+=S.substring(s,i.index)+"<REDACTED: user-file-path>",s=r.lastIndex)}return s<S.length&&(f+=S.substr(s)),f}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const f=S.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(f))return`<REDACTED: ${c.label}>`;return S}_cleanupInfo(S,f){let u=S;f&&(u=this._anonymizeFilePaths(u));for(const c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ve([Y(1,h.IConfigurationService),Y(2,I.IProductService)],E),e.TelemetryService=E;function b(){const p=(0,v.localize)(0,null,C.default.nameLong),S=C.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,v.localize)(3,null),u=(0,v.localize)(4,null),c=(0,v.localize)(5,null),r=(0,v.localize)(6,null),s=(0,v.localize)(7,null),i=`
|       | ${u} | ${c} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,v.localize)(8,null);return`
${p} ${S} ${f}

&nbsp;

${s}
${i}

&nbsp;

${n}
`}y.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:b(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(m.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,v.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,v.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[232],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(w=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===w.HIGH_CONTRAST_DARK||R===w.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===w.DARK||R===w.HIGH_CONTRAST_DARK}e.isDark=k}),define(J[233],Z([0,1,122,3,2,5,46,232]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var h;(function(b){function p(S){return S&&typeof S=="object"&&typeof S.id=="string"}b.isThemeColor=p})(h=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var C;(function(b){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||h.isThemeColor(n.color))}b.isThemeIcon=p;const S=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const o=S.exec(n);if(!o)return;const[,a]=o;return{id:a}}b.fromString=f;function u(n){return{id:n}}b.fromId=u;function c(n,o){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),o&&(a=`${a}~${o}`),{id:a}}b.modify=c;function r(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}b.getModifier=r;function s(n,o){return n.id===o.id&&n.color?.id===o.color?.id}b.isEqual=s;function i(n,o){return{id:n.id,color:o?m(o):void 0}}b.asThemeIcon=i,b.asClassNameArray=w.CSSIcon.asClassNameArray,b.asClassName=w.CSSIcon.asClassName,b.asCSSSelector=w.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function I(b){switch(b){case v.ColorScheme.DARK:return"vs-dark";case v.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case v.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(p);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const g=new y;D.Registry.add(e.Extensions.ThemingContribution,g);function d(b){return g.onColorThemeChange(b)}e.registerThemingParticipant=d;class E extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,S){let f=this.theme.getColor(p);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=E}),define(J[64],Z([0,1,15,3,2,4,19,5,41]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",C="#1E1E1E",I="#000000",y="#FFFFFF",g="theme",d="themeBackground",E="windowSplash";e.IThemeMainService=(0,v.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(S,f){super();this.stateMainService=S,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&w.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?I:y;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(g,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=I;break;case"hc-light":f=y;break;default:f=C}return R.isMacintosh&&f.toUpperCase()===C&&(f="#171717"),f}saveWindowSplash(S,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:E,data:f}]),typeof S=="number"&&this.updateBackgroundColor(S,f)}updateBackgroundColor(S,f){for(const u of w.BrowserWindow.getAllWindows())if(u.id===S){u.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};b=ve([Y(0,h.IStateMainService),Y(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(J[113],Z([0,1,3,4,5,6]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(E){E.Http="http",E.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var v;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(v=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=I;function y(E,b){return b?b!==1&&E<1024:!t.isWindows&&E<1024}e.isPortPrivileged=y;class g{constructor(b,p,S){this.remoteAddress=b,this.localAddress=p,this._dispose=S,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let d=class{constructor(b){this.logService=b,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const S of p){const f=Array.from(S.values());for(const u of f){const c=await u.value;c&&b.push(c)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(S=>S?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,p,S,f,u=!1,c,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${f}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(b,p,S,f,u,c,r);return s?s.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==p||i.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const S=p.get(b.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,S))}}}}async tryDisposeTunnel(b,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const f=S.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),f}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const S=this._tunnels.get(b);if(S&&S.has(p)){const f=S.get(p);f.refcount=0,await this.tryDisposeTunnel(b,p,f)}}addTunnelToMap(b,p,S){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(b,p){const S=this._tunnels.get(b);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const S=[b];C(b)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):I(b)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const f=S.map(u=>this._tunnels.get(u));for(const u of f){const c=u?.get(p);if(c)return c}}canTunnel(b){return!!m(b)}createWithProvider(b,p,S,f,u,c,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${f}.`);const s=S;this._factoryInProgress.add(s);const n={elevationRequired:u?y(f===void 0?S:f):!1},o={remoteAddress:{host:p,port:S},localAddressPort:f,privacy:c,public:c?c!==v.Private:void 0,protocol:r},a=b.forwardPort(o,n);return a?(this.addTunnelToMap(p,S,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),a}};d=ve([Y(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(J[234],Z([0,1,77,92,219,8,2,19,6,20,218,113,87]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(S,f,u,c,r){let s;for(let i=3;i&&(s?.dispose(),s=await new d(S,f,u,c,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));i--);return s}class d extends D.Disposable{constructor(f,u,c,r,s){super();this.defaultTunnelHost=u,this.suggestedLocalPort=s,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(f){f.pause();const u=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,C.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),r=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&f.write(s.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.end()}),f.on("close",()=>r.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.destroy()}),r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),f.pipe(r),r.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),r.end()})}}let E=class extends I.AbstractTunnelService{constructor(f,u,c,r,s){super(u);this.socketFactory=f,this.signService=c,this.productService=r,this.configurationService=s}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,u,c,r,s,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,r,s,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${r}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=g(a,this.defaultTunnelHost,u,c,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};E=ve([Y(1,h.ILogService),Y(2,y.ISignService),Y(3,m.IProductService),Y(4,v.IConfigurationService)],E),e.BaseTunnelService=E;let b=class extends E{constructor(f,u,c,r){super(k.nodeSocketFactory,f,u,c,r)}};b=ve([Y(0,h.ILogService),Y(1,y.ISignService),Y(2,m.IProductService),Y(3,v.IConfigurationService)],b),e.TunnelService=b;let p=class extends D.Disposable{constructor(f,u,c,r){super();this.logService=f,this.productService=u,this.signService=c,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(f,u,c,r,s,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${r} on local port ${s}.`),!this._tunnelServices.has(f)){const a=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(f,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(u,c,r,s,i,n,o)}};p=ve([Y(0,h.ILogService),Y(1,m.IProductService),Y(2,y.ISignService),Y(3,v.IConfigurationService)],p),e.SharedTunnelsService=p}),define(J[47],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[235],Z([0,1,4,171,62,46]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[236],Z([0,1,3,47]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(v){this.service=v}listen(v,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(v,h,m){switch(h){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=k;class R{constructor(v){this.channel=v,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(v){this._state=v,this._onStateChange.fire(v)}checkForUpdates(v){return this.channel.call("checkForUpdates",v)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(v){return this.channel.call("_applySpecificUpdate",v)}}e.UpdateChannelClient=R}),define(J[88],Z([0,1,8,22,3,19,26,21,6,20,54,47]),function(q,e,w,t,k,R,D,v,h,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(d,E,b){return`${b.updateUrl}/api/update/${d}/${E}/${b.commit}`}e.createUpdateURL=y;let g=class{constructor(E,b,p,S,f,u){this.lifecycleMainService=E,this.configurationService=b,this.environmentMainService=p,this.requestService=S,this.logService=f,this.productService=u,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const E=this.getUpdateMode(),b=this.getProductQuality(E);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),E==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}E==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(E){return E==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(E=60*60*1e3){return(0,w.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(E){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(E){}getUpdateType(){return 1}doQuitAndInstall(){}};g=ve([Y(0,v.ILifecycleMainService),Y(1,R.IConfigurationService),Y(2,D.IEnvironmentMainService),Y(3,C.IRequestService),Y(4,h.ILogService),Y(5,m.IProductService)],g),e.AbstractUpdateService=g}),define(J[237],Z([0,1,15,52,3,2,19,26,21,6,20,54,37,47,88]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let E=class extends d.AbstractUpdateService{constructor(p,S,f,u,c,r,s){super(p,S,u,c,r,s);this.telemetryService=f,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,S,f)=>({url:S,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,S,f,u)=>({releaseNotes:S,version:f,productVersion:f,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(g.State.Idle(1,f))}buildUpdateFeedUrl(p){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(S,p,this.productService);try{w.autoUpdater.setFeedURL({url:f})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return f}doCheckForUpdates(p){this.setState(g.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(g.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(g.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(g.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],E.prototype,"onRawError",null),ve([t.memoize],E.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateAvailable",null),ve([t.memoize],E.prototype,"onRawUpdateDownloaded",null),E=ve([Y(0,h.ILifecycleMainService),Y(1,D.IConfigurationService),Y(2,y.ITelemetryService),Y(3,v.IEnvironmentMainService),Y(4,I.IRequestService),Y(5,m.ILogService),Y(6,C.IProductService)],E),e.DarwinUpdateService=E}),define(J[238],Z([0,1,51,29,8,3,9,26,21,6,37,47]),function(q,e,w,t,k,R,D,v,h,m,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(E,b,p){if(this.lifecycleMainService=E,this.logService=p,this._state=I.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}get state(){return this._state}setState(E){this.logService.info("update#setState",E.type),this._state=E,this._onStateChange.fire(E)}scheduleCheckForUpdates(E=60*60*1e3){return(0,k.timeout)(E).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(E){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(E)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(E){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(E=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${E}`),!E&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(E){}};y=ve([Y(0,h.ILifecycleMainService),Y(1,v.IEnvironmentMainService),Y(2,m.ILogService)],y);let g=class extends y{constructor(E,b,p,S,f,u){super(p,S,f);this.snap=E,this.snapRevision=b,this.telemetryService=u;const c=(0,t.watch)(D.dirname(this.snap)),r=R.Event.fromNodeEventEmitter(c,"change",(o,a)=>a),s=R.Event.filter(r,o=>o==="current"),n=R.Event.debounce(s,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(E=>{E?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,E.message||E))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const E=await new Promise((p,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,u)=>f?S(f):p(u))),b=D.basename(E);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,E=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=ve([Y(2,h.ILifecycleMainService),Y(3,v.IEnvironmentMainService),Y(4,m.ILogService),Y(5,C.ITelemetryService)],g),e.SnapUpdateService=g}),define(J[55],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(J[239],Z([0,1,55,190,14,16,128,3,2]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(y){this.uri=y,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let C=class{constructor(y){this._fileService=y,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,d=E=>{let b=g.get(E.scheme);return b===void 0&&(b=y.hasProvider(E)&&!this._fileService.hasCapability(E,1024),g.set(E.scheme,b)),b};this._dispooables.add(v.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((E,b)=>this.extUri.compare(E,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,R.normalizePath)(y));const g=this._canonicalUris.get(y);return g?g.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new m(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((d,E)=>d[1].touch<E[1].touch?1:d[1].touch>E[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let d=0;d<g;d++)this._canonicalUris.set(y[d][0],y[d][1].touch())}};C=ve([Y(0,k.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(w.IUriIdentityService,C,!0)}),define(J[114],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[240],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(v){this.handler=v}listen(v,h){throw new Error(`Event not found: ${h}`)}call(v,h,m){switch(h){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=t;class k{constructor(v){this.channel=v}handleURL(v,h){return this.channel.call("handleURL",[v.toJSON(),h])}}e.URLHandlerChannelClient=k;class R{constructor(v){this.next=v}async routeCall(v,h,m,C){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(m){const I=w.URI.revive(m);if(I&&I.query){const y=/\bwindowId=(\d+)/.exec(I.query);if(y){const g=y[1],d=new RegExp(`window:${g}`),E=v.connections.find(b=>d.test(b.ctx));if(E)return E}}}return this.next.routeCall(v,h,m,C)}routeEvent(v,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=R}),define(J[241],Z([0,1,8,2,7,20]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,C){const I=[...this.handlers.values()];return(0,w.first)(I.map(y=>()=>y.handleURL(m,C)),void 0,!1).then(y=>y||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=D;let v=class extends D{constructor(m){super();this.productService=m}create(m){let{authority:C,path:I,query:y,fragment:g}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:C,path:I,query:y,fragment:g})}};v=ve([Y(0,R.IProductService)],v),e.NativeURLService=v}),define(J[242],Z([0,1,15,8,3,2,4,7]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(C){try{return v.URI.parse(C)}catch{return null}}class m{constructor(I,y,g,d,E){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=I,D.isWindows){const S=d.isBuilt?[]:[`"${d.appRoot}"`];S.push("--open-url","--"),w.app.setAsDefaultProtocolClient(E.urlProtocol,process.execPath,S)}const b=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(S,f)=>({event:S,url:f})),({event:S,url:f})=>(S.preventDefault(),f));this.disposables.add(b(S=>{const f=h(S);!f||this.urlService.open(f,{originalUrl:S})})),g.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(g.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||I.push(y);I.length!==0&&(this.uris=I,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[243],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[244],Z([0,1,15,2,13,7]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}handleWebviewRequest(h,m){try{const C=R.URI.parse(h.url),I=D.validWebviewFilePaths.get(C.path);if(typeof I=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${I}`,g=k.FileAccess.asFileUri(y,q);return m(decodeURIComponent(g.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(J[74],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function k(C){return!!C.folderUri}e.isFolderToOpen=k;function R(C){return!!C.fileUri}e.isFileToOpen=R;function D(C){const I=v(C),y=C.getValue("window.menuBarVisibility");return y==="default"||I==="native"&&y==="compact"||w.isMacintosh&&w.isNative?"classic":y}e.getMenuBarVisibility=D;function v(C){if(w.isWeb)return"custom";const I=C.getValue("window");if(I){if(w.isMacintosh&&I.nativeTabs===!0||w.isMacintosh&&I.nativeFullScreen===!1)return"native";const d=I.titleBarStyle;if(d==="native"||d==="custom")return d}return w.isLinux?"native":"custom"}e.getTitleBarStyle=v;function h(C,I){if(!w.isWindows||w.isWeb||!I.isBuilt||v(C)==="native")return!1;const y=C.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!1}e.useWindowControlsOverlay=h;function m(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=m}),define(J[115],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(v){v[v.INITIAL=1]="INITIAL",v[v.LOAD=2]="LOAD",v[v.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var t;(function(v){v[v.CLOSE=1]="CLOSE",v[v.QUIT=2]="QUIT",v[v.RELOAD=3]="RELOAD",v[v.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(v=1){return{width:1024,height:768,mode:v}};e.defaultWindowState=k;var R;(function(v){v[v.Maximized=0]="Maximized",v[v.Normal=1]="Normal",v[v.Minimized=2]="Minimized",v[v.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(v){v[v.UNRESPONSIVE=1]="UNRESPONSIVE",v[v.CRASHED=2]="CRASHED",v[v.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(J[33],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(J[245],Z([0,1,15,22,3,66,2,28,69,103,6,20,33]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(E){E[E.Initial=1]="Initial",E[E.StoredCredentialsUsed=2]="StoredCredentialsUsed",E[E.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let d=class extends D.Disposable{constructor(b,p,S,f,u){super();this.logService=b,this.windowsMainService=p,this.credentialsService=S,this.encryptionMainService=f,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(w.app,"login",(p,S,f,u,c)=>({event:p,webContents:S,req:f,authInfo:u,callback:c}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:S,callback:f}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(u?.username,u?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let S,f;try{const s=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(s){const i=JSON.parse(await this.encryptionMainService.decrypt(s));S=i.username,f=i.password}}catch(s){this.logService.error(s)}if(this.state!==g.StoredCredentialsUsed&&typeof S=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:S,password:f};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:b,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,v.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=g.LoginDialogShown;const r=await new Promise(s=>{const i=async(n,o,a)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),a){const l={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(P){this.logService.error(P)}s({username:l.username,password:l.password})}else s(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=r,r}};d=ve([Y(0,C.ILogService),Y(1,y.IWindowsMainService),Y(2,h.ICredentialsMainService),Y(3,m.IEncryptionMainService),Y(4,I.IProductService)],d),e.ProxyAuthHandler=d}),define(J[246],Z([0,1,69,6,36,20,33,202]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends v.BaseCredentialsMainService{constructor(C,I,y,g){super(C);this.environmentMainService=I,this.productService=y,this.windowsMainService=g,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((I,y)=>{q(["keytar"],I,y)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};h=ve([Y(0,t.ILogService),Y(1,k.INativeEnvironmentService),Y(2,R.IProductService),Y(3,D.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(J[247],Z([0,1,18,2,3,6,21,79,51,276,8,13,50,4,34,15,33]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=E.UtilityProcess,S=typeof p!="undefined";let f=class At{constructor(s,i,n){this._logService=s,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(s){const i=this._extHosts.get(s);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(s){return this._getExtHost(s).onStdout}onDynamicStderr(s){return this._getExtHost(s).onStderr}onDynamicMessage(s){return this._getExtHost(s).onMessage}onDynamicError(s){return this._getExtHost(s).onError}onDynamicExit(s){return this._getExtHost(s).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(s){if(this._shutdown)throw(0,w.canceled)();const i=String(++At._lastId);let n;if(s){if(!S)throw new Error("Cannot use UtilityProcess!");n=new c(i,this._logService,this._windowsMainService)}else n=new u(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:o,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(s,i){if(this._shutdown)throw(0,w.canceled)();return this._getExtHost(s).start(i)}async enableInspectPort(s){if(this._shutdown)throw(0,w.canceled)();const i=this._extHosts.get(s);return i?i.enableInspectPort():!1}async kill(s){if(this._shutdown)throw(0,w.canceled)();const i=this._extHosts.get(s);!i||i.kill()}async _killAllNow(){for(const[,s]of this._extHosts)s.kill()}async _waitForAllExit(s){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(s));return C.Promises.settled(i).then(()=>{})}};f._lastId=0,f=ve([Y(0,R.ILogService),Y(1,D.ILifecycleMainService),Y(2,b.IWindowsMainService)],f),e.ExtensionHostStarter=f;let u=class extends t.Disposable{constructor(s,i){super();this.id=s,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){g.isCI&&this._logService.info("Calling fork to start extension host...");const i=v.StopWatch.create(!1);this._process=(0,h.fork)(I.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,d.cwd)()},s));const n=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const a=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const l=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,w.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(s)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${s}ms.`),this._process.kill())}};u=ve([Y(1,R.ILogService)],u);let c=class extends t.Disposable{constructor(s,i,n){super();this.id=s,this._logService=i,this._windowsMainService=n,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){const i=this._windowsMainService.getWindowById(s.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=I.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=s.execArgv||[],M={...s.env};for(const re of Object.keys(M))M[re]=String(M[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(a,l,{serviceName:o,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(T(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const W=(re,le)=>{le.type==="Utility"&&le.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};E.app.on("child-process-gone",W),this._register((0,t.toDisposable)(()=>{E.app.off("child-process-gone",W)}));const{port1:U,port2:x}=new E.MessageChannelMain;this._process.postMessage("port",null,[x]),n.webContents.postMessage(s.responseChannel,s.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):g.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(s)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${s}ms, will kill it now.`),this._process.kill())}};c=ve([Y(1,R.ILogService),Y(2,b.IWindowsMainService)],c)}),define(J[248],Z([0,1,15,3,2,244,33]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends k.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,C){let I;if(typeof m.windowId=="number"){const{windowId:y}=m,g=this.windowsMainService.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);I=g.win.webContents}else{const{webContentsId:y}=m;if(I=w.webContents.fromId(y),!I)throw new Error(`Invalid webContentsId: ${y}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(C)}async findInFrame(m,C,I,y){const d=this.getFrameByName(m,C);if(typeof d.findInFrame=="function"){d.findInFrame(I,{findNext:y.findNext,forward:y.forward});const E=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",E))};d.on("found-in-frame",E)}}async stopFindInFrame(m,C,I){const g=this.getFrameByName(m,C);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,C){const I=this.windowsMainService.getWindowById(m.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${m}`);const y=I.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===C);if(!y)throw new Error(`Unknown frame: ${C}`);return y}};v=ve([Y(0,D.IWindowsMainService)],v),e.WebviewMainService=v}),define(J[249],Z([0,1,8,3,2]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:v,onDidFocusWindow:h,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(v,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(v){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=v}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(J[27],Z([0,1,175,9,32,16,7,5,13]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,v.createDecorator)("contextService");function m(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m;function C(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=C;function I(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=I;function y(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=y;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function E(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=E;class b{constructor(n,o,a,l,P){this._id=n,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(i){return new p({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=c;function r(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=r;function s(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===f}e.hasWorkspaceFileExtension=s}),define(J[250],Z([0,1,76,29,31,13,9,4,16,7,23,179,19,26,14,6,178,27]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(u,c,r){this.configurationService=c,this.logService=r,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,i)=>(0,k.isEqual)(s,i,!v.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:m.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let r=[];try{Array.isArray(u.folderWorkspaceInfos)?r=u.folderWorkspaceInfos.map(s=>({folderUri:m.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(r=u.folderURIWorkspaces.map(s=>({folderUri:m.URI.parse(s),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(r),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(s=>u.workspace.id===s.workspace.id)||(this.workspaces.push(u),this.saveSync());const r=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(r,c),r}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(r){this.logService.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,r=this.workspaces.findIndex(s=>s.workspace.id===c);r!==-1&&(this.workspaces.splice(r,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(r=>this.backupUriComparer.isEqual(u,r.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const r=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,r))||(this.emptyWindows.push({backupFolder:r,remoteAuthority:c}),this.saveSync()),this.getBackupPath(r)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,D.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,r=[];for(const s of u){const i=s.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==R.Schemas.file||await C.Promises.exists(i.configPath.fsPath)?r.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return r}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],r=new Set;for(const s of u){const i=s.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!r.has(n)){r.add(n);const o=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await C.Promises.exists(i.fsPath)?c.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],r=new Set;for(const s of u){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(s):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await C.Promises.exists(u)&&await C.Promises.rm(u,C.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));)c=this.getRandomEmptyWindowId();const r=this.getBackupPath(c);try{await C.Promises.rename(u,r)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));)c=this.getRandomEmptyWindowId();const r=this.getBackupPath(c);try{t.renameSync(u,r)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,I.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,b.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await C.Promises.readdir(u);for(const r of c)try{if((await C.Promises.readdir((0,D.join)(u,r))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let r;return c.scheme===R.Schemas.file?r=v.isLinux?c.fsPath:c.fsPath.toLowerCase():r=c.toString().toLowerCase(),(0,w.createHash)("md5").update(r).digest("hex")}};S=ve([Y(0,g.IEnvironmentMainService),Y(1,y.IConfigurationService),Y(2,E.ILogService)],S),e.BackupMainService=S}),define(J[56],Z([0,1,15,8,66,35,2,80,4,12,23,152,5,6,27]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let E=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,S){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},S)}pickFolder(p,S){return this.doPick({...p,pickFolders:!0,title:(0,I.localize)(1,null)},S)}pickFile(p,S){return this.doPick({...p,pickFiles:!0,title:(0,I.localize)(2,null)},S)}pickWorkspace(p,S){const f=(0,I.localize)(3,null),u=(0,R.mnemonicButtonLabel)((0,I.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:f,filters:c,buttonLabel:u},S)}async doPick(p,S){const f={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(f.properties=void 0,p.pickFiles&&p.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&f.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(S||w.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(p){if(p){let S=this.windowDialogQueues.get(p.id);return S||(S=new t.Queue,this.windowDialogQueues.set(p.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(p,S){return this.getWindowDialogQueue(S).queue(async()=>S?w.dialog.showMessageBox(S,p):w.dialog.showMessageBox(p))}async showSaveDialog(p,S){const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let u;return S?u=await w.dialog.showSaveDialog(S,p):u=await w.dialog.showSaveDialog(p),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,D.dispose)(f)}}normalizePath(p){return p&&h.isMacintosh&&(p=(0,v.normalizeNFC)(p)),p}normalizePaths(p){return p.map(S=>this.normalizePath(S))}async showOpenDialog(p,S){p.defaultPath&&(await C.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let u;return S?u=await w.dialog.showOpenDialog(S,p):u=await w.dialog.showOpenDialog(p),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(p,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let f=this.windowFileDialogLocks.get(S.id);f||(f=new Set,this.windowFileDialogLocks.set(S.id,f));const u=(0,k.hash)(p);if(!f.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),f.add(u),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),f?.delete(u),f?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};E=ve([Y(0,g.ILogService)],E),e.DialogMainService=E}),define(J[251],Z([0,1,3,2,67,27]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(h,m){super();this.logService=h,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new w.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,m){this._register(w.Event.debounce(h.onDidChangeStorage,(C,I)=>(C?C.push(I):C=[I],C),D.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&m.fire(this.serializeStorageChangeEvents(C,h))}))}serializeStorageChangeEvents(h,m){const C=new Map,I=new Set;return h.forEach(y=>{const g=m.get(y.key);typeof g=="string"?C.set(y.key,g):I.add(y.key)}),{changed:Array.from(C.entries()),deleted:Array.from(I.values())}}listen(h,m,C){switch(m){case"onDidChangeStorage":{const I=C.profile?(0,k.revive)(C.profile):void 0;if(!I)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(I.id);return y||(y=this._register(new w.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(I),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(I.id,y)),y.event}}throw new Error(`Event not found: ${m}`)}async call(h,m,C){const I=C.profile?(0,k.revive)(C.profile):void 0,y=(0,R.reviveIdentifier)(C.workspace),g=await this.withStorageInitialized(I,y);switch(m){case"getItems":return Array.from(g.items.entries());case"updateItems":{const d=C;if(d.insert)for(const[E,b]of d.insert)g.set(E,b);d.delete?.forEach(E=>g.delete(E));break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(h,m){let C;m?C=this.storageMainService.workspaceStorage(m):h?C=this.storageMainService.profileStorage(h):C=this.storageMainService.applicationStorage;try{await C.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":h?"profile":"application"} storage due to ${I}`)}return C}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[39],Z([0,1,66,3,2,16,12,7,172,36,14,5,6,27,32,55,8,28,25]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&v.URI.isUri(i.location)&&v.URI.isUri(i.globalStorageHome)&&v.URI.isUri(i.settingsResource)&&v.URI.isUri(i.keybindingsResource)&&v.URI.isUri(i.tasksResource)&&v.URI.isUri(i.snippetsHome)&&((0,D.isUndefined)(i.extensionsResource)||v.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function u(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,location:v.URI.revive(s.location).with({scheme:i}),globalStorageHome:v.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:v.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:v.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:v.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:v.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:v.URI.revive(s.extensionsResource)?.with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(s,i,n,o){return{id:(0,w.hash)(i.path).toString(16),name:s,location:i,isDefault:!1,globalStorageHome:(0,R.joinPath)(i,"globalStorage"),settingsResource:(0,R.joinPath)(i,"settings.json"),keybindingsResource:(0,R.joinPath)(i,"keybindings.json"),tasksResource:(0,R.joinPath)(i,"tasks.json"),snippetsHome:(0,R.joinPath)(i,"snippets"),extensionsResource:(0,R.joinPath)(i,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:n,isTransient:o}}e.toUserDataProfile=c;let r=class extends k.Disposable{constructor(i,n,o,a){super();this.environmentService=i,this.fileService=n,this.uriIdentityService=o,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(l=>c(l.name,l.location,l.useDefaultFlags)):[];let n;const o=new d.ResourceMap,a=c((0,h.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),i.length){const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[P,M]of Object.entries(l.workspaces)){const T=v.URI.parse(P),W=v.URI.parse(M),U=i.find(x=>this.uriIdentityService.extUri.isEqual(x.location,W));U&&o.set(T,U)}if(l.emptyWindow){const P=v.URI.parse(l.emptyWindow);n=i.find(M=>this.uriIdentityService.extUri.isEqual(M.location,P))}}this._profilesObject={profiles:i,workspaces:o,emptyWindow:n}}return this._profilesObject}async createTransientProfile(i){const n="Temp",o=new RegExp(`${(0,S.escapeRegExpCharacters)(n)}\\s(\\d+)`);let a=0;for(const P of this.profiles){const M=o.exec(P.name),T=M?parseInt(M[1]):0;a=T>a?T:a}const l=`${n} ${a+1}`;return this.createProfile(l,void 0,i,!0)}async createProfile(i,n,o,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=await this.doCreateProfile(i,n,a);return o&&await this.setProfileForWorkspace(o,l),l}async doCreateProfile(i,n,o){let a=this.profileCreationPromises.get(i);return a||(a=(async()=>{try{const l=this.profiles.find(T=>T.name===i);if(l)return l;const P=c(i,(0,R.joinPath)(this.profilesHome,(0,w.hash)((0,p.generateUuid)()).toString(16)),n,o);await this.fileService.createFolder(P.location);const M=[];return this._onWillCreateProfile.fire({profile:P,join(T){M.push(T)}}),await b.Promises.settled(M),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(i)}})(),this.profileCreationPromises.set(i,a)),a}async updateProfile(i,n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(l=>l.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=c(n,a.location,o),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(a=>a.id===i.id);if(!n)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:n,join(a){o.push(a)}}),await b.Promises.settled(o),n.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])n.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[n],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(n.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(i,n=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(i);return o||(o=n,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,o)),o}async setProfileForWorkspace(i,n){this.setProfileForWorkspaceSync(i,n)}setProfileForWorkspaceSync(i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(i,o)}unsetWorkspace(i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,n)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(n=>n.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,n.resource))).map(n=>this.fileService.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(n=>!this.isProfileAssociatedToWorkspace(n));await Promise.allSettled(i.map(n=>this.removeProfile(n)))}getProfileForWorkspace(i){const n=this.getWorkspace(i);return v.URI.isUri(n)?this.transientProfilesObject.workspaces.get(n)??this.profilesObject.workspaces.get(n):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,g.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,g.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,i.location)))}updateProfiles(i,n,o){const a=[...this.profiles,...i],l=[];this.transientProfilesObject.profiles=[];for(let P of a)P.isDefault||n.some(M=>P.id===M.id)||(P=o.find(M=>P.id===M.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):l.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(l),this._profilesObject=void 0,this.triggerProfilesChanges(i,n,o)}triggerProfilesChanges(i,n,o){this._onDidChangeProfiles.fire({added:i,removed:n,updated:o,all:this.profiles})}updateWorkspaceAssociation(i,n,o){o=n?.isTransient?!0:o,o||this.updateWorkspaceAssociation(i,void 0,!0);const a=this.getWorkspace(i),l=o?this.transientProfilesObject:this.profilesObject;v.URI.isUri(a)?(l.workspaces.delete(a),n&&l.workspaces.set(a,n)):l.emptyWindow=n,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[o,a]of this.profilesObject.workspaces.entries())i[o.toString()]=a.location.toString();const n=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:n}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};r.PROFILES_KEY="userDataProfiles",r.PROFILE_ASSOCIATIONS_KEY="profileAssociations",r=ve([Y(0,m.IEnvironmentService),Y(1,C.IFileService),Y(2,E.IUriIdentityService),Y(3,y.ILogService)],r),e.UserDataProfilesService=r}),define(J[89],Z([0,1,24,8,50,17,18,43,138,2,13,9,4,16,188,94,12,7,157,36,110,109,187,14,5,6,20,3,67,72,39,55,186]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P,M,T,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(K){function $(_,A){if(_===A)return!0;const F=Object.keys(_),z=new Set;for(const ee of Object.keys(A))z.add(ee);if(F.length!==z.size)return!1;for(const ee of F){if(_[ee]!==A[ee])return!1;z.delete(ee)}return z.size===0}K.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let x=class extends m.Disposable{constructor($,_,A,F,z,ee,B,H,L,O,N){super();this.systemExtensionsLocation=$,this.userExtensionsLocation=_,this.extensionsControlLocation=A,this.cacheLocation=F,this.userDataProfilesService=z,this.extensionsProfileScannerService=ee,this.fileService=B,this.logService=H,this.environmentService=L,this.productService=O,this.instantiationService=N,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,g.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(le,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,_,A){const[F,z]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(_)]),ee=A?await this.scanExtensionsUnderDevelopment($,[...F,...z]):[];return this.dedupExtensions(F,z,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const _=[];_.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),_.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[A,F]=await Promise.all(_);return this.applyScanOptions([...A,...F],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const _=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let F=await($.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return F=await this.applyScanOptions(F,1,$,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment($,_){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===C.Schemas.file).map(async F=>{const z=await this.createExtensionScannerInput(F,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=_.find(H=>(0,u.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",$,!0)}return[]}async scanExistingExtension($,_,A){const F=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanExtension(F);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions($,_,A){const F=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(z,_,A,!0)}async scanMetadata($){const _=(0,g.joinPath)($,"package.json"),A=(await this.fileService.readFile(_)).value.toString();return JSON.parse(A).__metadata}async updateMetadata($,_){const A=(0,g.joinPath)($,"package.json"),F=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(F);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.installedTimestamp=_.installedTimestamp||void 0,z.__metadata={...z.__metadata,..._},await this.fileService.writeFile((0,g.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions($,_,A,F){return A.includeAllVersions||($=this.dedupExtensions(_===0?$:void 0,_===1?$:void 0,_==="development"?$:void 0,await this.getTargetPlatform(),F)),A.includeInvalid||($=$.filter(z=>z.isValid)),$.sort((z,ee)=>{const B=I.basename(z.location.fsPath),H=I.basename(ee.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions($,_,A,F,z){const ee=(H,L,O)=>{if(H.isValid&&!L.isValid)return!1;if(H.isValid===L.isValid){if(z&&d.gt(H.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(d.eq(H.manifest.version,L.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===F)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${H.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${L.location.path}.`),!0},B=new Map;return $?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!1))&&B.set(L,H)}),_?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);if(!O&&$&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!O||ee(O,H,!1))&&B.set(L,H)}),A?.forEach(H=>{const L=c.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||ee(O,H,!0))&&B.set(L,H),B.set(L,H)}),[...B.values()]}async scanDefaultSystemExtensions($,_){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,_),z=await($&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions($,_){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=_?await this.getBuiltInExtensionControl():{},z=[],ee=p.URI.file(I.normalize(I.join(C.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const H of A){const L=F[H.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,g.joinPath)(ee,H.name));break;default:z.push(p.URI.file(L));break}}const B=await Promise.all(z.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,w.coalesce)(B)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,_,A,F,z,ee=!0){const B=await this.getTranslations(z??y.language),H=await this.getMtime($),L=_?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new re($,H,L,O,_,A,F,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime($){try{const _=await this.fileService.stat($);if(typeof _.mtime=="number")return _.mtime}catch{}}};x=ve([Y(4,M.IUserDataProfilesService),Y(5,P.IExtensionsProfileScannerService),Y(6,s.IFileService),Y(7,n.ILogService),Y(8,f.IEnvironmentService),Y(9,o.IProductService),Y(10,i.IInstantiationService)],x),e.AbstractExtensionsScannerService=x;class re{constructor($,_,A,F,z,ee,B,H,L,O,N,V,Q,ne){this.location=$,this.mtime=_,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=F,this.profile=z,this.type=ee,this.excludeObsolete=B,this.validate=H,this.productVersion=L,this.productDate=O,this.productCommit=N,this.devMode=V,this.language=Q,this.translations=ne}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,_){return(0,g.isEqual)($.location,_.location)&&$.mtime===_.mtime&&(0,g.isEqual)($.applicationExtensionslocation,_.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&$.profile===_.profile&&$.type===_.type&&$.excludeObsolete===_.excludeObsolete&&$.validate===_.validate&&$.productVersion===_.productVersion&&$.productDate===_.productDate&&$.productCommit===_.productCommit&&$.devMode===_.devMode&&$.language===_.language&&U.equals($.translations,_.translations)}}let le=class extends m.Disposable{constructor($,_,A,F,z){super();this.obsoleteFile=$,this.extensionsProfileScannerService=_,this.uriIdentityService=A,this.fileService=F,this.logService=z}async scanExtensions($){const _=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let A={};if($.excludeObsolete&&$.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(F)}catch{}return(0,b.isEmptyObject)(A)?_:_.filter(F=>!A[u.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation($){const _=await this.fileService.resolve($.location);if(!_.children?.length)return[];const A=await Promise.all(_.children.map(async F=>{if(!F.isDirectory||$.type===1&&(0,g.basename)(F.resource).indexOf(".")===0)return null;const z=new re(F.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(z)}));return(0,w.coalesce)(A).sort((F,z)=>F.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile($){let _=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){_=_.filter(F=>!F.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,$);_.push(...A)}return _}async scanExtensionsFromProfileResource($,_,A){const F=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!F.length)return[];const z=await Promise.all(F.map(async ee=>{if(_(ee)){const B=new re(ee.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,ee.metadata)}return null}));return(0,w.coalesce)(z)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,g.joinPath)($.location,"package.json"))){const _=await this.scanExtension($);return _?[_]:[]}else return await this.scanExtensions($)}catch(_){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,D.getErrorMessage)(_)),[]}}async scanExtension($,_){try{let A=await this.scanExtensionManifest($.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),_=_??A.__metadata,delete A.__metadata;const F=(0,u.getGalleryExtensionId)(A.publisher,A.name),z=_?.id?{id:F,uuid:_.id}:{id:F},ee=_?.isSystem?0:$.type,B=ee===0||!!_?.isBuiltin;A=await this.translateManifest($.location,A,re.createNlsConfiguration($));const H={type:ee,identifier:z,manifest:A,location:$.location,isBuiltin:B,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return $.validate?this.validate(H,$):H}}catch(A){$.type!==0&&this.logService.error(A)}return null}validate($,_){let A=!0;const F=(0,r.validateExtensionManifest)(_.productVersion,_.productDate,_.location,$.manifest,$.isBuiltin);for(const[z,ee]of F)z===E.default.Error&&(A=!1,this.logService.error(this.formatMessage(_.location,ee)));return $.isValid=A,$.validations=F,$}async scanExtensionManifest($){const _=(0,g.joinPath)($,"package.json");let A;try{A=(await this.fileService.readFile(_)).value.toString()}catch(z){return(0,s.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage($,(0,S.localize)(0,null,_.path,z.message))),null}let F;try{F=JSON.parse(A)}catch{const ee=[];(0,v.parse)(A,ee);for(const B of ee)this.logService.error(this.formatMessage($,(0,S.localize)(1,null,_.path,B.offset,B.length,(0,h.getParseErrorMessage)(B.error))));return null}return(0,v.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage($,(0,S.localize)(2,null,_.path))),null):F}async translateManifest($,_,A){const F=await this.getLocalizedMessages($,_,A);if(F)try{const z=[],ee=await this.resolveOriginalMessageBundle(F.default,z);if(z.length>0)return z.forEach(H=>{this.logService.error(this.formatMessage($,(0,S.localize)(3,null,F.default?.path,(0,h.getParseErrorMessage)(H.error))))}),_;if((0,v.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage($,(0,S.localize)(4,null,F.default?.path))),_;const B=F.values||Object.create(null);return(0,W.localizeManifest)(_,B,ee)}catch{}return _}async getLocalizedMessages($,_,A){const F=(0,g.joinPath)($,"package.nls.json"),z=(L,O)=>{O.forEach(N=>{this.logService.error(this.formatMessage($,(0,S.localize)(5,null,L?.path,(0,h.getParseErrorMessage)(N.error))))})},ee=L=>{this.logService.error(this.formatMessage($,(0,S.localize)(6,null,L?.path)))},B=`${_.publisher}.${_.name}`,H=A.translations[B];if(H)try{const L=p.URI.file(H),O=(await this.fileService.readFile(L)).value.toString(),N=[],V=(0,v.parse)(O,N);return N.length>0?(z(L,N),{values:void 0,default:F}):(0,v.getNodeType)(V)!=="object"?(ee(L),{values:void 0,default:F}):{values:V.contents?V.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let O;try{O=await this.findMessageBundles($,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const N=(await this.fileService.readFile(O.localized)).value.toString(),V=[],Q=(0,v.parse)(N,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,v.getNodeType)(Q)!=="object"?(ee(O.localized),{values:void 0,default:O.original}):{values:Q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle($,_){if($)try{const A=(await this.fileService.readFile($)).value.toString();return(0,v.parse)(A,_)}catch{}}findMessageBundles($,_){return new Promise((A,F)=>{const z=ee=>{const B=(0,g.joinPath)($,`package.nls.${ee}.json`);this.fileService.exists(B).then(H=>{H&&A({localized:B,original:(0,g.joinPath)($,"package.nls.json")});const L=ee.lastIndexOf("-");L===-1?A({localized:(0,g.joinPath)($,"package.nls.json"),original:null}):(ee=ee.substring(0,L),z(ee))})};if(_.devMode||_.pseudo||!_.language)return A({localized:(0,g.joinPath)($,"package.nls.json"),original:null});z(_.language)})}formatMessage($,_){return`[${$.path}]: ${_}`}};le=ve([Y(1,P.IExtensionsProfileScannerService),Y(2,T.IUriIdentityService),Y(3,s.IFileService),Y(4,n.ILogService)],le);let ue=class extends le{constructor($,_,A,F,z,ee){super(_,A,F,z,ee);this.cacheFile=$,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const _=await this.readExtensionCache();if(this.input=$,_&&_.input&&re.equals(_.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(F=>(F.location=p.URI.revive(F.location),F));const A=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:A}),A}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),_=JSON.parse($.value.toString());return{result:_.result,input:(0,l.revive)(_.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify($)))}catch(_){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const _=$.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,_))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};ue=ve([Y(2,P.IExtensionsProfileScannerService),Y(3,T.IUriIdentityService),Y(4,s.IFileService),Y(5,n.ILogService)],ue);function se(K,$){const _=(0,u.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:_,identifier:new c.ExtensionIdentifier(_),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:$,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class de extends x{constructor($,_,A,F,z,ee,B,H,L,O,N){super($,_,(0,g.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(F,c.MANIFEST_CACHE_FOLDER),z,ee,B,H,L,O,N);this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const V=await this.fileService.readFile(p.URI.file(y.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(J[252],Z([0,1,7,36,72,89,14,5,6,20,39]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends R.NativeExtensionsScannerService{constructor(g,d,E,b,p,S,f){super(w.URI.file(p.builtinExtensionsPath),w.URI.file(p.extensionsPath),p.userHome,w.URI.file(p.userDataPath),g,d,E,b,p,S,f)}};I=ve([Y(0,C.IUserDataProfilesService),Y(1,k.IExtensionsProfileScannerService),Y(2,D.IFileService),Y(3,h.ILogService),Y(4,t.INativeEnvironmentService),Y(5,m.IProductService),Y(6,v.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(J[253],Z([0,1,15,40,2,32,13,9,4,7,28,36,6,39]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(b,p,S){super();this.logService=S,this.validRoots=R.TernarySearchTree.forPaths(!h.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=w.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,S)=>this.handleResourceRequest(p,S)),b.protocol.interceptFileProtocol(D.Schemas.file,(p,S)=>this.handleFileRequest(p,S)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const p=(0,v.normalize)(b);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const S=m.URI.parse(b.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const S=this.requestToNormalizedFilePath(b);return this.validRoots.findSubstr(S)?p({path:S}):this.validExtensions.has((0,v.extname)(S).toLowerCase())?p({path:S}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=m.URI.parse(b.url),S=D.FileAccess.asFileUri(p);return(0,v.normalize)(S.fsPath)}createIPCObjectUrl(){let b;const p=m.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),S=p.toString(),f=async()=>b;return t.validatedIpcMain.handle(S,f),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:p,update:u=>b=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};d=ve([Y(0,I.INativeEnvironmentService),Y(1,g.IUserDataProfilesService),Y(2,y.ILogService)],d),e.ProtocolMainService=d}),define(J[254],Z([0,1,15,40,8,3,2,13,12,99,26,21,6,53,61,64,44,39,38]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(c,r,s,i,n,o,a,l,P){super();this.machineId=c,this.userEnv=r,this.environmentMainService=s,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=o,this.policyService=a,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,r)=>this.onWindowConnection(c,r)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,r)=>this.onWorkerConnection(c,r)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,r){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const s=await this.connect();if(c.sender.isDestroyed())return s.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",r,[s])}onWorkerConnection(c,r){this.logService.trace("SharedProcess: onWorkerConnection",r);const s=new D.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,r),s.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",r))},n=w.BrowserWindow.fromId(r.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!r.reply.channel){i("unavailable");return}s.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===n)(()=>i("load"))),s.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(r.reply.channel,r.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...r){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...r)}catch(s){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(s)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default,policiesData:this.policyService.serialize()}),this.window.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,r)=>this._onDidError.fire({type:2,details:r})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,r,s)=>this._onDidError.fire({type:3,details:{reason:s,exitCode:r}})))}async connect(){await this.whenIpcReady;const c=(0,h.assertIsDefined)(this.window);return(0,m.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};f=ve([Y(2,C.IEnvironmentMainService),Y(3,p.IUserDataProfilesService),Y(4,I.ILifecycleMainService),Y(5,y.ILogService),Y(6,S.IPolicyService),Y(7,E.IThemeMainService),Y(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(J[116],Z([0,1,8,3,2,71,12,100,5,39]),function(q,e,w,t,k,R,D,v,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var g;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,u){if(u===C){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:u,target:this.getKeyTargets(f)[u]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,u,c){return this.getStorage(u)?.get(f,c)}getBoolean(f,u,c){return this.getStorage(u)?.getBoolean(f,c)}getNumber(f,u,c){return this.getStorage(u)?.getNumber(f,c)}store(f,u,c,r){if((0,D.isUndefinedOrNull)(u)){this.remove(f,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,c,r),this.getStorage(c)?.set(f,u)})}remove(f,u){this.withPausedEmitters(()=>{this.updateKeyTarget(f,u,void 0),this.getStorage(u)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,u){const c=[],r=this.getKeyTargets(f);for(const s of Object.keys(r))r[s]===u&&c.push(s);return c}updateKeyTarget(f,u,c){const r=this.getKeyTargets(u);typeof c=="number"?r[f]!==c&&(r[f]=c,this.getStorage(u)?.set(C,JSON.stringify(r))):typeof r[f]=="number"&&(delete r[f],this.getStorage(u)?.set(C,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const u=this.get(C,f);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f});const u=this.getStorage(-1),c=this.getStorage(0),r=this.getStorage(1);switch(f){case I.NONE:await w.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await w.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return p(f,u,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,u){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,u):this.switchToWorkspace(f,u)}canSwitchProfile(f,u){return!(f.id===u.id||E(u)&&E(f))}switchData(f,u,c,r){this.withPausedEmitters(()=>{if(r)for(const[s,i]of f)u.set(s,i);else{const s=new Set;for(const[i,n]of f)s.add(i),u.get(i)!==n&&this.emitDidChangeValue(c,i);for(const[i]of u.items)s.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class b extends d{constructor(){super();this.applicationStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.profileStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=b;async function p(S,f,u,c,r,s){const i=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,o=new Map;S.forEach((U,x)=>{n.set(x,U),o.set(x,i(U))});const a=new Map,l=new Map;f.forEach((U,x)=>{a.set(x,U),l.set(x,i(U))});const P=new Map,M=new Map;u.forEach((U,x)=>{P.set(x,U),M.set(x,i(U))}),console.group(c!==r?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(n.forEach((U,x)=>{T.push({key:x,value:U})}),console.table(T),console.groupEnd(),console.log(o),c!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const U=[];a.forEach((x,re)=>{U.push({key:re,value:x})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${s})`);const W=[];P.forEach((U,x)=>{W.push({key:x,value:U})}),console.table(W),console.groupEnd(),console.log(M)}e.logStorage=p}),define(J[255],Z([0,1,24,8,3,2,9,79,7,23,100,149,6,116,37,27]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{constructor(s,i){super();this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const s=await this.doCreate();this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(s);const i=s.getBoolean(g.IS_NEW_KEY);i===void 0?s.set(g.IS_NEW_KEY,!0):i&&s.set(g.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}async close(){const s=new v.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(!!this.path)try{const i=(0,w.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{constructor(s,i,n,o){super(n,o);this.profile=s,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new C.Storage(new I.SQLiteStorageDatabase(this.path??I.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class S extends p{constructor(s,i,n,o){super(s,i,n,o)}}e.ProfileStorageMain=S;class f extends p{constructor(s,i,n,o){super(i.defaultProfile,s,n,o)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(d.firstSessionDateStorageKey,void 0)===void 0&&s.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();s.set(d.lastSessionDateStorageKey,typeof n=="undefined"?null:n),s.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=f;class u extends b{constructor(s,i,n,o,a){super(n,a);this.workspace=s,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new I.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:i?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(s,u.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(s,u.WORKSPACE_META_NAME);await m.Promises.exists(n)||await m.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u,u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json";class c extends b{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(J[256],Z([0,1,67,36,14,6,225,55,39]),function(q,e,w,t,k,R,D,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class kt extends h.UserDataProfilesService{constructor(I,y,g,d,E){super(g,d,y,E);this.stateService=I}getStoredProfiles(){return(0,w.revive)(this.stateService.getItem(kt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,w.revive)(this.stateService.getItem(kt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([Y(0,D.IStateService),Y(1,v.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(J[42],Z([0,1,7,36,14,5,6,41,55,39,256]),function(q,e,w,t,k,R,D,v,h,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let I=class lt extends C.UserDataProfilesService{constructor(g,d,E,b,p){super(g,d,E,b,p);this.stateMainService=g}setEnablement(g){super.setEnablement(g),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(g){if(!!this.isEnabled()&&!(!g._.length&&!g["folder-uri"]&&!g["file-uri"])){if(g.profile)return this.profiles.some(d=>d.name===g.profile)?void 0:this.createProfile(g.profile).then(()=>g);if(g["profile-temp"])return this.createTransientProfile().then(d=>(g.profile=d.name,g))}}saveStoredProfiles(g){g.length?this.stateMainService.setItem(lt.PROFILES_KEY,g):this.stateMainService.removeItem(lt.PROFILES_KEY)}saveStoredProfileAssociations(g){g.emptyWindow||g.workspaces?this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,g):this.stateMainService.removeItem(lt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateMainService.getItem(g,void 0);if(d){this.stateMainService.removeItem(g);const E=d.reduce((b,{workspace:p,profile:S})=>(b[w.URI.revive(p).toString()]=w.URI.revive(S).toString(),b),{});this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,{workspaces:E})}return super.getStoredProfileAssociations()}};I=ve([Y(0,v.IStateMainService),Y(1,h.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,D.ILogService)],I),e.UserDataProfilesMainService=I}),define(J[257],Z([0,1,2,16,72,89,14,6,39,42]),function(q,e,w,t,k,R,D,v,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let C=class extends w.Disposable{constructor(y,g,d,E,b){super();this.userDataProfilesService=y,this.fileService=g,this.extensionsScannerService=d,this.extensionsProfileScannerService=E,y.isEnabled()?(this._register(y.onWillCreateProfile(p=>{y.profiles.length===1&&p.join(this.initialize())})),this._register(y.onDidChangeProfiles(p=>{y.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>b.error(p))}async initialize(){const y=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(y)}catch{}const g=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(g.map(d=>[d,d.metadata]),y)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,h.EXTENSIONS_RESOURCE_NAME)}};C=ve([Y(0,m.IUserDataProfilesMainService),Y(1,D.IFileService),Y(2,R.IExtensionsScannerService),Y(3,k.IExtensionsProfileScannerService),Y(4,v.ILogService)],C),e.DefaultExtensionsProfileInitHandler=C}),define(J[90],Z([0,1,49,2,36,14,5,21,6,116,255,39,42]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let g=class extends t.Disposable{constructor(b,p,S,f,u){super();this.logService=b,this.environmentService=p,this.userDataProfilesService=S,this.lifecycleMainService=f,this.fileService=u,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join(this.applicationStorage.close());for(const[,p]of this.mapProfileToStorage)b.join(p.close());for(const[,p]of this.mapWorkspaceToStorage)b.join(p.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const p=this.mapProfileToStorage.get(b.profile.id);p&&b.join(p.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,w.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,m.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let p=this.mapProfileToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),p=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id)})),p}createProfileStorage(b){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let p=this.mapWorkspaceToStorage.get(b.id);return p||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),p=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,p),(0,w.once)(p.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),p}createWorkspaceStorage(b){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};g=ve([Y(0,h.ILogService),Y(1,k.IEnvironmentService),Y(2,y.IUserDataProfilesMainService),Y(3,v.ILifecycleMainService),Y(4,R.IFileService)],g),e.StorageMainService=g,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends m.AbstractStorageService{constructor(b,p){super();this.userDataProfilesService=b,this.storageMainService=p,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ve([Y(0,I.IUserDataProfilesService),Y(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(J[258],Z([0,1,2,21,42]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends w.Disposable{constructor(v,h){super();this.userDataProfilesService=h,this._register(v.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.previousWorkspace??"empty-window")})),this._register(v.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(v){this.userDataProfilesService.getOrSetProfileForWorkspace(v).isTransient&&(this.userDataProfilesService.unsetWorkspace(v,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([Y(0,t.ILifecycleMainService),Y(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(J[117],Z([0,1,16,7,27]),function(q,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(h,m,C){for(const y of h){const g=y.openedWorkspace;if((0,k.isWorkspaceIdentifier)(g)){const d=C(g);if(d){if(d.folders.some(E=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.uri)))return y}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.configPath))return y}}const I=h.filter(y=>(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.openedWorkspace.uri));if(I.length)return I.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(h,m){for(const C of h)if((0,k.isWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,m))return C}e.findWindowOnWorkspaceOrFolder=D;function v(h,m){const C=I=>m.some(y=>w.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(I)));for(const I of h)if(I.config?.extensionDevelopmentPath?.some(y=>C(y)))return I}e.findWindowOnExtensionDevelopmentPath=v}),define(J[259],Z([0,1,15,2,4,16,7,19,21,6,41,33,115,27]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Mt extends t.Disposable{constructor(u,c,r,s,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=r,this.logService=s,this.configurationService=i,this._state=E(this.stateMainService.getItem(Mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&u.add(c.lastActiveWindow.uiState.display))}const r=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(r),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!r.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?k.isMacintosh&&n.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const s=p(c);this.stateMainService.setItem(Mt.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(r=>{const s=(0,g.isWorkspaceIdentifier)(u.openedWorkspace)&&r.workspace?.id===u.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&r.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(r.folderUri,u.openedWorkspace.uri);(s||i)&&(r.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{windowId:u.id,workspace:(0,g.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),r=this.configurationService.getValue("window");if(c.mode===3){let s;c.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||r?.restoreFullscreen),s||(c.mode=1)}return c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,g.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(u.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let r;const s=w.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(k.isMacintosh){const a=w.screen.getCursorScreenPoint();r=w.screen.getDisplayNearestPoint(a)}!r&&c&&(r=w.screen.getDisplayMatching(c.getBounds())),r||(r=w.screen.getPrimaryDisplay()||s[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(r=>r.getBounds());for(;c.some(r=>r.x===u.x||r.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=ve([Y(0,I.IWindowsMainService),Y(1,C.IStateMainService),Y(2,h.ILifecycleMainService),Y(3,m.ILogService),Y(4,v.IConfigurationService)],d),e.WindowsStateHandler=d;function E(f){const u={openedWindows:[]},c=f||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(r=>b(r))),u}e.restoreWindowsState=E;function b(f){const u={uiState:f.uiState};return f.backupPath&&(u.backupPath=f.backupPath),f.remoteAuthority&&(u.remoteAuthority=f.remoteAuthority),f.folder&&(u.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(u.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),u}function p(f){return{lastActiveWindow:f.lastActiveWindow&&S(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&S(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(u=>S(u))}}e.getWindowsStateStoreData=p;function S(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(J[91],Z([0,1,31,43,125,35,13,9,4,16,7,5,63,27]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(M){return S(M)||f(M)}e.isStoredWorkspaceFolder=p;function S(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function u(M,T,W,U,x){if(M.scheme!==U.scheme)return{name:W,uri:M.toString(!0)};let re=T?void 0:x.relativePath(U,M);if(re!==void 0)re.length===0?re=".":h.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,h.isWindows&&(re=c(re));else if(x.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:W,uri:M.toString(!0)};return{name:W,path:re}}e.getStoredWorkspaceFolder=u;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,w.isUNC)(M)||(M=(0,w.toSlashes)(M)),M}function r(M,T,W){const U=[],x=new Set,re=W.dirname(T);for(const le of M){let ue;if(S(le))le.path&&(ue=W.resolvePath(re,le.path));else if(f(le))try{ue=C.URI.parse(le.uri),ue.path[0]!==v.posix.sep&&(ue=ue.with({path:v.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=W.getComparisonKey(ue);if(!x.has(se)){x.add(se);const de=le.name||W.basenameOrAuthority(ue);U.push(new g.WorkspaceFolder({uri:ue,name:de,index:U.length},le))}}}return U}e.toWorkspaceFolders=r;function s(M,T,W,U,x){const re=i(T,M),le=x.dirname(T),ue=x.dirname(U),se=[];for(const _ of re.folders){const A=S(_)?x.resolvePath(le,_.path):C.URI.parse(_.uri);let F;W?F=!1:F=!S(_)||(0,v.isAbsolute)(_.path),se.push(u(A,F,_.name,ue,x))}const de={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,de);let $=k.applyEdits(M,K);return(0,m.isEqualAuthority)(re.remoteAuthority,(0,y.getRemoteAuthority)(U))&&($=k.applyEdits($,k.removeProperty($,["remoteAuthority"],de))),$}e.rewriteWorkspaceFileForNewLocation=s;function i(M,T){const W=t.parse(T);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(U=>p(U));else throw new Error(`${M} looks like an invalid workspace file.`);return W}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function l(M,T){const W={workspaces:[],files:[]};if(M){const U=function(re,le){for(let ue=0;ue<re.length;ue++)try{le(re[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[ue])}: ${se.toString()}. Skip entry.`)}},x=M;Array.isArray(x.entries)&&U(x.entries,re=>{const le=re.label,ue=re.remoteAuthority;n(re)?W.workspaces.push({label:le,remoteAuthority:ue,workspace:{id:re.workspace.id,configPath:C.URI.parse(re.workspace.configPath)}}):o(re)?W.workspaces.push({label:le,remoteAuthority:ue,folderUri:C.URI.parse(re.folderUri)}):a(re)&&W.files.push({label:le,remoteAuthority:ue,fileUri:C.URI.parse(re.fileUri)})})}return W}e.restoreRecentlyOpened=l;function P(M){const T={entries:[]};for(const W of M.workspaces)E(W)?T.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):T.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of M.files)T.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return T}e.toStoreData=P}),define(J[118],Z([0,1,76,29,13,4,16]),function(q,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function v(m){function C(){let I=m.scheme===k.Schemas.file?(0,D.originalFSPath)(m):m.toString();return R.isLinux||(I=I.toLowerCase()),(0,w.createHash)("md5").update(I).digest("hex")}return{id:C(),configPath:m}}e.getWorkspaceIdentifier=v;function h(m,C){function I(){if(m.scheme!==k.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!C)try{C=(0,t.statSync)(m.fsPath)}catch{return}let g;return R.isLinux?g=C.ino:R.isMacintosh?g=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?g=Math.floor(C.birthtimeMs):g=C.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(g?String(g):"").digest("hex")}const y=I();if(typeof y=="string")return{id:y,uri:m}}e.getSingleFolderWorkspaceIdentifier=h}),define(J[48],Z([0,1,15,29,3,43,35,2,13,9,16,12,23,177,60,56,26,5,6,20,42,117,27,91,118]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let n=class extends v.Disposable{constructor(a,l,P,M,T,W){super();this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=T,this.productService=W,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>y.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const P=l(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,r.isUntitledWorkspace)(a,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const P=this.doParseStoredWorkspace(a,l),M=(0,i.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,s.toWorkspaceFolders)(P.folders,M.configPath,C.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,l){const P=(0,R.parse)(l);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,s.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return await y.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await y.Promises.writeFile(T,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,y.writeFileSync)(T,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],l){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,C.joinPath)(this.untitledWorkspacesHome,P),T=(0,C.joinPath)(M,r.UNTITLED_WORKSPACE_NAME),W=[];for(const U of a)W.push((0,s.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,C.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:W,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,r.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,C.originalFSPath)(a.configPath);try{(0,y.rimrafSync)((0,m.dirname)(l));const P=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,y.writeFileSync)((0,m.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${l} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,C.joinPath)(this.untitledWorkspacesHome,P,r.UNTITLED_WORKSPACE_NAME));for(const P of l){const M=(0,i.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,P))return;const T=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,l,P){if(!P)return!0;if((0,r.isWorkspaceIdentifier)(a.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(0,null))],message:(0,g.localize)(1,null,(0,C.basename)(P)),detail:(0,g.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,r.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=P,{workspace:l,backupPath:P}}};n=ve([Y(0,b.IEnvironmentMainService),Y(1,S.ILogService),Y(2,u.IUserDataProfilesMainService),Y(3,d.IBackupMainService),Y(4,E.IDialogMainService),Y(5,f.IProductService)],n),e.WorkspacesManagementMainService=n}),define(J[119],Z([0,1,40,22,5,33,27,48]),function(q,e,w,t,k,R,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let h=class{constructor(C,I){this.windowsMainService=C,this.workspacesManagementMainService=I}async getRemoteDiagnostics(C){const I=this.windowsMainService.getWindows();return(await Promise.all(I.map(g=>new Promise(d=>{const E=g.remoteAuthority;if(E){const b=`vscode:getDiagnosticInfoResponse${g.id}`,p={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(g):void 0};g.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:b,args:p}),w.validatedIpcMain.once(b,(S,f)=>{f||d({hostName:E,errorMessage:`Unable to resolve connection to '${E}'.`}),d(f)}),setTimeout(()=>{d({hostName:E,errorMessage:`Connection to '${E}' could not be established`})},5e3)}else d(void 0)})))).filter(g=>!!g)}getFolderURIs(C){const I=[],y=C.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(y))I.push(y.uri);else if((0,D.isWorkspaceIdentifier)(y)){const g=this.workspacesManagementMainService.resolveLocalWorkspaceSync(y.configPath);g&&g.folders.forEach(E=>{I.push(E.uri)})}return I}};h=ve([Y(0,R.IWindowsMainService),Y(1,v.IWorkspacesManagementMainService)],h),e.DiagnosticsMainService=h}),define(J[120],Z([0,1,15,24,4,12,7,23,19,59,5,6,114,33,27,48,42]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let p=class{constructor(f,u,c,r,s,i){this.logService=f,this.windowsMainService=u,this.urlService=c,this.workspacesManagementMainService=r,this.configurationService=s,this.userDataProfilesMainService=i}async start(f,u){this.logService.trace("Received data from other instance: ",f,u),k.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(f);if(c.length){let r=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(r=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),r.then(()=>{for(const{uri:s,url:i}of c)this.urlService.open(s,{originalUrl:i})})}else return this.startOpenWindow(f,u)}parseOpenUrl(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,t.coalesce)(f._urls.map(u=>{try{return{uri:D.URI.parse(u),url:u}}catch{return null}})):[]}async startOpenWindow(f,u){const c=(0,m.isLaunchedFromCli)(u)?0:4;let r=[];const s=f.wait&&f.waitMarkerFilePath?D.URI.file(f.waitMarkerFilePath):void 0,i=f.remote||void 0,n=this.userDataProfilesMainService.checkAndCreateProfileFromCli(f);n&&await n;const o={context:c,cli:f,userEnv:u,waitMarkerFileURI:s,remoteAuthority:i};if(f.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,o);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let a=!1;if(f["new-window"]||f["unity-launch"])a=!0;else if(f["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!k.isMacintosh}if(a)r=this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,o),r=[l]):r=this.windowsMainService.open({...o,forceEmpty:!0})}}else r=this.windowsMainService.open({...o,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(s&&r.length===1&&r[0])return Promise.race([r[0].whenClosedOrLoaded,(0,v.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const f=[];return w.BrowserWindow.getAllWindows().forEach(u=>{const c=this.windowsMainService.getWindowById(u.id);c?f.push(this.codeWindowToInfo(c)):f.push(this.browserWindowToInfo(u))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(f){const u=[],c=f.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(c))u.push(c.uri);else if((0,d.isWorkspaceIdentifier)(c)){const r=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);r&&r.folders.forEach(i=>{u.push(i.uri)})}return u}codeWindowToInfo(f){const u=this.getFolderURIs(f),c=(0,R.assertIsDefined)(f.win);return this.browserWindowToInfo(c,u,f.remoteAuthority)}browserWindowToInfo(f,u=[],c){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:u,remoteAuthority:c}}};p=ve([Y(0,I.ILogService),Y(1,g.IWindowsMainService),Y(2,y.IURLService),Y(3,E.IWorkspacesManagementMainService),Y(4,h.IConfigurationService),Y(5,b.IUserDataProfilesMainService)],p),e.LaunchMainService=p}),define(J[65],Z([0,1,51,15,30,143,52,3,35,2,13,9,4,7,96,81,23,92,167,56,26,5,21,6,20,64,33,27,48,17]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends m.Disposable{constructor(W,U,x,re,le,ue,se,de,K){super();this.sharedProcess=W,this.windowsMainService=U,this.dialogMainService=x,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=ue,this.productService=se,this.themeMainService=de,this.workspacesManagementMainService=K,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidTriggerSystemContextMenu=v.Event.filter(v.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:$,x:_,y:A})=>({windowId:$.id,x:_,y:A})),({windowId:$})=>!!this.windowsMainService.getWindowById($)),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-blur",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),v.Event.filter(v.Event.fromNodeEventEmitter(t.app,"browser-window-focus",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",($,_,A)=>A),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),v.Event.fromNodeEventEmitter(t.screen,"display-added"),v.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(W){return this.windowsMainService.getWindowCount()}async getActiveWindowId(W){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(W,U,x){return Array.isArray(U)?this.doOpenWindow(W,U,x):this.doOpenEmptyWindow(W,U)}async doOpenWindow(W,U,x=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:W,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0})}async doOpenEmptyWindow(W,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:W},U)}async toggleFullScreen(W){this.windowById(W)?.toggleFullScreen()}async handleTitleDoubleClick(W){this.windowById(W)?.handleTitleDoubleClick()}async isMaximized(W){const U=this.windowById(W);return U?.win?U.win.isMaximized():!1}async maximizeWindow(W){const U=this.windowById(W);U?.win&&U.win.maximize()}async unmaximizeWindow(W){const U=this.windowById(W);U?.win&&U.win.unmaximize()}async minimizeWindow(W){const U=this.windowById(W);U?.win&&U.win.minimize()}async updateWindowControls(W,U){const x=this.windowById(W);x&&x.updateWindowControls(U)}async focusWindow(W,U){U&&typeof U.windowId=="number"&&(W=U.windowId),this.windowById(W)?.focus({force:U?.force??!1})}async setMinimumSize(W,U,x){const re=this.windowById(W);if(re?.win){const[le,ue]=re.win.getSize(),[se,de]=re.win.getMinimumSize(),[K,$]=[U??se,x??de],[_,A]=[Math.max(le,K),Math.max(ue,$)];(se!==K||de!==$)&&re.win.setMinimumSize(K,$),(le!==_||ue!==A)&&re.win.setSize(_,A)}}async saveWindowSplash(W,U){this.themeMainService.saveWindowSplash(W,U)}async installShellCommand(W){const{source:U,target:x}=await this.getShellCommandLink();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,d.realpath)(U);if(x===le)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(x,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(ue)}catch{throw new Error((0,S.localize)(3,null,U))}}}async uninstallShellCommand(W){const{source:U}=await this.getShellCommandLink();try{await b.Promises.unlink(U)}catch(x){switch(x.code){case"EACCES":{const{response:re}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(le)}catch{throw new Error((0,S.localize)(7,null,U))}break}case"ENOENT":break;default:throw x}}}async getShellCommandLink(){const W=(0,I.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(W))throw new Error((0,S.localize)(8,null,W));return{source:U,target:W}}async showMessageBox(W,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(W))}async showSaveDialog(W,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(W))}async showOpenDialog(W,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(W))}toBrowserWindow(W){const U=this.windowById(W);if(U?.win)return U.win}async pickFileFolderAndOpen(W,U){const x=await this.dialogMainService.pickFileFolder(U);x&&this.doOpenPicked(await Promise.all(x.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),U,W)}async pickFolderAndOpen(W,U){const x=await this.dialogMainService.pickFolder(U);x&&this.doOpenPicked(x.map(re=>({folderUri:g.URI.file(re)})),U,W)}async pickFileAndOpen(W,U){const x=await this.dialogMainService.pickFile(U);x&&this.doOpenPicked(x.map(re=>({fileUri:g.URI.file(re)})),U,W)}async pickWorkspaceAndOpen(W,U){const x=await this.dialogMainService.pickWorkspace(U);x&&this.doOpenPicked(x.map(re=>({workspaceUri:g.URI.file(re)})),U,W)}doOpenPicked(W,U,x){this.windowsMainService.open({context:3,contextWindowId:x,cli:this.environmentMainService.args,urisToOpen:W,forceNewWindow:U.forceNewWindow})}async showItemInFolder(W,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(W,U){this.windowById(W)?.setRepresentedFilename(U)}async setDocumentEdited(W,U){this.windowById(W)?.setDocumentEdited(U)}async openExternal(W,U){return y.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(W){const U=process.env.GDK_PIXBUF_MODULE_FILE,x=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(W),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=x}moveItemToTrash(W,U){return t.shell.trashItem(U)}async isAdmin(){let W;return y.isWindows?W=(await new Promise((U,x)=>{q(["native-is-elevated"],U,x)}))():W=process.getuid()===0,W}async writeElevated(W,U,x,re){const le=await new Promise((ue,se)=>{q(["@vscode/sudo-prompt"],ue,se)});return new Promise((ue,se)=>{const de=[`"${this.cliPath}"`];re?.unlock&&de.push("--file-chmod"),de.push("--file-write",`"${U.fsPath}"`,`"${x.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(de.join(" "),K,($,_,A)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),$?se($):ue(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return E.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(W,U,x){process.kill(U,x)}async readClipboardText(W,U){return t.clipboard.readText(U)}async writeClipboardText(W,U,x){return t.clipboard.writeText(U,x)}async readClipboardFindText(W){return t.clipboard.readFindText()}async writeClipboardFindText(W,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(W,U,x,re){return t.clipboard.writeBuffer(U,Buffer.from(x.buffer),re)}async readClipboardBuffer(W,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(W,U,x){return t.clipboard.has(U,x)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,U){this.windowById(W)?.updateTouchBar(U)}async notifyReady(W){this.windowById(W)?.setReady()}async relaunch(W,U){return this.lifecycleMainService.relaunch(U)}async reload(W,U){const x=this.windowById(W);if(x){if((0,a.isWorkspaceIdentifier)(x.openedWorkspace)){const re=x.openedWorkspace.configPath;if(re.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(x,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(W){this.closeWindowById(W,W)}async closeWindowById(W,U){const x=this.windowById(U);if(x?.win)return x.win.close()}async quit(W){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(W,U){await this.lifecycleMainService.kill(U)}async resolveProxy(W,U){const re=this.windowById(W)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(W,U,x,re,le=1){return(0,p.findFreePort)(U,x,re,le)}async openDevTools(W,U){const x=this.windowById(W);x?.win&&x.win.webContents.openDevTools(U)}async toggleDevTools(W){const U=this.windowById(W);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(W,U){const x=this.windowById(W);x?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&x.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(W,U,x,re){if(!y.isWindows)return;const le=await new Promise((ue,se)=>{q(["@vscode/windows-registry"],ue,se)});try{return le.GetStringRegKey(U,x,re)}catch{return}}windowById(W){if(typeof W=="number")return this.windowsMainService.getWindowById(W)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([Y(1,o.IWindowsMainService),Y(2,f.IDialogMainService),Y(3,r.ILifecycleMainService),Y(4,u.IEnvironmentMainService),Y(5,s.ILogService),Y(6,i.IProductService),Y(7,n.IThemeMainService),Y(8,l.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(J[260],Z([0,1,15,40,30,35,2,13,4,97,165,84,119,56,26,5,120,6,65,53,20,61,74]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,E.createDecorator)("issueMainService");let s=class Tt{constructor(n,o,a,l,P,M,T,W,U,x){this.userEnv=n,this.environmentMainService=o,this.launchMainService=a,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=W,this.protocolMainService=U,this.productService=x,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(n,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,C.localize)(0,null),rootProcess:await(0,m.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,I.isRemoteDiagnosticError)(P)?o.push({name:P.hostName,rootProcess:P}):P.processes&&o.push({name:P.hostName,rootProcess:P.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:a,from:l,args:P}=o;let M;switch(l){case"issueReporter":M=this.issueReporterParentWindow;break;case"processExplorer":M=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}M?.webContents.send("vscode:runAction",{id:a,from:l,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...a){n.sender.isDestroyed()||n.sender.send(o,...a)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:f.default}),this.issueReporterWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:f.default}),this.processExplorerWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,a,l){const P=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:a.title,backgroundColor:a.backgroundColor||Tt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,a){let l;const P=w.screen.getAllDisplays();if(P.length===1)l=P[0];else{if(h.isMacintosh){const W=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(W)}!l&&n&&(l=w.screen.getDisplayMatching(n.getBounds())),l||(l=w.screen.getPrimaryDisplay()||P[0])}const M={width:o,height:a},T=l.bounds;return M.x=T.x+T.width/2-M.width/2,M.y=T.y+T.height/2-M.height/2,T.width>0&&T.height>0&&(M.x<T.x&&(M.x=T.x),M.y<T.y&&(M.y=T.y),M.x>T.x+T.width&&(M.x=T.x),M.y>T.y+T.height&&(M.y=T.y),M.width>T.width&&(M.width=T.width),M.height>T.height&&(M.height=T.height)),M}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};s.DEFAULT_BACKGROUND_COLOR="#1E1E1E",s=ve([Y(1,d.IEnvironmentMainService),Y(2,b.ILaunchMainService),Y(3,p.ILogService),Y(4,I.IDiagnosticsService),Y(5,y.IDiagnosticsMainService),Y(6,g.IDialogMainService),Y(7,S.INativeHostMainService),Y(8,c.IProtocolMainService),Y(9,u.IProductService)],s),e.IssueMainService=s}),define(J[261],Z([0,1,22,19,26,21,6,65,20,54,37,47,88]),function(q,e,w,t,k,R,D,v,h,m,C,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends y.AbstractUpdateService{constructor(E,b,p,S,f,u,c,r){super(E,b,S,f,u,r);this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(E){return(0,y.createUpdateURL)(`linux-${process.arch}`,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(I.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const p=E?b.message||b:void 0;this.setState(I.State.Idle(1,p))}))}async doDownloadUpdate(E){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(I.State.Idle(1))}};g=ve([Y(0,R.ILifecycleMainService),Y(1,t.IConfigurationService),Y(2,C.ITelemetryService),Y(3,k.IEnvironmentMainService),Y(4,m.IRequestService),Y(5,D.ILogService),Y(6,v.INativeHostMainService),Y(7,h.IProductService)],g),e.LinuxUpdateService=g}),define(J[262],Z([0,1,51,29,30,8,22,52,9,7,129,23,19,26,14,21,6,65,20,54,37,47,88]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends r.AbstractUpdateService{constructor(l,P,M,T,W,U,x,re,le){super(l,P,T,W,U,le);this.telemetryService=M,this.fileService=x,this.nativeHostMainService=re}get cachePath(){const l=h.join((0,k.tmpdir)(),`${this.productService.applicationName}-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,r.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(P=>{const M=n();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>I.Promises.exists(T).then(W=>{if(W)return Promise.resolve(T);const U=P.url,x=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(le=>this.fileService.writeFile(m.URI.file(re),le.stream)).then(x?()=>(0,C.checksum)(re,P.hash):()=>{}).then(()=>I.Promises.rename(re,T)).then(()=>T)})).then(T=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},W&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(c.State.Idle(n(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(l){const P=await this.cachePath;return h.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,M=await this.cachePath,W=(await I.Promises.readdir(M)).filter(P).map(async U=>{try{await I.Promises.unlink(h.join(M,U))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=h.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,W=await new Promise((U,x)=>{q(["windows-mutex"],U,x)});s(()=>W.isActive(T)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([v.memoize],o.prototype,"cachePath",null),o=ve([Y(0,E.ILifecycleMainService),Y(1,y.IConfigurationService),Y(2,u.ITelemetryService),Y(3,g.IEnvironmentMainService),Y(4,f.IRequestService),Y(5,b.ILogService),Y(6,d.IFileService),Y(7,p.INativeHostMainService),Y(8,S.IProductService)],o),e.Win32UpdateService=o}),define(J[263],Z([0,1,15,8,22,44,3,35,2,13,9,71,4,7,173,60,19,56,26,59,14,21,6,20,61,230,90,37,233,64,74,33,27,48,115,123,38,41,53,42]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P,M,T,W,U,x,re,le,ue,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(K||(K={}));let $=class Dt extends h.Disposable{constructor(A,F,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le){super();this.logService=F,this.environmentMainService=z,this.policyService=ee,this.userDataProfilesService=B,this.fileService=H,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=N,this.themeMainService=V,this.workspacesManagementMainService=Q,this.backupMainService=ne,this.telemetryService=j,this.dialogMainService=te,this.lifecycleMainService=ie,this.productService=ce,this.protocolMainService=fe,this.windowsMainService=ke,this.stateMainService=Le,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const Ve=this.windowState.mode===0||this.windowState.mode===3,ge=this.configurationService.getValue("window");let pe=!1;typeof ge?.experimental?.useSandbox=="boolean"?pe=ge.experimental.useSandbox:pe=typeof se.default.quality=="string"&&se.default.quality!=="stable";const be={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!Ve,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(ge?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...pe?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?be.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(be.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(be.fullscreenable=!1),y.isMacintosh&&(be.acceptFirstMouse=!0,ge?.clickThroughInactive===!1&&(be.acceptFirstMouse=!1));const X=y.isMacintosh&&ge?.nativeTabs===!0;X&&(be.tabbingIdentifier=this.productService.nameShort);const ae=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ae&&(be.titleBarStyle="hidden",y.isMacintosh||(be.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=re.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";be.titleBarOverlay={height:29,color:he,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(be),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,y.isMacintosh&&ae&&this._win.setSheetOffset(22),ae&&(y.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||y.isMacintosh)){const he=this.stateMainService.getItem(Dt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}if(y.isWindows&&ae){const he=278;this._win.hookWindowMessage(he,()=>{const[ye,Ce]=this._win.getPosition(),Te=w.screen.getCursorScreenPoint(),Oe=Te.x-ye,Be=Te.y-Ce;return(()=>!(Oe>30&&Be>=0&&Be<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:Be})),0})}(y.isMacintosh||y.isWindows)&&Ae&&(!X||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Ve&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get previousWorkspace(){return this._previousWorkspace}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){y.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){y.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){y.isMacintosh&&A?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){z.dispose(),ee.dispose(),A()}const z=this.onDidClose(()=>F()),ee=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(F,z,ee)=>this.onWindowError(3,{reason:ee,exitCode:z})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this._config&&(this._config.maximized=!0),w.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this._config&&(this._config.maximized=!1),w.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated(F))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,z)=>{const ee=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,ee)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,F){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,v.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(z.response!==1){const ee=z.response===0;this.destroyWindow(ee,z.checkboxChecked)}}else if(A===2){let z;F?z=(0,d.localize)(7,null,F.reason,F.exitCode??"<unknown>"):z=(0,d.localize)(6,null);const ee=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,v.mnemonicButtonLabel)((0,d.localize)(9,null))],message:z,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),B=ee.response===0;this.destroyWindow(B,ee.checkboxChecked)}break}}async destroyWindow(A,F){const z=this._config?.workspace;if(F&&z)try{const ee=this.storageMainService.workspaceStorage(z);await ee.init(),ee.delete("memento/workbench.parts.editor"),await ee.close()}catch(ee){this.logService.error(ee)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ee,B;(0,W.isSingleFolderWorkspaceIdentifier)(z)?ee={folderUri:z.uri}:(0,W.isWorkspaceIdentifier)(z)?ee={workspaceUri:z.configPath}:B=!0;const[H]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const F=this.getMenuBarVisibility();F!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=F,this.setMenuBarVisibility(F));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const ee=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||ee!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=ee;const B=z||"",H=ee?`${ee},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(A){y.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this._previousWorkspace=this.openedWorkspace,this.updateConfiguration(A,F),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:F.isReload?3:z?2:1})}updateConfiguration(A,F){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const ee=(0,f.isLaunchedFromCli)(z)&&!(0,f.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(ee||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),A.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const F=Object.assign({},this._config);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.isInitialStartup=!1,F.policiesData=this.policyService.serialize(),F.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,W.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,x.defaultWindowState)();if(this.isFullScreen){let z;try{z=w.screen.getDisplayMatching(this.getBounds())}catch{}const ee=(0,x.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||ee.width,height:this.windowState.height||ee.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let F;if(!y.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let z;F===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Dt.windowControlHeightStateStorageKey,A.height),y.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):y.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,I.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const z=w.screen.getAllDisplays();F=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[A||(0,x.defaultWindowState)(),F]}validateWindowState(A,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const B=this.getWorkingArea(F[0]);if(B){let H=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),H(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),H()}return A}if(A.display&&A.mode===3){const B=F.find(H=>H.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,x.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let z,ee;try{z=w.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ee=this.getWorkingArea(z)}catch{}if(z&&ee&&A.x+A.width>ee.x&&A.y+A.height>ee.y&&A.x<ee.x+ee.width&&A.y<ee.y+ee.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ee),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this._win.getPosition(),[z,ee]=this._win.getSize();return{x:A,y:F,width:z,height:ee}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){y.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,F=!0){y.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const F=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,F,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...z)})}send(A,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...F)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!y.isMacintosh||this.touchBarGroups.forEach((F,z)=>{const ee=A[z];F.segments=this.createTouchBarGroupSegments(ee)})}createTouchBar(){if(!!y.isMacintosh){for(let A=0;A<10;A++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const F=this.createTouchBarGroupSegments(A),z=new w.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:ee=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[ee].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let ee;z.icon&&!l.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(ee=w.nativeImage.createFromPath(g.URI.revive(z.icon.dark).fsPath),ee.isEmpty()&&(ee=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:ee?void 0:B,icon:ee}})}dispose(){super.dispose(),this._win=null}};$.windowControlHeightStateStorageKey="windowControlHeight",$=ve([Y(1,r.ILogService),Y(2,S.IEnvironmentMainService),Y(3,le.IPolicyService),Y(4,de.IUserDataProfilesMainService),Y(5,u.IFileService),Y(6,o.IApplicationStorageMainService),Y(7,o.IStorageMainService),Y(8,b.IConfigurationService),Y(9,P.IThemeMainService),Y(10,U.IWorkspacesManagementMainService),Y(11,E.IBackupMainService),Y(12,a.ITelemetryService),Y(13,p.IDialogMainService),Y(14,c.ILifecycleMainService),Y(15,s.IProductService),Y(16,i.IProtocolMainService),Y(17,T.IWindowsMainService),Y(18,ue.IStateMainService)],$),e.CodeWindow=$}),define(J[75],Z([0,1,15,24,8,3,35,2,13,4,16,7,23,176,5,21,6,90,91,27,48]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class it extends v.Disposable{constructor(s,i,n,o){super();this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){const i=[],n=[];for(const o of s)if((0,S.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,S.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(n,o.fileUri)>=0,l=o.fileUri.scheme===h.Schemas.file&&it.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!a&&!l&&(n.push(o),m.isWindows&&o.fileUri.scheme===h.Schemas.file&&w.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>it.MAX_TOTAL_RECENT_ENTRIES&&(i.length=it.MAX_TOTAL_RECENT_ENTRIES),n.length>it.MAX_TOTAL_RECENT_ENTRIES&&(n.length=it.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(s){const i=l=>{const P=this.location(l);for(const M of s)if(C.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),a=n.files.filter(i);(o.length!==n.workspaces.length||a.length!==n.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const s=[],i=[];return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(s,i){const n=await this.getRecentlyOpenedFromStorage();for(const o of n.workspaces){const a=(0,S.isRecentFolder)(o)?this.indexOfFolder(s,o.folderUri):this.indexOfWorkspace(s,o.workspace);a>=0?s[a].label=s[a].label||o.label:s.push(o)}for(const o of n.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let s;const i=this.applicationStorageMainService.get(it.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{s=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,S.restoreRecentlyOpened)(s,this.logService)}async saveRecentlyOpened(s){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(it.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(s)),-1,1)}location(s){return(0,S.isRecentFolder)(s)?s.folderUri:(0,S.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,i){return s.findIndex(n=>(0,S.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(s,i){return s.findIndex(n=>(0,S.isRecentFolder)(n)&&C.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(s,i){return s.findIndex(n=>C.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of w.app.getJumpListSettings().removedItems){const l=a.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&i.push(I.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,S.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(l,a.label);let T;return I.URI.isUri(l)?T=`--folder-uri "${l.toString()}"`:(n=!0,T=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&s.push({type:"custom",name:n?(0,g.localize)(2,null):(0,g.localize)(3,null),items:o})}s.push({type:"recent"});try{const i=w.app.setJumpList(s);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(s,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(I.URI.isUri(s))return{title:(0,C.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,g.localize)(4,null),description:""};let n=(0,C.basename)(s.configPath);return n.endsWith(f.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,n),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,D.normalizeDriveLetter)(s.fsPath):s.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),i=[];let n=0;for(let a=0;a<s.workspaces.length&&n<it.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(s.workspaces[a]);if(l.scheme===h.Schemas.file){const P=(0,C.originalFSPath)(l);await y.Promises.exists(P)&&(i.push(P),n++)}}const o=[];for(let a=0;a<s.files.length&&n<it.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(s.files[a]);if(l.scheme===h.Schemas.file){const P=(0,C.originalFSPath)(l);if(it.COMMON_FILES_FILTER.includes((0,C.basename)(l))||i.includes(P))continue;await y.Promises.exists(P)&&(o.push(P),n++)}}o.reverse().forEach(a=>w.app.addRecentDocument(a)),i.reverse().forEach(a=>w.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([Y(0,b.ILogService),Y(1,u.IWorkspacesManagementMainService),Y(2,E.ILifecycleMainService),Y(3,p.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(J[264],Z([0,1,15,8,22,35,4,7,166,19,26,21,6,210,65,20,41,37,47,74,33,75]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const r="menu";let s=class Rt{constructor(o,a,l,P,M,T,W,U,x,re,le){this.updateService=o,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=W,this.lifecycleMainService=U,this.logService=x,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Rt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,W,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,W,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,W,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Rt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=w.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(D.isMacintosh?new w.Menu:null);return}const a=new w.Menu;let l;if(D.isMacintosh){const M=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new w.Menu;M.append(new w.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new w.Menu;P=new w.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(T)}a.items&&a.items.length>0?w.Menu.setApplicationMenu(a):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new w.Menu;this.setMenuById(ue,"Preferences"),P=new w.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:ue})}const M=new w.Menu,T=new w.MenuItem({label:h.localize(12,null),role:"services",submenu:M}),W=new w.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new w.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new w.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(ue,se,de)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(de)&&this.nativeHostMainService.quit(void 0)}})),le=[a];le.push(...l),P&&le.push(i(),P),le.push(i(),T,i(),W,U,x,i(),re),le.forEach(ue=>o.append(ue))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(h.localize(17,null)),(0,R.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(l=>{if((0,g.isMenubarMenuItemSeparator)(l))o.append(i());else if((0,g.isMenubarMenuItemSubmenu)(l)){const P=new w.Menu,M=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),o.append(M)}else(0,g.isMenubarMenuItemRecentAction)(l)?o.append(this.createOpenRecentMenuItem(l)):(0,g.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?o.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):o.append(this.createMenuItem(l.label,l.id,!1,l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>o.append(l)),o.append(i()))}createOpenRecentMenuItem(o){const a=v.URI.revive(o.uri),l=o.id,P=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new w.MenuItem(this.likeAction(l,{label:o.label,click:(M,T,W)=>{const U=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,l){const P={label:this.mnemonicLabel(o),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(o){const a=new w.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new w.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,i(),M,...T,i(),P].forEach(W=>o.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,l,P){const M=this.mnemonicLabel(o),T=typeof a=="function"?a:(le,ue,se)=>{const de=le?le.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),de&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:de}):this.runActionInRenderer({type:"commandId",commandId:K})},W=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,x={label:M,click:T,enabled:W};U&&(x.type="checkbox",x.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?x.role="cut":re==="editor.action.clipboardCopyAction"?x.role="copy":re==="editor.action.clipboardPasteAction"&&(x.role="paste"),re==="undo"?x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(re,x))}makeContextAwareClickHandler(o,a){return(l,P,M)=>{const T=w.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);o(l,P||T,M)}}runActionInRenderer(o){let a=w.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const P={id:o.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:o.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const l=typeof o=="string"?this.keybindings[o]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,l=!a.accelerator){l&&(a=this.withKeybinding(o,a));const P=a.click;return a.click=(M,T,W)=>{this.reportMenuActionTelemetry(o),P?.(M,T,W)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:r})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=ve([Y(0,S.IUpdateService),Y(1,m.IConfigurationService),Y(2,u.IWindowsMainService),Y(3,C.IEnvironmentMainService),Y(4,p.ITelemetryService),Y(5,c.IWorkspacesHistoryMainService),Y(6,b.IStateMainService),Y(7,I.ILifecycleMainService),Y(8,y.ILogService),Y(9,d.INativeHostMainService),Y(10,E.IProductService)],s),e.Menubar=s;function i(){return new w.MenuItem({type:"separator"})}}),define(J[265],Z([0,1,5,21,6,264]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let D=class{constructor(h,m,C){this.instantiationService=h,this.lifecycleMainService=m,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(h,m){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(m,h)}};D=ve([Y(0,w.IInstantiationService),Y(1,t.ILifecycleMainService),Y(2,k.ILogService)],D),e.MenubarMainService=D}),define(J[266],Z([0,1,15,29,30,24,22,3,31,49,35,2,13,9,71,4,34,16,12,7,174,60,19,56,26,14,5,21,6,53,20,61,63,41,74,263,117,259,27,118,75,48,64,38,42]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P,M,T,W,U,x,re,le,ue,se,de,K,$,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(H){return(0,se.isWorkspaceIdentifier)(H?.workspace)}function ee(H){return(0,se.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class ut extends I.Disposable{constructor(L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le,Me,Ae,Ve,ge,pe){super();this.machineId=L,this.initialUserEnv=O,this.logService=N,this.stateMainService=V,this.policyService=Q,this.environmentMainService=ne,this.userDataProfilesMainService=j,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=ce,this.workspacesHistoryMainService=fe,this.workspacesManagementMainService=ke,this.instantiationService=Le,this.dialogMainService=Me,this.fileService=Ae,this.productService=Ve,this.protocolMainService=ge,this.themeMainService=pe,this._onDidOpenWindow=this._register(new v.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new v.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new v.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new v.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new v.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new I.DisposableStore;if(O.add(v.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const N=this.environmentMainService.args,V=O?.remoteAuthority||void 0,Q=!0,ne=O?.forceReuseWindow,j=!ne;return this.open({...L,cli:N,forceEmpty:Q,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],N=[],V=[],Q=[],ne=[];let j,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const Me of ie)ee(Me)?L.addMode?O.push(Me):N.push(Me):z(Me)?V.push(Me):Me.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),j.filesToOpenOrCreate.push(Me)):Me.backupPath?ne.push({backupFolder:(0,g.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):te++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Q.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...Q),ne.push(...this.backupMainService.getEmptyWindowBackupPaths())):ne.length=0;const{windows:ce,filesOpenedInWindow:fe}=this.doOpen(L,V,N,ne,te,j,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${N.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),ce.length>1)if(fe)fe.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ve=!0;if(Me){const ge=ce.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Ae=!1,Ve=!1)}if(Ae)for(let ge=ce.length-1;ge>=0;ge--){const pe=ce[ge];if(!(pe.openedWorkspace&&Q.some(be=>pe.openedWorkspace&&be.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&ne.some(be=>pe.backupPath&&be.backupFolder===(0,g.basename)(pe.backupPath)))){pe.focus(),Ve=!1;break}}Ve&&ce[ce.length-1].focus()}const ke=j&&j.filesToDiff.length>0,Le=j&&j.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!ke&&!Le&&!L.noRecentEntry){const Me=[];for(const Ae of ie)z(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):ee(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const N=L.waitMarkerFileURI;L.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(L,O,N,V,Q,ne,j){const te=[];let ie;function ce(ge,pe){te.push(ge),pe&&(ie=ge,ne=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const ge=j[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(ge);pe&&ce(this.doAddFoldersToExistingWindow(pe,j.map(be=>be.workspace.uri)))}const Le=N.length+O.length+V.length;if(ne&&Le===0){const ge=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],pe=this.getWindows().filter(X=>ne&&(0,p.isEqualAuthority)(X.remoteAuthority,ne.remoteAuthority));let be;ge?.fileUri&&!ke&&((L.context===4||L.context===0||L.context===1)&&(be=(0,le.findWindowOnFile)(pe,ge.fileUri,X=>X.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),be||(be=this.doGetLastActiveWindow(pe))),be?(0,se.isWorkspaceIdentifier)(be.openedWorkspace)?O.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?N.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,be,ne),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Me=(0,R.distinct)(O,ge=>ge.workspace.id);if(Me.length>0){const ge=(0,R.coalesce)(Me.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ge.length>0){const pe=ge[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,be),!!be),fe=!0}Me.forEach(pe=>{if(ge.some(ae=>ae.openedWorkspace&&ae.openedWorkspace.id===pe.workspace.id))return;const be=pe.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,fe,X),!!X),fe=!0})}const Ae=(0,R.distinct)(N,ge=>p.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Ae.length>0){const ge=(0,R.coalesce)(Ae.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ge.length>0){const pe=ge[0],be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,be),!!be),fe=!0}Ae.forEach(pe=>{if(ge.some(ae=>(0,se.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(ae.openedWorkspace.uri,pe.workspace.uri)))return;const be=pe.remoteAuthority,X=(0,p.isEqualAuthority)(ne?.remoteAuthority,be)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,fe,X),!!X),fe=!0})}const Ve=(0,R.distinct)(V,ge=>ge.backupFolder);if(Ve.length>0&&Ve.forEach(ge=>{const pe=ge.remoteAuthority,be=(0,p.isEqualAuthority)(ne?.remoteAuthority,pe)?ne:void 0;ce(this.doOpenEmpty(L,!0,pe,be,ge),!!be),fe=!0}),te.length===0||ne){ne&&!Q&&Q++;const ge=ne?ne.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<Q;pe++)ce(this.doOpenEmpty(L,fe,ge,ne),!!ne),fe=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const V={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const N={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,N),L}doOpenEmpty(L,O,N,V,Q){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:N,filesToOpen:V,forceNewWindow:O});let ne;return!O&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:Q})}doOpenFolderOrWorkspace(L,O,N,V,Q){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!N&&!Q&&typeof L.contextWindowId=="number"&&(Q=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:Q,userDataProfileInfo:O.userDataProfileInfo})}getPathsToOpen(L){let O,N=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),N=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&N){const Q=O.filter(ne=>ee(ne));if(Q.length>1){const ne=Q[0].remoteAuthority;if(Q.every(j=>(0,p.isEqualAuthority)(j.remoteAuthority,ne))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(Q.map(te=>({uri:te.workspace.uri})));O.push({workspace:j,remoteAuthority:ne}),O=O.filter(te=>!ee(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(Q=>z(Q)||ee(Q)||Q.backupPath)),O}doExtractPathsFromAPI(L){const O=[],N={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const Q=this.resolveOpenable(V,N);if(Q)Q.label=V.label,O.push(Q);else{const ne=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:ne.scheme===y.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:ne.scheme===y.Schemas.file?(0,u.localize)(3,null,(0,C.getPathLabel)(ne,{os:E.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,S.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const j of V){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable({folderUri:te},N);ie&&O.push(ie)}}const Q=L["file-uri"];if(Q)for(const j of Q){const te=this.cliArgToUri(j);if(te){const ie=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(j)?{workspaceUri:te}:{fileUri:te},N);ie&&O.push(ie)}}const ne=L._;for(const j of ne){const te=N.remoteAuthority?this.doResolvePathRemote(j,N):this.doResolveFilePath(j,N);te&&O.push(te)}if(L.profile)for(const j of O)j.userDataProfileInfo={name:L.profile};return O}cliArgToUri(L){try{const O=f.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const V of O)if(V.workspace){const Q=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});z(Q)&&N.push(Q)}else if(V.folderUri){const Q=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});ee(Q)&&N.push(Q)}else L!=="folders"&&V.backupPath&&N.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return N}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const N=this.resourceFromOpenable(L);return N.scheme===y.Schemas.file?((0,x.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let N=this.resourceFromOpenable(L);const V=(0,W.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(N)),(0,x.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Q,line:ne,column:j}=(0,h.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:Q}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:N,remoteAuthority:V}}else if((0,x.isWorkspaceToOpen)(L))return{workspace:(0,de.getWorkspaceIdentifier)(N),remoteAuthority:V};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:V}}resourceFromOpenable(L){return(0,x.isWorkspaceToOpen)(L)?L.workspaceUri:(0,x.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let N,V;O.gotoLineMode&&({path:L,line:N,column:V}=(0,h.parseLineAndColumnAware)(L)),L=(0,h.sanitizeFilePath)((0,g.normalize)(L),(0,b.cwd)());try{const Q=(0,t.statSync)(L);if(Q.isFile()){if(!O.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(f.URI.file(L));if(ne)return ne.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:V||1}:void 0}}}else{if(Q.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),Q),type:n.FileType.Directory,exists:!0};if(!E.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const ne=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),O.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const N=L.charCodeAt(0),V=O.remoteAuthority;let Q,ne;O.gotoLineMode&&({path:L,line:Q,column:ne}=(0,h.parseLineAndColumnAware)(L)),N!==47&&((0,h.isWindowsDriveLetter)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,h.toSlashes)(L)),L=`/${L}`);const j=f.URI.from({scheme:y.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||g.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:Q?{startLineNumber:Q,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let Q=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(Q=N==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(E.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,O){const N=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let V=O.cli["folder-uri"]||[],Q=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!V.length&&!Q.length&&!O.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,fe=ce&&(ce.workspace||ce.folderUri);fe&&(f.URI.isUri(fe)?fe.scheme===y.Schemas.file?ne=[fe.fsPath]:V=[fe.toString()]:fe.configPath.scheme===y.Schemas.file?ne=[(0,p.originalFSPath)(fe.configPath)]:Q=[fe.configPath.toString()])}let j=O.remoteAuthority;for(const ce of L)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const fe=f.URI.parse(ce),ke=(0,W.getRemoteAuthority)(fe);ke&&(j?(0,p.isEqualAuthority)(ke,j)||this.logService.error("more than one extension development path authority"):j=ke)}ne=ne.filter(ce=>{const fe=f.URI.file(ce);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),j)}),V=V.filter(ce=>{const fe=this.cliArgToUri(ce);return fe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),j):!1}),Q=Q.filter(ce=>{const fe=this.cliArgToUri(ce);return fe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),j):!1}),O.cli._=ne,O.cli["folder-uri"]=V,O.cli["file-uri"]=Q;const te=!ne.length&&!V.length&&!Q.length,ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const Q=V.config;!N.extensionDevelopmentPath&&Q&&!!Q.extensionDevelopmentPath&&(N.extensionDevelopmentPath=Q.extensionDevelopmentPath,N.extensionDevelopmentKind=Q.extensionDevelopmentKind,N["enable-proposed-api"]=Q["enable-proposed-api"],N.verbose=Q.verbose,N["inspect-extensions"]=Q["inspect-extensions"],N["inspect-brk-extensions"]=Q["inspect-brk-extensions"],N.debugId=Q.debugId,N.extensionEnvironment=Q.extensionEnvironment,N["extensions-dir"]=Q["extensions-dir"],N["disable-extensions"]=Q["disable-extensions"])}else{const Q=this.windowsStateHandler.getNewWindowState(N);(0,d.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:Q,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),ut.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,m.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,m.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const j=(0,S.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return N.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(Q=>{Q||this.doOpenInBrowserWindow(V,N,L)}):this.doOpenInBrowserWindow(V,N,L),V}resolveProfileForBrowserWindow(L){let O;return L.userDataProfileInfo&&(O=this.userDataProfilesMainService.profiles.find(N=>N.name===L.userDataProfileInfo.name),O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O)),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}doOpenInBrowserWindow(L,O,N){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}L.load(O)}onWindowClosed(L){const O=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=w.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(N=>N.lastFocusTime));return L.find(N=>N.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,N){for(const V of this.getWindows())N&&N.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(N=>N.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=w.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([Y(2,l.ILogService),Y(3,U.IStateMainService),Y(4,A.IPolicyService),Y(5,i.IEnvironmentMainService),Y(6,F.IUserDataProfilesMainService),Y(7,a.ILifecycleMainService),Y(8,c.IBackupMainService),Y(9,r.IConfigurationService),Y(10,K.IWorkspacesHistoryMainService),Y(11,$.IWorkspacesManagementMainService),Y(12,o.IInstantiationService),Y(13,s.IDialogMainService),Y(14,n.IFileService),Y(15,M.IProductService),Y(16,T.IProtocolMainService),Y(17,_.IThemeMainService)],B),e.WindowsMainService=B}),define(J[267],Z([0,1,60,33,75,48]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,m,C,I){this.workspacesManagementMainService=h,this.windowsMainService=m,this.workspacesHistoryMainService=C,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,m){const C=this.windowsMainService.getWindowById(h);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(h,m,C){return this.workspacesManagementMainService.createUntitledWorkspace(m,C)}deleteUntitledWorkspace(h,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(h,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(h,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([Y(0,R.IWorkspacesManagementMainService),Y(1,t.IWindowsMainService),Y(2,k.IWorkspacesHistoryMainService),Y(3,w.IBackupMainService)],D),e.WorkspacesMainService=D}),define(J[268],Z([0,1,15,40,29,30,17,44,18,31,49,43,35,2,13,9,4,12,7,28,81,133,45,147,99,245,150,60,250,19,69,183,84,119,56,103,181,26,59,111,193,213,194,247,104,195,196,14,206,86,68,5,85,260,224,120,21,6,208,265,65,20,63,254,87,41,251,90,112,37,229,231,73,47,236,237,261,238,262,114,240,241,242,243,248,33,266,249,27,91,75,267,48,246,38,212,42,257,220,54,72,89,252,258]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P,M,T,W,U,x,re,le,ue,se,de,K,$,_,A,F,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le,Me,Ae,Ve,ge,pe,be,X,ae,he,ye,Ce,Te,Oe,Be,ze,_e,He,G,oe,me,Se,we,Ie,Fe,$e,Ke,Qe,Ye,et,ot,at,Ot,Ft,Wt,Et,_t,Ut,Nt,Lt,Bt,zt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends g.Disposable{constructor(Ee,De,Re,Pe,We,Ge,qe,je,Ne,Ue,xe){super();this.mainProcessNodeIpcServer=Ee,this.userEnv=De,this.mainInstantiationService=Re,this.logService=Pe,this.environmentMainService=We,this.lifecycleMainService=Ge,this.configurationService=qe,this.stateMainService=je,this.fileService=Ne,this.productService=Ue,this.userDataProfilesMainService=xe,this.configureSession(),this.registerListeners()}configureSession(){const Ee=Ne=>Ne?.startsWith(`${d.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ne,Ue,xe,Je)=>Ee(Je.requestingUrl)?xe(De.has(Ue)):xe(!1)),w.session.defaultSession.setPermissionCheckHandler((Ne,Ue,xe,Je)=>Ee(Je.requestingUrl)?De.has(Ue):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Pe=Ne=>{for(let Ue=Ne;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},We=Ne=>Ne.resourceType==="xhr"||Pe(Ne.frame),Ge=Ne=>{const Ue=Ne.frame;if(!Ue||!this.windowsMainService)return!1;const xe=w.BrowserWindow.getAllWindows();for(const Je of xe)if(Ue.processId===Je.webContents.mainFrame.processId)return!0;return!1},qe=(Ne,Ue)=>{if(Ne.path!=="/index.html")return!0;const xe=Ue.frame;if(!xe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ne,Ue)=>{const xe=S.URI.parse(Ne.url);return xe.scheme===d.Schemas.vscodeWebview&&!qe(xe,Ne)?(this.logService.error("Blocked vscode-webview request",Ne.url),Ue({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!Ge(Ne)?(this.logService.error("Blocked vscode-file request",Ne.url),Ue({cancel:!0})):xe.path.endsWith(".svg")&&!Re.has(xe.scheme)?Ue({cancel:!We(Ne)}):Ue({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ne,Ue)=>{const xe=Ne.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const rt=S.URI.parse(Ne.url);if(rt.path.endsWith(".svg")&&Re.has(rt.scheme))return xe["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:xe});if(!rt.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ht=>ht.toLowerCase().includes("image/svg")))return Ue({cancel:!We(Ne)})}return Ue({cancel:!1})});const je=w.session.defaultSession;typeof je.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&je.setCodeCachePath((0,E.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,h.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,h.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Re,Pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),w.app.on("activate",(Re,Pe)=>{this.logService.trace("app#activate"),Pe||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Re,Pe)=>{Pe.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Pe.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let Ee=[],De;w.app.on("open-file",(Re,Pe)=>{this.logService.trace("app#open-file: ",Pe),Re.preventDefault(),Ee.push(this.getWindowOpenableFromPathSync(Pe)),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],De=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Pe=this.windowsMainService?.getWindowByWebContents(Re.sender);let We,Ge;return Pe?.config?(We=Pe.config,Ge={...process.env,...Pe.config.userEnv}):(We=this.environmentMainService.args,Ge=process.env),this.resolveShellEnvironment(We,Ge,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Pe,We)=>{const Ge=this.validateNlsPath([Pe]);if(!Ge||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ge,D.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Pe)=>{const We=this.validateNlsPath(Pe);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(Ee){let De;for(const Re of Ee)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,E.join)(De,Re));if(!(typeof De!="string"||!(0,E.isAbsolute)(De)||!(0,m.isEqualOrParent)(De,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return S.URI.file(De)}onUnexpectedError(Ee){if(Ee){const De={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.logService.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.logService.error(Ee.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ee=this.productService.win32AppUserModelId;b.isWindows&&Ee&&w.app.setAppUserModelId(Ee);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.logService.error(Ue)}const De=new s.Server;this.lifecycleMainService.onWillShutdown(Ue=>{Ue.reason===2&&De.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Pe,sharedProcessReady:We,sharedProcessClient:Ge}=this.setupSharedProcess(Re),qe=await this.initServices(Re,Pe,We);this.setUpHandlers(qe);const je=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);je&&await je,qe.invokeFunction(Ue=>this.initChannels(Ue,De,Ge));const Ne=qe.invokeFunction(Ue=>this.openFirstWindow(Ue,De));qe.invokeFunction(Ue=>this.afterWindowOpen(Ue,Pe)),this.environmentMainService.args.trace&&qe.invokeFunction(Ue=>this.stopTracingEventually(Ue,Ne))}setUpHandlers(Ee){this._register(Ee.createInstance(n.ProxyAuthHandler)),this._register(Ee.createInstance(_t.DefaultExtensionsProfileInitHandler)),this._register(Ee.createInstance($t.UserDataTransientProfilesHandler))}async resolveMachineId(){let Ee=this.stateMainService.getItem(ae.machineIdKey);return(!Ee||b.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,u.getMachineId)(),this.stateMainService.setItem(ae.machineIdKey,Ee)),Ee}setupSharedProcess(Ee){const De=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,Ee,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await De.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(We,"main")})(),Pe=(async()=>(await De.whenReady(),Re))();return{sharedProcess:De,sharedProcessReady:Pe,sharedProcessClient:Re}}async initServices(Ee,De,Re){const Pe=new V.ServiceCollection;switch(process.platform){case"win32":Pe.set(Te.IUpdateService,new O.SyncDescriptor(He.Win32UpdateService));break;case"linux":b.isLinuxSnap?Pe.set(Te.IUpdateService,new O.SyncDescriptor(_e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(Te.IUpdateService,new O.SyncDescriptor(ze.LinuxUpdateService));break;case"darwin":Pe.set(Te.IUpdateService,new O.SyncDescriptor(Be.DarwinUpdateService));break}Pe.set(Fe.IWindowsMainService,new O.SyncDescriptor($e.WindowsMainService,[Ee,this.userEnv])),Pe.set(x.IDialogMainService,new O.SyncDescriptor(x.DialogMainService)),Pe.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),Pe.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Pe.set(W.IDiagnosticsService,r.ProxyChannel.toService((0,r.getDelayedChannel)(Re.then(Ge=>Ge.getChannel("diagnostics"))))),Pe.set(Q.IIssueMainService,new O.SyncDescriptor(Q.IssueMainService,[this.userEnv])),Pe.set(re.IEncryptionMainService,new O.SyncDescriptor(le.EncryptionMainService,[Ee])),Pe.set(ne.IKeyboardLayoutMainService,new O.SyncDescriptor(ne.KeyboardLayoutMainService)),Pe.set(ke.INativeHostMainService,new O.SyncDescriptor(ke.NativeHostMainService,[De])),Pe.set(M.ICredentialsMainService,new O.SyncDescriptor(Ot.CredentialsNativeMainService)),Pe.set(we.IWebviewManagerService,new O.SyncDescriptor(Ie.WebviewMainService)),Pe.set(Ye.IWorkspacesService,new O.SyncDescriptor(ot.WorkspacesMainService)),Pe.set(at.IWorkspacesManagementMainService,new O.SyncDescriptor(at.WorkspacesManagementMainService)),Pe.set(et.IWorkspacesHistoryMainService,new O.SyncDescriptor(et.WorkspacesHistoryMainService)),Pe.set(fe.IMenubarMainService,new O.SyncDescriptor(fe.MenubarMainService)),Pe.set(K.IExtensionUrlTrustService,new O.SyncDescriptor($.ExtensionUrlTrustService)),Pe.set(_.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Pe.set(be.IStorageMainService,new O.SyncDescriptor(be.StorageMainService)),Pe.set(be.IApplicationStorageMainService,new O.SyncDescriptor(be.ApplicationStorageMainService)),b.isWindows?Pe.set(F.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):b.isMacintosh?Pe.set(F.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):b.isLinux&&Pe.set(F.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const We=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Pe.set(a.IBackupMainService,We),Pe.set(G.IURLService,new O.SyncDescriptor(me.NativeURLService)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const Ge=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),qe=(0,r.getDelayedChannel)(Re.then(Je=>Je.getChannel("telemetryAppender"))),je=new he.TelemetryAppenderClient(qe),Ne=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,Ee,Ge,this.environmentMainService.installSourcePath),Ue=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),xe={appenders:[je],commonProperties:Ne,piiPaths:Ue,sendErrorTelemetry:!0};Pe.set(ae.ITelemetryService,new O.SyncDescriptor(ye.TelemetryService,[xe]))}else Pe.set(ae.ITelemetryService,Ce.NullTelemetryService);return Pe.set(Lt.IExtensionsProfileScannerService,new O.SyncDescriptor(Lt.ExtensionsProfileScannerService)),Pe.set(Bt.IExtensionsScannerService,new O.SyncDescriptor(zt.ExtensionsScannerService)),await We.initialize(),this.mainInstantiationService.createChild(Pe)}initChannels(Ee,De,Re){const Pe=r.ProxyChannel.fromService(Ee.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const We=r.ProxyChannel.fromService(Ee.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const Ge=new Wt.PolicyChannel(Ee.get(Ft.IPolicyService));De.registerChannel("policy",Ge),Re.then(tt=>tt.registerChannel("policy",Ge));const qe=this.fileService.getProvider(d.Schemas.file);(0,p.assertType)(qe instanceof L.DiskFileSystemProvider);const je=new H.DiskFileSystemProviderChannel(qe,this.logService,this.environmentMainService);De.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,je),Re.then(tt=>tt.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,je));const Ne=r.ProxyChannel.fromService(Ee.get(Et.IUserDataProfilesMainService));De.registerChannel("userDataProfiles",Ne),Re.then(tt=>tt.registerChannel("userDataProfiles",Ne));const Ue=new Ut.RequestChannel(Ee.get(Nt.IRequestService));Re.then(tt=>tt.registerChannel("request",Ue));const xe=new Oe.UpdateChannel(Ee.get(Te.IUpdateService));De.registerChannel("update",xe);const Je=r.ProxyChannel.fromService(Ee.get(Q.IIssueMainService));De.registerChannel("issue",Je);const rt=r.ProxyChannel.fromService(Ee.get(re.IEncryptionMainService));De.registerChannel("encryption",rt);const ht=r.ProxyChannel.fromService(Ee.get(M.ICredentialsMainService));De.registerChannel("credentials",ht);const It=r.ProxyChannel.fromService(Ee.get(Ve.ISignService));De.registerChannel("sign",It);const Ze=r.ProxyChannel.fromService(Ee.get(ne.IKeyboardLayoutMainService));De.registerChannel("keyboardLayout",Ze),this.nativeHostMainService=Ee.get(ke.INativeHostMainService);const dt=r.ProxyChannel.fromService(this.nativeHostMainService);De.registerChannel("nativeHost",dt),Re.then(tt=>tt.registerChannel("nativeHost",dt));const ft=r.ProxyChannel.fromService(Ee.get(Ye.IWorkspacesService));De.registerChannel("workspaces",ft);const gt=r.ProxyChannel.fromService(Ee.get(fe.IMenubarMainService));De.registerChannel("menubar",gt);const wt=r.ProxyChannel.fromService(Ee.get(G.IURLService));De.registerChannel("url",wt);const vt=r.ProxyChannel.fromService(Ee.get(K.IExtensionUrlTrustService));De.registerChannel("extensionUrlTrust",vt);const mt=r.ProxyChannel.fromService(Ee.get(we.IWebviewManagerService));De.registerChannel("webview",mt);const ct=this._register(new pe.StorageDatabaseChannel(this.logService,Ee.get(be.IStorageMainService)));De.registerChannel("storage",ct),Re.then(tt=>tt.registerChannel("storage",ct));const St=r.ProxyChannel.fromService(Ee.get(F.IExternalTerminalMainService));De.registerChannel("externalTerminal",St);const Xe=new ce.LogLevelChannel(Ee.get(ie.ILogService));De.registerChannel("logLevel",Xe),Re.then(tt=>tt.registerChannel("logLevel",Xe));const nt=new ce.LoggerChannel(Ee.get(ie.ILoggerService));De.registerChannel("logger",nt),Re.then(tt=>tt.registerChannel("logger",nt));const st=new T.ElectronExtensionHostDebugBroadcastChannel(Ee.get(Fe.IWindowsMainService),Ee.get(Et.IUserDataProfilesMainService));De.registerChannel("extensionhostdebugservice",st);const pt=r.ProxyChannel.fromService(Ee.get(_.IExtensionHostStarter));De.registerChannel(_.ipcExtensionHostStarterChannelName,pt)}openFirstWindow(Ee,De){const Re=this.windowsMainService=Ee.get(Fe.IWindowsMainService),Pe=Ee.get(G.IURLService),We=Ee.get(ke.INativeHostMainService);this.lifecycleMainService.phase=2;const Ge=[],qe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Xe=>{try{return{uri:S.URI.parse(Xe),url:Xe}}catch{return}}).filter(Xe=>{if(!Xe||this.shouldBlockURI(Xe.uri))return!1;const nt=this.getWindowOpenableFromProtocolLink(Xe.uri);return nt?(Ge.push(nt),!1):!0}),je=this,Ne=this.environmentMainService,Ue=this.productService,xe=this.logService;Pe.registerHandler({async handleURL(Xe,nt){if(xe.trace("app#handleURL: ",Xe.toString(!0),nt),Xe.scheme===Ue.urlProtocol&&Xe.path==="workspace"&&(Xe=Xe.with({authority:"file",path:S.URI.parse(Xe.query).path,query:""})),je.shouldBlockURI(Xe))return!0;let st=!1;const pt=new URLSearchParams(Xe.query);pt.get("windowId")==="_blank"&&(pt.delete("windowId"),Xe=Xe.with({query:pt.toString()}),st=!0),st||(st=b.isMacintosh&&Re.getWindowCount()===0);const tt=je.getWindowOpenableFromProtocolLink(Xe);if(xe.trace("app#handleURL: windowOpenableFromProtocolLink = ",tt),tt){const[Pt]=Re.open({context:5,cli:{...Ne.args},urisToOpen:[tt],forceNewWindow:st,gotoLineMode:!0});return Pt.focus(),!0}if(st){const[Pt]=Re.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Me.getRemoteAuthority)(Xe)});return await Pt.ready(),Pe.open(Xe,nt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),rt=new r.StaticRouter(Xe=>Je.getActiveClientId().then(nt=>Xe===nt)),ht=new oe.URLHandlerRouter(rt),It=De.getChannel("urlHandler",ht);Pe.registerHandler(new oe.URLHandlerChannelClient(It)),this._register(new Se.ElectronURLListener(qe,Pe,Re,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,dt=global.macOpenFiles,ft=(0,se.isLaunchedFromCli)(process.env)?0:4,gt=Ze._.length,wt=!!Ze["folder-uri"],vt=!!Ze["file-uri"],mt=Ze["skip-add-to-recently-opened"]===!0,ct=Ze.wait&&Ze.waitMarkerFilePath?S.URI.file(Ze.waitMarkerFilePath):void 0,St=Ze.remote||void 0;return Ge.length>0?Re.open({context:ft,cli:Ze,urisToOpen:Ge,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!gt&&!wt&&!vt?Re.open({context:ft,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:St}):dt.length&&!gt&&!wt&&!vt?Re.open({context:1,cli:Ze,urisToOpen:dt.map(Xe=>this.getWindowOpenableFromPathSync(Xe)),noRecentEntry:mt,waitMarkerFileURI:ct,initialStartup:!0}):Re.open({context:ft,cli:Ze,forceNewWindow:Ze["new-window"]||!gt&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:mt,waitMarkerFileURI:ct,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(Ee){return!!(Ee.authority===d.Schemas.file&&b.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,y.getPathLabel)(Ee,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(Ee){if(!!Ee.path){if(Ee.authority===d.Schemas.file){const De=S.URI.file(Ee.fsPath);return(0,Qe.hasWorkspaceFileExtension)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ee.authority===d.Schemas.vscodeRemote){const De=Ee.path.indexOf(E.posix.sep,1);if(De!==-1){const Re=Ee.path.substring(1,De),Pe=Ee.path.substring(De),We=S.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Pe,query:Ee.query,fragment:Ee.fragment});return(0,Qe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:We}:/:[\d]+$/.test(Pe)?{fileUri:We}:{folderUri:We}}}}}getWindowOpenableFromPathSync(Ee){try{if((0,k.statSync)(Ee).isDirectory())return{folderUri:S.URI.file(Ee)};if((0,Qe.hasWorkspaceFileExtension)(Ee))return{workspaceUri:S.URI.file(Ee)}}catch{}return{fileUri:S.URI.file(Ee)}}async afterWindowOpen(Ee,De){this.lifecycleMainService.phase=3;let Re=!1;(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0);const Pe=Ee.get(ae.ITelemetryService);this._register(De.onDidError(({type:qe,details:je})=>{let Ne;switch(qe){case 1:Ne="SharedProcess: detected unresponsive window";break;case 2:Ne=`SharedProcess: crashed (detail: ${je?.reason??"<unknown>"}, code: ${je?.exitCode??"<unknown>"})`;break;case 3:Ne=`SharedProcess: failed to load (detail: ${je?.reason??"<unknown>"}, code: ${je?.exitCode??"<unknown>"})`;break}(0,h.onUnexpectedError)(new Error(Ne)),Pe.publicLog2("sharedprocesserror",{type:qe,reason:je?.reason,code:je?.exitCode,visible:De.isVisible(),shuttingdown:Re})}));const We=this.productService.win32MutexName;if(b.isWindows&&We)try{const qe=q.__$__nodeRequire("windows-mutex").Mutex,je=new qe(We);(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>je.release())}catch(qe){this.logService.error(qe)}w.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(qe,je)=>{je({url:qe.url.replace(/^vscode-remote-resource:/,"http:"),method:qe.method})});const Ge=Ee.get(Te.IUpdateService);(Ge instanceof He.Win32UpdateService||Ge instanceof ze.LinuxUpdateService||Ge instanceof Be.DarwinUpdateService)&&await Ge.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const je=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,I.stripComments)(je))["enable-crash-reporter"]===void 0){const xe=(0,Ce.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${xe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],rt=je.substring(0,je.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(rt))}}catch(qe){this.logService.error(qe)}}async resolveShellEnvironment(Ee,De,Re){try{return await(0,de.getResolvedShellEnv)(this.logService,Ee,De)}catch(Pe){const We=(0,v.toErrorMessage)(Pe);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}stopTracingEventually(Ee,De){this.logService.info("Tracing: waiting for windows to get ready...");const Re=Ee.get(x.IDialogMainService);let Pe=!1;const We=async qe=>{if(Pe)return;Pe=!0;const je=await w.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);qe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${je}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,je),buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},Ge=setTimeout(()=>We(!0),3e4);Promise.all(De.map(qe=>qe.ready())).then(()=>{clearTimeout(Ge),We(!1)})}};Ct=ve([Y(2,N.IInstantiationService),Y(3,ie.ILogService),Y(4,ue.IEnvironmentMainService),Y(5,te.ILifecycleMainService),Y(6,P.IConfigurationService),Y(7,ge.IStateMainService),Y(8,B.IFileService),Y(9,Le.IProductService),Y(10,Et.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(J[269],Z([0,1,38,8,277,2]),function(q,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends w.AbstractPolicyService{constructor(h){super();this.productName=h,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((m,C)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,h,I=>{for(const y in I){const g=I[y];g===void 0?this.policies.delete(y):this.policies.set(y,g)}this._onDidChange.fire(Object.keys(I)),m()})}catch(I){C(I)}}))}}e.NativePolicyService=D}),define(J[270],Z([0,1,222,8,17,18,2,12,19,36,111,6,221,278]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(b,p,S){super();this.environmentService=p,this.logService=S,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:S,strictSSL:f}=this;let u;try{u=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const c={...process.env,...u},r=b.agent?b.agent:await(0,y.getProxyAgent)(b.url||"",c,{proxyUrl:S,strictSSL:f});b.agent=r,b.strictSSL=f,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",b.url,s),s}}async getNodeRequest(b){return((0,w.parse)(b.url).protocol==="https:"?await new Promise((f,u)=>{q(["https"],f,u)}):await new Promise((f,u)=>{q(["http"],f,u)})).request}_request(b,p){return t.Promises.withAsyncBody(async(S,f)=>{const u=(0,w.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),r={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,v.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(r.auth=b.user+":"+b.password);const s=c(r,i=>{const n=(0,v.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...b,url:i.headers.location,followRedirects:n-1},p).then(S,f);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),S({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});s.on("error",f),b.timeout&&s.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),p.onCancellationRequested(()=>{s.abort(),f(new R.CancellationError)})})}async resolveProxy(b){}};d=ve([Y(0,h.IConfigurationService),Y(1,m.INativeEnvironmentService),Y(2,I.ILogService)],d),e.RequestService=d}),define(J[271],Z([0,1,15,270]),function(q,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return w.net.request}class R extends t.RequestService{request(v,h){return super.request({...v||{},getRawRequest:k},h)}}e.RequestMainService=R}),define(J[279],Z([0,1,15,29,7,24,8,44,18,31,49,35,13,9,71,4,34,25,23,45,83,268,10,19,216,228,26,59,185,14,204,86,68,201,85,21,106,6,209,107,53,20,61,253,113,234,54,271,87,223,41,227,73,64,42,38,269,211,2,55,239,39,235]),function(q,e,w,t,k,R,D,v,h,m,C,I,y,g,d,E,b,p,S,f,u,c,r,s,i,n,o,a,l,P,M,T,W,U,x,re,le,ue,se,de,K,$,_,A,F,z,ee,B,H,L,O,N,V,Q,ne,j,te,ie,ce,fe,ke,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Me{main(){try{this.startup()}catch(ge){console.error(ge.message),w.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ge,pe,be,X,ae,he,ye,Ce]=this.createServices();try{try{await this.initServices(be,Ce,X,ae,ye)}catch(Te){throw this.handleStartupDataDirError(be,ye.nameLong,Te),Te}await ge.invokeFunction(async Te=>{const Oe=Te.get(ue.ILogService),Be=Te.get(re.ILifecycleMainService),ze=Te.get(P.IFileService),_e=await this.claimInstance(Oe,be,Be,ge,ye,!0);return S.Promises.writeFile(be.mainLockfile,String(process.pid)).catch(He=>{Oe.warn(`Error writing main lockfile: ${He.stack}`)}),he.logger=new de.SpdLogLogger("main",(0,g.join)(be.logsPath,"main.log"),!0,!1,he.getLevel()),(0,C.once)(Be.onWillShutdown)(He=>{ze.dispose(),X.dispose(),He.join(S.Promises.unlink(be.mainLockfile).catch(()=>{}))}),ge.createInstance(c.CodeApplication,_e,pe).startup()})}catch(Te){ge.invokeFunction(this.quit,Te)}}createServices(){const ge=new x.ServiceCollection,pe=new ce.DisposableStore;process.once("exit",()=>pe.dispose());const be={_serviceBrand:void 0,...K.default};ge.set($.IProductService,be);const X=new o.EnvironmentMainService(this.resolveArgs(),be),ae=this.patchEnvironment(X);ge.set(o.IEnvironmentMainService,X);const he=new le.BufferLogService,ye=pe.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),he]));ge.set(ue.ILogService,ye);const Ce=new M.FileService(ye);ge.set(P.IFileService,Ce);const Te=new T.DiskFileSystemProvider(ye);Ce.registerProvider(y.Schemas.file,Te);const Oe=new ke.UriIdentityService(Ce);ge.set(fe.IUriIdentityService,Oe),ge.set(ue.ILoggerService,new se.LoggerService(ye,Ce));const Be=new N.StateMainService(X,ye,Ce);ge.set(O.IStateMainService,Be);const ze=new ne.UserDataProfilesMainService(Be,Oe,X,Ce,ye);ge.set(ne.IUserDataProfilesMainService,ze);const _e=E.isWindows&&be.win32RegValueName?pe.add(new te.NativePolicyService(be.win32RegValueName)):X.policyFile?pe.add(new ie.FilePolicyService(X.policyFile,Ce,ye)):new j.NullPolicyService;ge.set(j.IPolicyService,_e);const He=new i.ConfigurationService(ze.defaultProfile.settingsResource,Ce,_e,ye);return ge.set(s.IConfigurationService,He),ge.set(re.ILifecycleMainService,new W.SyncDescriptor(re.LifecycleMainService)),ge.set(ee.IRequestService,new W.SyncDescriptor(B.RequestMainService)),ge.set(Q.IThemeMainService,new W.SyncDescriptor(Q.ThemeMainService)),ge.set(H.ISignService,new W.SyncDescriptor(L.SignService)),ge.set(F.ITunnelService,new W.SyncDescriptor(z.TunnelService)),ge.set(_.IProtocolMainService,new W.SyncDescriptor(A.ProtocolMainService)),[new U.InstantiationService(ge,!0),ae,X,He,Be,he,be,ze]}patchEnvironment(ge){const pe={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(be=>{const X=process.env[be];typeof X=="string"&&(pe[be]=X)}),Object.assign(process.env,pe),pe}async initServices(ge,pe,be,X,ae){await D.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(he=>he?S.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),be.initialize()]),pe.setEnablement(ae.quality!=="stable"||be.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ge,pe,be,X,ae,he){let ye;try{(0,d.mark)("code/willStartMainServer"),ye=await(0,u.serve)(pe.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,C.once)(be.onWillShutdown)(()=>ye.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,ae.nameLong,Ce),Ce;let Te;try{Te=await(0,u.connect)(pe.mainIPCHandle,"main")}catch(_e){if(!he||E.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,r.localize)(0,null,ae.nameShort),(0,r.localize)(1,null),ae.nameLong),_e;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(He){throw ge.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(ge,pe,be,X,ae,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ge.error(_e),Te.dispose(),new Error(_e)}let Oe;!pe.args.wait&&!pe.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,r.localize)(2,null,ae.nameShort),(0,r.localize)(3,null),ae.nameLong)},1e4));const Be=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return X.invokeFunction(async()=>{const _e=new n.DiagnosticsService(V.NullTelemetryService,ae),He=await Be.getMainProcessInfo(),G=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),oe=await _e.getDiagnostics(He,G);throw console.log(oe),new h.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Be,ge),ge.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new h.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ge.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ge,pe,be){if(be.code==="EACCES"||be.code==="EPERM"){const X=(0,R.coalesce)([ge.userDataPath,ge.extensionsPath,u.XDG_RUNTIME_DIR]).map(ae=>(0,I.getPathLabel)(k.URI.file(ae),{os:E.OS,tildify:ge}));this.showStartupWarningDialog((0,r.localize)(4,null),(0,r.localize)(5,null,(0,v.toErrorMessage)(be),X.join(`
`)),pe)}}showStartupWarningDialog(ge,pe,be){w.dialog.showMessageBoxSync({title:be,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,r.localize)(6,null))],message:ge,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ge,pe){if(E.isWindows){const be=await ge.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",be);try{(await new Promise((X,ae)=>{q(["windows-foreground-love"],X,ae)})).allowSetForegroundWindow(be)}catch(X){pe.error(X)}}}quit(ge,pe){const be=ge.get(ue.ILogService),X=ge.get(re.ILifecycleMainService);let ae=0;pe&&(pe.isExpected?pe.message&&be.trace(pe.message):(ae=1,pe.stack?be.error(pe.stack):be.error(`Startup error: ${pe.toString()}`))),X.kill(ae)}resolveArgs(){const ge=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const pe=(0,l.createWaitMarkerFile)(ge.verbose);pe&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",pe),ge.waitMarkerFilePath=pe)}return ge}validatePaths(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const pe=this.doValidatePaths(ge._,ge.goto);ge._=pe}return ge}doValidatePaths(ge,pe){const be=(0,b.cwd)(),X=ge.map(ye=>{let Ce=String(ye),Te;pe&&(Te=(0,m.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(be,Ce));const Oe=(0,m.sanitizeFilePath)(Ce,be),Be=(0,g.basename)(Oe);return Be&&!(0,m.isValidBasename)(Be)?null:pe&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),ae=E.isWindows||E.isMacintosh,he=(0,R.distinct)(X,ye=>ye&&ae?ye.toLowerCase():ye||"");return(0,R.coalesce)(he)}preparePath(ge,pe){return E.isWindows&&(pe=(0,p.rtrim)(pe,'"')),pe=(0,p.trim)((0,p.trim)(pe," "),"	"),E.isWindows&&(pe=(0,g.resolve)(ge,pe),pe=(0,p.rtrim)(pe,".")),pe}toPath(ge){const pe=[ge.path];return typeof ge.line=="number"&&pe.push(String(ge.line)),typeof ge.column=="number"&&pe.push(String(ge.column)),pe.join(":")}}new Me().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cea9d1a4b17966719d8c5f3cdd914480f7cec47c/core/vs/code/electron-main/main.js.map
